## Changelog

### Tomcat 9.0.31 (markt)

#### Catalina

- Do not store username and password as session notes during authentication if they are not needed. (kkolinko)
- Avoid useless environment restore when not using GSSCredential in JNDIRealm. (remm)
- 58577: Respect the argument-count when searching for MBean operations to invoke via the JMXProxyServlet. (schultz)
- 63691: Skip all jar and directory scanning when the wildcard pattern "*" or "*.jar" is set or added to `tomcat.util.scan.StandardJarScanFilter.jarsToSkip`. (isapir)
- 64005: Correct a regression in the static resource caching changes introduced in 9.0.28. Avoid a `NullPointerException` when working with the URL provided for the root of a packed WAR. (markt)
- 64006: Provide default configuration source based on the current directory if none has been set, for full compatibility with existing code. (remm)
- 64008: Clarify/expand the Javadoc for the `Tomcat#addWebapp()` and related methods. (markt)
- Deprecate the `JmxRemoteLifecycleListener` as the features it provides are now available in the remote JMX capability included with the JRE. This listener will be removed in Tomcat 10 and may be removed from Tomcat 9.0.x some time after 2020-12-31. (markt)
- 64011: `JNDIRealm` no longer authenticates to LDAP. (michaelo)
- 64021: Ensure that container provided SCIs are always loaded before application provided SCIs. Note that where both the container and the application provide the same SCI, it is the application provided SCI that will be used. (markt)
- SCI definitions from JARs unpacked into `WEB-INF/classes` are now handled consistently and will always be found irrespective of whether the web application defines a JAR ordering or not. (markt)
- 64023: Skip null-valued session attributes when deserializing sessions. (schultz)
- Do not throw a NullPointerException when an MBean or operation cannot be found by the JMXProxyServlet. (schultz)
- 64067: Allow more than one parameter when defining RewriteMaps. (fschumacher)
- 64074: `InputStream`s for directories obtained from resource URLs now return a directory listing consistent with the behaviour of `FileURLConnection`. In addition to restoring the behaviour that was lost as a result of the introduction of `CachedResourceURLConnection`, it expands the feature to include packedWARs and to take account of resource JARs. (markt)
- Refactor recycle facade system property into a new connector attribute named `discardFacades`. (remm)
- 64089: Add `${...}` property replacement support to XML external entity definitions. (markt)
- Deprecate `MappingData.contextPath` as it is unused. (markt)
- Fix a problem that meant that remote host, address and port information could be missing in the access log for an HTTP/2 request where the connection was closed unexpectely.
- Improve validation of storage location when using FileStore. (markt)
- Make the non-blocking I/O error handling more robust by handling the case where the application code swallows an `IOException` in `WriteListener.onWritePossible()` and `ReadListener.onDataAvailable()`. (markt)
- Improve handling of failures within `recycle()` methods. (markt)
- 66471: Fix JSessionId secure attribute missing When `RemoteIpFilter` determines that this request was submitted via a secure channel. (lihan)

#### Coyote

- Simplify NIO blocking read and write. (remm)
- Ensure that Servlet Asynchronous processing timeouts fire when requests are made using HTTP/2. (markt)
- Fix the corrupton of the TLS configuration when using the deprecated TLS attributes on the Connector if the configuration has already been set via the new `SSLHostConfig` and `SSLHostConfigCertificate` elements. (markt)
- 63966: Switch the message shown when using HTTP to connect to an HTTPS port from ISO-8859-1 to UTF-8. (markt)
- 64007: Cancel selection key in poller before wrapper close to avoid possible deadlock. (remm)
- Add support for RFC 5915 formatted, unencrypted EC key files when using a JSSE based TLS connector. (markt)
- Correct a regression introduced in 9.0.28 that meant invalid tokens in the `Transfer-Encoding` header were ignored rather than treated as an error. (markt)
- Rename the HTTP Connector attribute `rejectIllegalHeaderName` to `rejectIllegalHeader` and expand the underlying implementation to include header values as well as names. (markt)
- Disable (comment out in server.xml) the AJP/1.3 connector by default. (markt)
- Change the default bind address for the AJP/1.3 connector to be the loopback address. (markt)
- Rename the `requiredSecret` attribute of the AJP/1.3 Connector to `secret` and add a new attribute `secretRequired` that defaults to `true`. When `secretRequired` is `true` the AJP/1.3 Connector will not start unless the `secret` attribute is configured to a non-null, non-zero length String. (markt)
- Add a new attribute, `allowedRequestAttributesPattern` to the AJP/1.3 Connector. Requests with unrecognised attributes will be blocked with a 403. (markt)
- 64195: Revert simplification of NIO block read and write, deferred to Tomcat 10. (remm)
- Enforce the requirement of RFC 7230 onwards that a request with a malformed `content-length` header should always be rejected with a 400 response. (markt)
- Avoid protocol relative redirects in FORM authentication. (markt)
- Align validation of HTTP trailer fields with standard fields. (markt)

#### Jasper

- Update the performance optimisation for using expressions in tags that depend on uninitialised tag attributes with implied scope to make the performance optimisation aware of the new public class (`java.lang.Record`) added in Java 14. (markt)
- 64097: Replace the faulty custom services lookup used for `ExpressionFactory` implementations with `ServiceLoader`. (markt)
- Add a `META-INF/services` entry to jasper-el.jar so that the Expression Language implementation can be discovered via the services API. (markt)

#### Cluster

- 64043: Ensure that session ID changes are replicated during form-authentication. (kfujino)
- Make handling of OpenSSL read errors more robust when plain text data is reported to be available to read. (markt)

#### Web applications

- 64000: In the examples web application, where a Servlet example includes ii18n support, the Locale used should be based on the request locale and not the server locale. (markt)
- Add additional information on securing AJP/1.3 Connectors. (markt)
- Ensure that WebSocket connection closure completes if the connection is closed when the server side has used the proprietary suspend/resume feature to suspend the connection. (markt)

#### Other

- 63995: Ensure statements are closed when a pooled JDBC connection is passivated in Tomcat's fork of Commons DBCP2. (markt)

### 2019-12-12 Tomcat 9.0.30 (markt)

#### Catalina

- 63681: Introduce RealmBase#authenticate(GSSName, GSSCredential) and friends. (michaelo)
- 63964: Correct a regression in the static resource caching changes introduced in 9.0.28. URLs constructed from URLs obtained from the cache could not be used to access resources. (markt)
- 63970: Correct a regression in the static resource caching changes introduced in 9.0.28. Connections to URLs obtained for JAR resources could not be cast to `JarURLConnection`. (markt)
- 63937: Add a new attribute to the standard `Authenticator` implementations, `allowCorsPreflight`, that allows the `Authenticator`s to be configured to allow CORS preflight requests to bypass authentication as required by the CORS specification. (markt)
- 63939: Correct the same origin check in the CORS filter. An origin with an explicit default port is now considered to be the same as an origin without a default port and origins are now compared in a case-sensitive manner as required by the CORS specification. (markt)
- 63981: Allow multiple calls to `Registry.disableRegistry()` without the second and subsequent calls triggering the logging of a warning. Based on a patch by Andy Wilkinson. (markt)
- 63982: CombinedRealm makes assumptions about principal implementation (michaelo)
- 63983: Correct a regression in the static resource caching changes introduced in 9.0.28. A large number of file descriptors were opened that could reach the OS limit before being released by GC. (markt)
- 63987: Deprecate `Realm.getRoles(Principal)`. (michaelo)
- Add a unit test for the session `FileStore` implementation and refactor loops in `FileStore` to use the ForEach style. Pull request provided by Govinda Sakhare. (markt)
- Moved server-side include (SSI) module into a separate JAR library. (schultz)
- Refactor FORM authentication to reduce duplicate code and to ensure that the authenticated Principal is not cached in the session when caching is disabled. This is the fix for CVE-2019-17563. (markt/kkolinko)
- Ensure that an `IOException` during the reading of the request triggers always error handling, regardless of whether the application swallows the exception. (markt)

#### Coyote

- Fix endpoint closeSocket and destroySocket discrepancies, in particular in the APR connector. (remm)
- Harmonize maxConnections default value to 8192 across all connectors. (remm)
- 63931: Improve timeout handling for asyncIO to ensure that blocking operations see a `SocketTimeoutException` if one occurs. (remm/markt)
- 63932: By default, do not compress content that has a strong ETag. This behaviour is configuration for the HTTP/1.1 and HTTP/2 connectors via the new Connector attribute `noCompressionStrongETag`. (markt)
- 63949: Fix non blocking write problems with NIO due to the need for a write loop. (remm)
- Simplify regular endpoint writes by removing write(Non)BlockingDirect. All regular writes will now be buffered for a more predictable behavior. (remm)
- Send an exception directly to the completion handler when a timeout exception occurs for the operation, and add a boolean to make sure the completion handler is called only once. (remm/markt)
- When reporting / logging invalid HTTP headers encode any non-printing characters using the 0xNN form. (markt)

#### WebSocket

- Ensure a couple of very unlikely concurrency issues are avoided when writing WebSocket messages. (markt)

#### Web applications

- Fix the broken re-try link on the error page for the FORM authentication example in the JSP section of the examples web application. (markt)
- Improvements to CsrfPreventionFilter: additional logging, allow the CSRF nonce request parameter name to be customized. (schultz)
- Correct the documentation for the `maxConnections` attribute of the `Connector` in the documentation web application. (markt)
- Add the ability to set and display session attributes in the JSP FORM authentication example to demonstrate session persistence across restarts for authenticated sessions. (markt)

#### Other

- Correct the fix for 63815 (quoting the use of `CATALINA_OPTS` and `JAVA_OPTS` when used in shell scripts to avoid the expansion of `*`) as it caused various regressions, particularly with `daemon.sh`. (markt)
- Update the OWB module to Apache OpenWebBeans 2.0.13. (remm)
- Support Java 11 in Graal Native Images with Graal 19.3+. (remm)
- Expand the search made by the Windows installer for a suitable Java installation to include the 64-bit JDK registry entries and the `JAVA_HOME` environment variable. Pull request provided by Alexander Norz. (markt)
- Expand the coverage of the Korean translations provided with Apache Tomcat. (woonsan)
- Expand the coverage of the French translations provided with Apache Tomcat. (remm)
- Expand the coverage of the Chinese translations provided with Apache Tomcat. Contributions provided by lins and 磊. (markt)
- Update the internal fork of Apache Commons BCEL to ff6941e (2019-12-06, 6.4.2-dev). Code clean-up only. (markt)
- Update the internal fork of Apache Commons Codec to 9637dd4 (2019-12-06, 1.14-SNAPSHOT). Code clean-up and a fix for CODEC-265. (markt)
- Update the internal fork of Apache Commons FileUpload to 2317552 (2019-12-06, 2.0-SNAPSHOT). Refactoring. (markt)
- Update the internal fork of Apache Commons Pool 2 to 6092f92 (2019-12-06, 2.8.0-SNAPSHOT). Clean-up and minor refactoring. (markt)
- Update the internal fork of Apache Commons DBCP 2 to a36390 (2019-12-06, 2.7.1-SNAPSHOT). Minor refactoring. (markt)

### 2019-11-21 Tomcat 9.0.29 (markt)

#### Catalina

- Refactor JMX remote RMI registry creation. This is the fix for CVE-2019-12418. (remm)
- Improvement to CsrfPreventionFilter: expose the latest available nonce as a request attribute; expose the expected nonce request parameter name as a context attribute. (schultz)

#### Coyote

- 63835: Add support for Keep-Alive response header. (michaelo)
- Correct a logic bug in the `NioEndpoint` timeout handling that meant a write timeout could be handled as a read timeout. (markt)

#### Web applications

- Add a warning regarding potential poor performance of the HTTP and AJP connectors if `socket.txBufSize` is configured with an explicit value rather than using the JVM default. (markt)

#### Other

- Improve OWB module based using custom shade appender. (remm)
- Add security filter in OWB module in addition to the valve for more flexibility. (remm)

### not released Tomcat 9.0.28 (markt)

#### Catalina

- Bad paths for URIs can cause exceptions on Windows due to its path separator, so wrap using an IOException. (remm)
- 63832: Properly mark container as FAILED when a JVM error occurs on stop. (remm)
- Add more details on the usage of `RewriteMap` functionality in the `RewriteValve`. (fschumacher)
- 63836 Ensure that references to the Host object are cleared once the Host instance is destroyed. (markt)
- Ensure that, when static resource caching is enabled for a web application, all access to static files (including JSP files) goes via the cache so that a consistent view of the static files is seen. Prior to this change it was possible to see an updated last modified time but the content would be that prior to the modification. (markt)
- 63905 Clean up Tomcat CSS. (michaelo)
- 63909: When the `ExpiresFilter` is used without a default and the response is served by the Default Servlet, ensure that the filter processes the response if the Default Servlet sets a 304 (Not Found) status code. (markt)

#### Coyote

- Ensure that `ServletRequest.isAsyncStarted()` returns `false` once `AsyncContext.complete()` or `AsyncContext.dispatch()` has been called during `AsyncListener.onTimeout()` or `AsyncListener.onError()`. (markt)
- 63816 and 63817: Correctly handle I/O errors after asynchronous processing has been started but before the container thread that started asynchronous processing has completed processing the current request/response. (markt)
- 63825: When processing the `Expect` and `Connection` HTTP headers looking for a specific token, be stricter in ensuring that the exact token is present. (markt)
- 63829: Improve the check of the `Content-Encoding` header when looking to see if Tomcat is serving pre-compressed content. Ensure that only a full token is matched and that the match is case insensitive. (markt)
- 63864: Refactor parsing of the `transfer-encoding` request header to use the shared parsing code and reduce duplication. (markt)
- 63865: Add `Unset` option to same-site cookies and pass through `None` value if set by user. Patch provided by John Kelly. (markt)
- 63879: Remove stack trace from debug logging on socket wrapper close. (remm)
- Add connection tracking on the connector endpoint to remove excessive concurrency in the protocol handler when maintaining an association between the socket wrapper and its current processor. (remm)
- 63894: Ensure that the configured values for `certificateVerification` and `certificateVerificationDepth` are correctly passed to the OpenSSL based SSLEngine implementation. (remm/markt)
- Improve cleanup after errors when setting socket options. (remm)
- 63859: Do not perform a blocking read after a `CPING` message is received by the AJP connector because, if the JK Connector is configured with `ping_mode="I"`, the `CPING` message will not always be followed by the start of a request. (markt)
- Properly calculate all dynamic parts of the ErrorReportValve response on the fly in `org.apache.coyote.http2.TestHttp2InitialConnection`. (michaelo)

#### Jasper

- 63897: Capture the timestamp of a JSP for the purposes of modification tracking before the JSP is compiled to prevent a race condition if the JSP is modified during compilation. Patch provided by Karl von Randow. (markt)
- Fix a race condition that could mean changes to a modified JSP were not visible to end users. (markt)

#### WebSocket

- 63913: Wrap any `NullPointerException`s throw by the `Inflater` or `Deflater` used by the `PerMessageDeflate` extension in an `IOException` so that the error can be caught and handled by the WebSocket error handling mechanism. (markt)

#### Web applications

- Correct the description of the default value for the server attribute in the security How-To. (markt)

#### Other

- 63815: Quote the use of `CATALINA_OPTS` and `JAVA_OPTS` when used in shell scripts to avoid the expansion of `*`. Note that any newlines present in `CATALINA_OPTS` and/or `JAVA_OPTS` will no longer removed. (markt)
- 63826: Remove `commons-daemon-native.tar.gz` and `tomcat-native.tar.gz` from the binary zip distributions for Windows since compiled versions of those components are already included within the zip distributions. (markt)
- 63838: Suppress reflexive access warnings when running the unit tests on the command line. (markt)
- Add missing charsets from the HPE JVM on HP-UX to pass unit tests in `org.apache.tomcat.util.buf.TestCharsetCache`. (michaelo)
- Update the CXF module to Apache CXF 3.3.4. (remm)
- Expand the coverage and quality of the French translations provided with Apache Tomcat. (remm)
- Expand the coverage and quality of the Japanese translations provided with Apache Tomcat. Patch provided by motohashi.yuki. (markt)
- Expand the coverage and quality of the Simplified Chinese translations provided with Apache Tomcat. Contributions provided by rpo130, Mason Shen, leeyazhou, winsonzhao, qingshi huang, Lay, Shucheng Hou and Yanming Zhou. (markt)
- Expand the coverage and quality of the Brazilian Portuguese translations provided with Apache Tomcat. Patch provided by Danielamorais. (markt)

### 2019-10-11 Tomcat 9.0.27 (markt)

#### Catalina

- Correct a regression introduced in 9.0.25 that prevented configuration files from being loaded from the class path. (markt)

#### Coyote

- Use URL safe base 64 encoding rather than standard base 64 encoding when generating or parsing the `HTTP2-Settings` header as part of an HTTP upgrade to `h2c` as required by RFC 7540. (markt)
- 63765: NIO2 should try to unwrap after TLS handshake to avoid edge cases. (remm)
- 63766: Ensure Processor objects are recycled when processing an HTTP upgrade connection that terminates before processing switches to the Processor for the upgraded protocol. (markt)
- Fix a memory leak introduced by the HTTP/2 timeout refactoring in 9.0.23 that could occur when HTTP/2 or WebSocket was used. (markt)

#### Jasper

- Update to the Eclipse JDT compiler 4.13. (markt)
- Add GraalVM specific ELResolver to avoid BeanInfo use in BeanElResolver if possible, as it needs manual reflection configuration. (remm)
- 63781: When performing various checks related to the visibility of classes, fields an methods in the EL implementation, also check that the containing module has been exported. (markt)

#### Web Socket

- 63753: Ensure that the `Host` header in a Web Socket HTTP upgrade request only contains a port if a non-default port is being used. (markt)
- When running on Java 9 and above, don't attempt to instantiate WebSocket Endpoints found in modules that are not exported. (markt)

#### Web Applications

- Add base GraalVM documentation. (remm)
- Add Javadoc for the Common Annotations API implementation. (markt)
- Correct various typos in the comments, error messages and Javadoc. Patch provided by 康智冬. (markt)

#### jdbc-pool

- When connections are validated without an explicit validation query, ensure that any transactions opened by the validation process are committed. Patch provided by Pascal Davoust. (markt)

#### Other

- Deprecate `org.apache.tomcat.util.compat.TLS`. Its functionality was only used for unit tests in `org.apache.tomcat.util.net.TesterSupport` and has been moved there. (rjung)
- 63759: When installing Tomcat with the Windows installer, grant sufficient privileges to enable the uninstaller to execute when user account control is active. (markt)
- Use a build property to define the minimum supported Java version and use that build property to reduce the number of edits required to update the minimum supported Java version. (markt)
- Update the OWB module to Apache OpenWebBeans 2.0.12. (remm)
- Update the CXF module to Apache CXF 3.3.3. (remm)
- 63767: Update to Commons Daemon 1.2.2. This corrects a regression in Commons Daemon 1.2.0 and 1.2.1 that caused the Windows Service to crash on start when running on an operating system that had not been fully updated. (markt)
- 64467: Improve performance of closing idle HTTP/2 streams. (markt)
- Remove support for the `identity` transfer encoding. The inclusion of this encoding in RFC 2616 was an error that was corrected in 2001. Requests using this transfer encoding will now receive a 501 response. (markt)
- Process transfer encoding headers from both HTTP 1.0 and HTTP 1.1 clients. (markt)
- Ensure that if the transfer encoding header contains the `chunked`, that the `chunked` encoding is the final encoding listed. (markt)

### 2019-09-19 Tomcat 9.0.26 (markt)

#### Other

- Re-tagged to ensure that the source file for the changelog did not contain an XML byte order mark. (markt)

### not released Tomcat 9.0.25 (markt)

#### Catalina

- Avoid a possible `InvalidPathException` when obtaining a URI for a configuration file. (markt)
- 63684: `Wrapper` never passed to `RealmBase.hasRole()` for given security constraints. (michaelo)
- 63740: Ensure configuration files are loaded correctly when a `Host` is configured with an `xmlBase`. Patch provided by uk4sx. (markt)
- Avoid a potential `NullPointerException` on Service stop if a Service is embedded directly (i.e. with no Server) in an application and JNDI is enabled. Patch provided by S. Ali Tokmen. (markt)
- Add a new `PropertySource` implementation, `EnvironmentPropertySource`, that can be used to do property replacement in configuration files with environment variables. Based on a pull request provided by Thomas Meyer. (markt)

#### Coyote

- 63682: Fix a potential hang when using the asynchronous Servlet API to write the response body and the stream and/or connection window reaches 0 bytes in size. (markt)
- 63690: Use the average of the current and previous sizes when calculating overhead for HTTP/2 `DATA` and `WINDOW_UPDATE` frames to avoid false positives as a result of client side buffering behaviour that causes a small percentage of non-final DATA frames to be smaller than expected. (markt)
- 63706: Avoid NPE accessing https port with plaintext. (remm)
- Correct typos in the names of the configuration attributes `overheadDataThreshold` and `overheadWindowUpdateThreshold`. (markt)
- If the HTTP/2 connection requires an initial window size larger than the default, send a WINDOW_UPDATE to increase the flow control window for the connection so that the initial size of the flow control window for the connection is consistent with the increased value. (markt)
- 63710: When using HTTP/2, ensure that a `content-length` header is not set for those responses with status codes that do not permit one. (markt)
- 63737: Correct various issues when parsing the `accept-encoding` header to determine if gzip encoding is supported including only parsing the first header found. (markt)

#### Jasper

- 63724: Correct a regression introduced in 9.0.21 that broke compilation of JSPs in some configurations. (markt)

#### Web applications

- Correct the source code links on the index page for the ROOT web application to point to Git rather than Subversion. (markt)
- Fix various issues with the Javadoc generated for the documentation web application to enable release builds to be built with Java 10 onwards. (markt)
- 63733: Remove the documentation for the "Additional Components" since they have been removed / merged into the core Tomcat distribution for 9.0.5 onwards. (markt)
- 63739: Correct the invalid `Automatic-Module-Name` manifest entries for the Tomcat provided JARs included in the Tomcat embedded distribution. (markt)
- Fix a large number of Javadoc and documentation typos. Patch provided by KangZhiDong. (markt)
- Spelling and formatting corrections for the cluster how-to. Pull request provided by Bill Mitchell. (markt)

#### Other

- Expand the coverage and quality of the French translations provided with Apache Tomcat. (remm)
- Expand the coverage and quality of the Simplified Chinese translations provided with Apache Tomcat. Includes contributions by leeyazhou and 康智冬. (markt)
- 62140: Additional usage documentation in comments for `catalina.[bat|sh]`. (markt)
- Fix `JSSE_OPTS` quoting in `catalina.bat`. Contributed by Peter Uhnak. (fschumacher)
- 63625: Update to Commons Daemon 1.2.1. This corrects several regressions in Commons Daemon 1.2.1, most notably the Windows Service crashing on start when using 32-bit JVMs. (markt)
- 63689: Correct a regression in the fix for 63285 that meant that when installing a service, the service display name was not set. (markt)
- When performing a silent install with the Windows Installer, ensure that the registry entries are added to the 64-bit registry when using a 64-bit JVM. (markt)
- Remove unused i18n messages and associated translations. Patch provided by KangZhiDong. (markt)
- Expand the coverage and quality of the Korean translations provided with Apache Tomcat. (woonsan)

### 2019-08-17 Tomcat 9.0.24 (markt)

#### Coyote

- Remove the code in the sendfile poller that ensured smaller pollsets were used with older, no longer supported versions of Windows that could not support larger pollsets. (markt)

### not released Tomcat 9.0.23 (markt)

#### Catalina

- 57665: Add support for the `X-Forwarded-Host` header to the `RemoteIpFilter` and `RemoteIpValve`. (markt)
- 62496: Add option to write auth information (remote user/auth type) to response headers. (michaelo)
- 63550: Only try the `alternateURL` in the `JNDIRealm` if one has been specified. (markt)
- 63556: Mark request as forwarded in RemoteIpValve and RemoteIpFilter (michaelo)
- 63579: Correct parsing of malformed OPTIONS requests and reject them with a 400 response rather than triggering an internal error that results in a 500 response. (markt)
- 63608: Align the implementation of the negative match feature for patterns used with the `RewriteValve` with the description in the documentation. (markt)
- 63627: Implement more fine-grained handling in `RealmBase.authenticate(GSSContext, boolean)`. (michaelo)
- If an unhandled exception occurs on a asynchronous thread started via `AsyncContext.start(Runnable)`, process it using the standard error page mechanism. (markt)
- Discard large byte buffers allocated using setBufferSize when recycling the request. (remm)
- Avoid a `NullPointerException` in the `CrawlerSessionManagerValve` if no ROOT Context is deployed and a request does not map to any of the other deployed Contexts. Patch provided by Jop Zinkweg. (markt)
- 63636: `Context.findRoleMapping()` never called in `StandardWrapper.findSecurityReference()`. (michaelo)

#### Coyote

- Refactor the APR poller to always use a single pollset now that the Windows operating systems that required multiple smaller pollsets to be used are no longer supported. (markt)
- 63524: Improve the handling of PEM file based keys and certificates that do not include a full certificate chain when configuring the internal, in-memory key store. Improve the handling of PKCS#1 formatted private keys when configuring the internal, in-memory key store. (markt)
- Add callback when finishing the set properties rule in the digester. (remm)
- 63568: Avoid error when trying to set tcpNoDelay on socket types that do not support it, which can occur when using the NIO inherited channel capability. Submitted by František Kučera. (remm)
- 63570: Fix regression retrieving local address with the NIO connector. Submitted by Aditya Kadakia. (remm)
- Correct parsing of invalid host names that contain bytes in the range 128 to 255 and reject them with a 400 response rather than triggering an internal error that results in a 500 response. (markt)
- 63571: Allow users to configure infinite TLS session caches and/or timeouts. (markt)
- 63578: Improve handling of invalid requests so that 400 responses are returned to the client rather than 500 responses. (markt)
- Fix h2spec test suite failure. It is an error if a Huffman encoded string literal contains the EOS symbol. (jfclere)
- Connections that fail the TLS handshake will now appear in the access logs with a 400 status code. (markt)
- Timeouts for HTTP/2 connections were not always correctly handled leaving some connections open for longer than expected. (markt)
- 63650: Refactor initialisation for JSSE based TLS connectors to enable custom JSSE providers that provide custom cipher suites to be used. (markt)
- Expand the HTTP/2 excessive overhead protection to cover various forms of abusive client behaviour and close the connection if any such behaviour is detected. (markt)
- Fix a crash on shutdown with the APR/native connector when a blocking I/O operation was still in progress when the connector stopped. (markt)

#### Cluster

- Avoid failing Kubernetes membership (and preventing startup) if the stream cannot be opened, to get the same behavior as the DNS based membership. The namespace is still a failure on startup but it is easy to provide. (remm)
- Avoid non fatal NPEs with Tribes when JMX is not available. (remm)
- Make Kube environment optional for Kube memberships, for easier testing and Graal training. A warn log will occur if the environment is not present. (remm)

#### Web applications

- 63597: Update the custom 404 error page for the Host Manager to take account of previous refactoring so that the page is used for 404 errors rather than falling back to the default error page. (markt)

#### Other

- JNDI support for GraalVM native images. (remm)
- JSP runtime library support for GraalVM native images. (remm)
- java.util.logging configuration for GraalVM native images. (remm)
- Update Checkstyle to 8.22. (markt)
- 55969: Tighten up the security of the Apache Tomcat installation created by the Windows installer. Change the default shutdown port used by the Windows installer from `8005` to `-1` (disabled). Limit access to the chosen installation directory to local administrators, Local System and Local Service. (markt)
- 62696: The digital signature for the Windows installer now uses SHA-256 for hashes. (markt)
- 63285: Add an option to `service.bat` so that when installing a Windows service, the name of the executables used by the Windows service may be changed to match the service name. This makes the installation behaviour consistent with the Windows installer. The original executable names will be restored when the Windows service is removed. The renaming can be enabled by using the new `--rename` option after the service name. (markt)
- 63310: Update to Commons Daemon 1.2.0. This provides improved support for Java 11. This also changes the user configured by the Windows installer for the Windows service from `Local System` to the lower privileged `Local Service`. (markt)
- Expand the coverage and quality of the French translations provided with Apache Tomcat. (remm)
- 63555: Add `Automatic-Module-Name` entries for each of the Tomcat provided JARs included in the Tomcat embedded distribution. (markt)
- 63567: Restore the passing of `$LOGGING_MANAGER` to the jvm in `catalina.sh` when calling `stop`. (markt)
- Correct broken OSGi data in JAR file manifests. (markt)
- Add "embed" to the `Bundle-Name` and `Bundle-Symbolic-Name` for the Tomcat embedded WebSocket JAR to align the naming with the other embedded JARs and to differentiate it from the standard WebSocket JAR that does not include the API classes. (markt)
- Update dependency on bnd to 4.2.0. (markt)
- Update the internal fork of Commons Codec to 3ebef4a (2018-08-01) to pick up the fix for CODEC-134. (markt)
- Update the internal fork of Commons Pool2 to 796e32d (2018-08-01) to pick up the changes Commons Pool2 2.7.0. (markt)
- Update the internal fork of Commons DBCP2 to 87d9e3a (2018-08-01) to pick up the changes Commons DBCP2 2.7.0 and DBCP-555. (markt)
- 63648: Update the test TLS keys and certificates used in the test suite to replace the keys and certificates that are about to expire. (markt)

### 2019-07-09 Tomcat 9.0.22 (markt)

#### Catalina

- Improve parsing of Range request headers. (markt)
- Range headers that specify a range unit Tomcat does not recognise should be ignored rather than triggering a 416 response. Based on a pull request by zhanhb. (markt)
- When comparing a date from a `If-Range` header, an exact match is required. Based on a pull request by zhanhb. (markt)
- Add an option to the default servlet to disable processing of PUT requests with Content-Range headers as partial PUTs. The default behaviour (processing as partial PUT) is unchanged. Based on a pull request by zhanhb. (markt)
- Improve parsing of Content-Range headers. (markt)
- Update the recommended minimum Tomcat Native version to 1.2.23. (markt)

#### Coyote

- Remove a source of potential deadlocks when using HTTP/2 when the Connector is configured with `useAsyncIO` as `true`. (markt)
- 63523: Restore SSLUtilBase methods as protected to preserve compatibility. (remm)
- Fix typo in UTF-32LE charset name. Patch by zhanhb via Github. (fschumacher)
- Once a URI is identified as invalid don't attempt to process it further. Based on a PR by Alex Repert. (markt)
- Fix to avoid the possibility of long poll times for individual pollers when using multiple pollers with APR. (markt)
- Refactor the fix for 63205 so it only applies when using PKCS12 keystores as regressions have been reported with some other keystore types. (markt)

#### Jasper

- Include file names if SMAP processor is unable to delete or rename a class file during SMAP generation. (markt)
- Update to the Eclipse JDT compiler 4.12. (markt)

#### WebSocket

- 63521: As required by the WebSocket specification, if a POJO that is deployed as a result of the SCI scan for annotated POJOs is subsequently deployed via the programmatic API ignore the programmatic deployment. (markt)

#### Other

- Switch the check for terminal availability to test for stdin as using stdout does not work when output is piped to another process. Patch provided by Radosław Józwik. (markt)
- Add user buildable optional modules for easier CDI 2 and JAX-RS support. Also include a new documentation page describing how to use it. (remm)

### 2019-06-07 Tomcat 9.0.21 (markt)

#### Catalina

- 57287: Add file sorting to DefaultServlet (schultz)
- Fix `--no-jmx` flag processing, which was called after registry initialization. (remm)
- Ensure that a default request character encoding set on a `ServletContext` is used when calling `ServletRequest#getReader()`. (markt)
- Make a best efforts attempt to clean-up if a request fails during processing due to an `OutOfMemoryException`. (markt)
- Improve the BoM detection for static files handled by the default servlet for the rarely used UTF-32 encodings. Identified by Coverity Scan. (markt)
- Ensure that the default servlet reads the entire global XSLT file if one is defined. Identified by Coverity Scan. (markt)
- Avoid potential `NullPointerException` when generating an HTTP `Allow` header. Identified by Coverity Scan. (markt)
- Add `Context.createInstanceManager()` for easier framework integration. (remm)
- Add utility `org.apache.catalina.core.FrameworkListener` to allow replicating adding a Listener to context.xml in a programmatic way. (remm)
- Move `Container.ADD_CHILD_EVENT` to before the child container start, and `Container.REMOVE_CHILD_EVENT` to before removal of the child from the internal child collection. (remm)
- Remove any fragment included in the target path used to obtain a `RequestDispatcher`. The requested target path is logged as a warning since this is an application error. (markt)

#### Coyote

- NIO poller seems to create some unwanted concurrency, causing rare CI test failures. Add sync when processing async operation to avoid this. (remm)
- Fix concurrency issue that lead to incorrect HTTP/2 connection timeout. (remm/markt)
- Avoid useless exception wrapping in async IO. (remm)
- 63412: Security manager failure when using the async IO API from a webapp. (remm)
- Remove `acceptorThreadCount` Connector attribute, one accept thread is sufficient. As documented, value `2` was the only other sensible value, but without and impact beyond certain microbenchmarks. (remm)
- Avoid possible NPEs on connector stop. (remm)
- Remove `pollerThreadCount` Connector attribute for NIO, one poller thread is sufficient. (remm)
- Add async IO for APR connector for consistency, but disable it by default due to low performance. (remm)
- Avoid blocking write of internal buffer when using async IO. (remm)
- Refactor async IO implementation to the `SocketWrapperBase`. (remm)
- Refactor `SocketWrapperBase` close using an atomic boolean and a `doClose` method that subclasses will implement, with a guarantee that it will be run only once. (remm)
- Decouple the socket wrapper, which is not recycled, from the NIOx channel after close, and replace it with a dummy static object. (remm)
- Clear buffers on socket wrapper close. (remm)
- NIO2 failed to properly close sockets on connector stop. (remm)
- Reduce the default for `maxConcurrentStreams` on the `Http2Protocol` from 200 to 100 to align with typical defaults for HTTP/2 implementations. (markt)
- Reduce the default HTTP/2 header list size from 4GB to 32kB to align with typical HTTP/2 implementations. (markt)
- Add support for same-site cookie attribute. Patch provided by John Kelly. (markt)
- Drop legacy NIO double socket close (close channel, then close socket). (remm)
- Fix HTTP/2 end of stream concurrency with async. (remm)
- Correct a bug in the stream flushing code that could lead to multiple threads processing the stream concurrently which in turn could cause errors processing the stream. (markt)

#### Cluster

- 62841: Refactor the `DeltaRequest` serialization to reduce the window during which the `DeltaSession` is locked and to remove a potential cause of deadlocks during serialization. (markt)
- 63441: Further streamline the processing of session creation messages in the `DeltaManager` to reduce the possibility of a session update message being processed before the session has been created. (markt)

#### WebSocket

- Fix timeout logic for async non blocking writes. Identified by Coverity Scan. (remm)

#### Web applications

- Expand the explanation of how deprecated TLS configuration attributes are converted to the new TLS configuration style. (markt)

#### Tribes

- Treat `NoRouteToHostException` the same way as `SocketTimeoutException` when checking the health of group members. This avoids a SEVERE log message every time the check is performed when the host associated with a group member is not powered on. (markt)

#### Other

- Switch from FindBugs to SpotBugs. (fschumacher)
- Start Graal native image compatibility, using the tomcat-maven packaging. (remm)
- 63403: Fix TestHttp2InitialConnection test failures when running with a non-English locale. (kkolinko)
- Add Graal JreCompat, and use it to disable JMX and URL stream handlers. (remm)
- Expand the coverage and quality of the Czech translations provided with Apache Tomcat. Includes contributions by Arnošt Havelka. (markt)
- Expand the coverage and quality of the German translations provided with Apache Tomcat. Includes contributions by Niklasmerz, dusiema and Jens. (markt)
- Expand the coverage and quality of the French translations provided with Apache Tomcat. (remm)
- Expand the coverage and quality of the Simplified Chinese translations provided with Apache Tomcat. Includes contributions by 諵. (markt)
- Use the `test` command to check for terminal availability rather than the `tty` command since the `tty` based test fails on non-English locales. (markt)

### 2019-05-13 Tomcat 9.0.20 (markt)

#### Catalina

- Fix some edge cases where the docBase was not being set using a canonical path which in turn meant resource URLs were not being constructed as expected. (markt)
- Fix a potential resource leak when executing CGI scripts from a WAR file. Identified by Coverity scan. (markt)
- Fix a potential concurrency issue in the StringCache identified by Coverity scan. (markt)
- Fix a potential concurrency issue in the main Sendfile thread of the APR connector. Identified by Coverity scan. (markt)
- Fix a potential resource leak when running a web application from a WAR file. Identified by Coverity scan. (markt)
- Fix a potential resource leak on some exception paths in the `DataSourceRealm`. Identified by Coverity scan. (markt)
- Fix a potential resource leak on an exception path when parsing JSP files. Identified by Coverity scan. (markt)
- Fix a potential resource leak when a JNDI lookup returns an object of an in compatible class. Identified by Coverity scan. (markt)
- Refactor `ManagerServlet` to avoid loading classes when filtering JNDI resources for resources of a specified type. (markt)
- 63324: Refactor the `CrawlerSessionManagerValve` so that the object placed in the session is compatible with session serialization with mem-cached. Patch provided by Martin Lemanski. (markt)
- 63358: Expand the `throwOnFailure` support in the `Connector` to include the adding of a `Connector` to a running `Service`. (markt)
- 63361: Add a new method (`Registry.disableRegistry()`) that can be used to disable JMX registration of Tomcat components providing it is called before the first component is registered. (markt)
- Avoid `OutOfMemoryError`s and `ArrayIndexOutOfBoundsException`s when accessing large files via the default servlet when resource caching has been disabled. (markt)
- Avoid a `NullPointerException` when a `Context` is defined in `server.xml` with a `docBase` but not the optional `path`. (markt)
- 63333: Override the `isAvailable()` method in the `JAASRealm` so that only login failures caused by invalid credentials trigger account lock out when the `LockOutRealm` is in use. Patch provided by jchobantonov. (markt)
- Add `--no-jmx` flag to allow disabling JMX in `startup.Tomcat.main`. (remm)

#### Coyote

- The `useAsyncIO` boolean attribute on the Connector element value now defaults to `true`. (remm)
- Possible HTTP/2 connection leak issue when using async with NIO. (remm)
- Fix socket close discrepancies for NIO, now the wrapper close is used everywhere except for socket accept problems. (remm)
- Implement poller timeout when using async IO with NIO. (remm)
- Avoid creating and using object caches when they are disabled. (remm)
- When running on newer JREs that don't support SSLv2Hello, don't warn that it is not available unless explicitly configured. (markt)
- Change default value of `pollerThreadCount` of NIO to `1`. (remm)
- Associate BlockPoller thread name with its NIO connector for better readability. (remm)
- The async HTTP/2 frame parser should tolerate concurrency so clearing shared buffers before attempting a read is not possible. (remm)
- Update the HTTP/2 connection preface and initial frame reading to be asynchronous instead of blocking IO. (remm)
- Refactor Hostname validation to improve performance. Patch provided by Uwe Hees. (markt)
- Add additional NIO2 style read and write methods closer to core NIO2, for possible use with an asynchronous workflow like CompletableFuture. (remm)
- Expand HTTP/2 timeout handling to include connection window exhaustion on write. This is the fix for CVE-2019-10072. (markt)

#### Jasper

- 63359: Ensure that the type conversions used when converting from strings for `jsp:setProperty` actions are correctly implemented as per section JSP.1.14.2.1 of the JSP 2.3 specification. (markt)

#### Other

- 63335: Ensure that stack traces written by the `OneLineFormatter` are fully indented. The entire stack trace is now indented by an additional TAB character. (markt)
- 63370: Message files (LocalStrings_*.properties) of the examples webapp not converted to ascii. (woonsan)
- Expand the coverage and quality of the French translations provided with Apache Tomcat. (remm)
- Expand the coverage and quality of the Japanese translations provided with Apache Tomcat. Includes contributions by motohashi.yuki. (markt)
- Expand the coverage and quality of the Czech translations provided with Apache Tomcat. Includes contributions by Arnošt Havelka. (markt)
- When using the `OneLineFormatter`, don't print a blank line in the log after printing a stack trace. (markt)
- Update the internal fork of Apache Commons FileUpload to 41e4047 (2019-04-24) pick up some enhancements. (markt)
- Update the internal fork of Apache Commons DBCP 2 to dcdbc72 (2019-04-24) to pick up some clean-up and enhancements. (markt)
- Update the internal fork of Apache Commons Pool 2 to 0664f4d (2019-04-30) to pick up some enhancements and bug fixes. (markt)

### 2019-04-13 Tomcat 9.0.19 (markt)

#### Catalina

- Fix wrong JMX registration regression in 9.0.18. (remm)

#### Coyote

- Add vectoring for NIO in the base and SSL channels. (remm)
- Add asynchronous IO from NIO2 to the NIO connector, with support for the async IO implementations for HTTP/2 and Websockets. The `useAsyncIO` boolean attribute on the Connector element allows enabling use of the asynchronous IO API. (remm)

#### Other

- Ensure that the correct files are included in the source distribution for javacc based parsers depending on whether jjtree is used or not. (markt)
- Ensure that text files in the source distribution have the correct line endings for the target platform. (markt)

### not released Tomcat 9.0.18 (markt)

#### Catalina

- 63196: Provide a default (`X-Forwarded-Proto`) for the `protocolHeader` attribute of the `RemoteIpFilter` and `RemoteIpValve`. (markt)
- 63235: Refactor Charset cache to reduce start time. (markt)
- 63249: Use a consistent log level (`WARN`) when logging the failure to register or deregister a JMX Bean. (markt)
- 63249: Use a consistent log level (`ERROR`) when logging the `LifecycleException` associated with the failure to start or stop a component. (markt)
- When the SSI directive `fsize` is used with an invalid target, return a file size of `-` rather than `1k`. (markt)
- 63251: Implement a work-around for a known JRE bug (JDK-8194653) that may cause a dead-lock when Tomcat starts. (markt)
- 63275: When using a `RequestDispatcher` ensure that `HttpServletRequest.getContextPath()` returns an encoded path in the dispatched request. (markt)
- Add optional listeners for Server/Listener, as a slight variant of a standard listener. The difference is that loading is not fatal when it fails. This would allow adding example configuration to the standard server.xml if deemed useful. Storeconfig will not attempt to persist the new listener. (remm)
- 63286: Document the differences in behaviour between the `LogFormat` directive in httpd and the `pattern` attribute in the `AccessLogValve` for `%D` and `%T`. (markt)
- 63287: Make logging levels more consistent for similar issues of similar severity. (markt)
- 63311: Add support for https URLs to the local resolver within Tomcat used to resolve standard XML DTDs and schemas when Tomcat is configured to validate XML configuration files such as web.xml. (markt)
- Encode the output of the SSI `printenv` command. This is the fix for CVE-2019-0221. (markt)
- Use constants for SSI encoding values. (markt)
- When the CGI Servlet is configured with `enableCmdLineArguments` set to true, limit the encoded form of the individual command line arguments to those values allowed by RFC 3875. This restriction may be relaxed by the use of the new initialisation parameter `cmdLineArgumentsEncoded`. (markt)
- When the CGI Servlet is configured with `enableCmdLineArguments` set to true, limit the decoded form of the individual command line arguments to known safe values when running on Windows. This restriction may be relaxed by the use of the new initialisation parameter `cmdLineArgumentsDecoded`. This is the fix for CVE-2019-0232. (markt)

#### Coyote

- Fix bad interaction between NIO2 async read API and the regular read. (remm)
- Refactor NIO2 write pending strategy for the classic IO API. (remm)
- Restore original maxConnections default for NIO2 as the underlying close issues have been fixed. (remm)
- Harmonize NIO2 isReadyForWrite with isReadyForRead code. (remm)
- When using a JSSE TLS connector that supported ALPN (Java 9 onwards) and a protocol was not negotiated, Tomcat failed to fallback to HTTP/1.1 and instead dropped the connection. (markt)
- Correct a regression in the TLS connector refactoring in Tomcat 9.0.17 that prevented the use of PKCS#8 private keys with OpenSSL based connectors. (markt)
- Fix NIO2 SSL edge cases. (remm)
- When performing an upgrade from HTTP/1.1 to HTTP/2, ensure that any query string present in the original HTTP/1.1 request is passed to the HTTP/2 request processing. (markt)
- When Tomcat writes a final response without reading all of an HTTP/2 request, reset the stream to inform the client that the remaining request body is not required. (markt)

#### Jasper

- Add support for specifying Java 11 (with the value `11`) as the compiler source and/or compiler target for JSP compilation. (markt)
- Add support for specifying Java 12 (with the value `12`) and Java 13 (with the value `13`) as the compiler source and/or compiler target for JSP compilation. If used with an ECJ version that does not support these values, a warning will be logged and the latest supported version will used. Based on a patch by Thomas Collignon. (markt)

#### Web applications

- 63184: Expand the SSI documentation to provide more information on the supported directives and their attributes. Patch provided by nightwatchcyber. (markt)
- Add a note to the documentation about the risk of DoS with poorly written regular expressions and the `RewriteValve`. Patch provided by salgattas. (markt)

#### jdbc-pool

- Improved maxAge handling. Add support for age check on idle connections. Connection that expired reconnects rather than closes it. Patch provided by toby1984. (kfujino)
- 63320: Ensure that `StatementCache` caches statements that include arrays in arguments. (kfujino)

#### Other

- Update to the Eclipse JDT compiler 4.10. (markt)
- Expand the coverage and quality of the Spanish translations provided with Apache Tomcat. Includes contributions by Ulises Gonzalez Horta. (markt)
- Expand the coverage and quality of the Czech translations provided with Apache Tomcat. Includes contributions by Arnošt Havelka. (markt)
- Expand the coverage and quality of the Chinese translations provided with Apache Tomcat. Includes contributions by winsonzhao and wjt. (markt)
- Expand the coverage and quality of the Russian translations provided with Apache Tomcat. (kkolinko)
- Expand the coverage and quality of the Japanese translations provided with Apache Tomcat. (kfujino)
- Expand the coverage and quality of the Korean translations provided with Apache Tomcat. (woonsan)
- Expand the coverage and quality of the German translations provided with Apache Tomcat. (fschumacher)
- Expand the coverage and quality of the French translations provided with Apache Tomcat. (remm)

### 2019-03-18 Tomcat 9.0.17 (markt)

#### Catalina

- Refactor how cookies are transferred from the base request to a `PushBuilder` so that they are accessible, and may be edited, via the standard `PushBuilder` methods for working with HTTP headers. (markt)
- Simplify the value of `jarsToSkip` property in `catalina.properties` file for tomcat-i18n jar files. Use prefix pattern instead of listing each language. (kkolinko)
- Restore the getter and setter for the access log valve attribute `maxLogMessageBufferSize` that were accidentally removed. (markt)
- 63206: Add a new attribute to `Context` - `createUploadTargets` which, if `true` enables Tomcat to create the temporary upload location used by a Servlet if the location specified by the Servlet does not already exist. The default value is `false`. (markt)
- 63210: Ensure that the Apache Commons DBCP 2 based default connection pool is correctly shutdown when it is no longer required. This ensures that a non-daemon thread is not left running that will prevent Tomcat from shutting down cleanly. (markt)
- 63213: Ensure the correct escaping of group names when searching for nested groups when the JNDIRealm is configured with `roleNested` set to `true`. (markt)
- 63236: Use `String.intern()` as suggested by Phillip Webb to reduce memory wasted due to String duplication. This changes saves ~245k when starting a clean installation. With additional thanks to YourKit Java profiler for helping to track down the wasted memory and the root causes. (markt)
- 63246: Fix a potential `NullPointerException` when calling `AsyncContext.dispatch()`. (markt)
- Always use the absolute path of the `docBase` during the deployment process to determine the Context name, deployment type, whether the `docBase` is located within the `appBase` etc. (markt)

#### Coyote

- When performing an HTTP/1.1 upgrade to HTTP/2 (h2c) ensure that the hostname and port from the HTTP/1.1 Host header of the upgraded request are made available via the standard methods `ServletRequest.getServerName()` and `ServletRequest.getServerPort()`. (markt)
- Refactor the APR/Native endpoint TLS configuration code to enable JSSE style configuration - including JKS keystores - to be used with the APR/Native connector. (markt)
- With the TLS configuration refactoring, the configuration attributes `sessionCacheSize` and `sessionTimeout` are no longer limited to JSSE implementations. They may now be used with OpenSSL implementations as well. (markt)
- Refactor NIO2 read pending strategy for the classic IO API. (remm)
- 63182: Avoid extra read notifications for HTTP/1.1 with NIO2 when using asynchronous threads. (remm)
- 63205: Add a work-around for a known JRE KeyStore loading bug. (markt)
- NIO2 should try to use SocketTimeoutException everywhere rather than a mix of it and InterruptedByTimeout. (remm)
- Correct an error in the request validation that meant that HTTP/2 push requests always resulted in a 400 response. (markt)
- 63223: Correctly account for push requests when tracking currently active HTTP/2 streams. (markt)
- Ensure enough buffer space when using TLS with NIO2 by using the main read buffer to store additional decrypted data. (remm)
- Verify HTTP/2 stream is still writable before assuming a timeout occurred. (remm)
- Avoid some overflow cases with OpenSSL to improve efficiency, as the OpenSSL engine has an internal buffer. (remm)
- Harmonize HTTP/1.1 NIO2 keepalive code. (remm)

#### WebSocket

- Remove the `STREAMS_DROP_EMPTY_MESSAGES` system property that was introduced to work-around four failing TCK tests. An alternative solution has been implemented. Sending messages via `getSendStream()` and `getSendWriter()` will now only result in messages on the wire if data is written to the `OutputStream` or `Writer`. Writing zero length data will result in an empty message. Note that sending a message via an `Encoder` may result in the message being send via `getSendStream()` or `getSendWriter()`. (markt)

#### Web applications

- Fix messages used by Manager and Host Manager web applications. Disambiguate message keys used when adding or removing a host. Improve display of summary values on the status page: separate terms and values with a whitespace. Improve wording of messages for expire sessions command. (kkolinko)
- Do not add CSRF nonce parameter and suppress Referer header for external links in Manager and Host Manager web applications. (kkolinko)

#### Tribes

- Add feature that discover local member from the static member list. (kfujino)
- Ensure that members registered in the addSuspects list are static members. (kfujino)

#### Other

- Expand the coverage and quality of the French translations provided with Apache Tomcat. (remm)
- 63041: Revert the changes for 53930 that added support for the `CATALINA_OUT_CMD` environment variable as they prevented correct operation with systemd configurations that did not explicitly specify a PID file. (markt)
- Expand the coverage and quality of the Russian translations provided with Apache Tomcat. (kkolinko)
- Fix the artifactId of `tomcat-i18n-cs`. (rjung)
- Expand the coverage and quality of the Korean translations provided with Apache Tomcat. (woonsan)
- Expand the coverage and quality of the Chinese translations provided with Apache Tomcat. Includes contributions by winsonzhao. (markt)
- Expand the coverage and quality of the Czech translations provided with Apache Tomcat. Includes contributions by Arnošt Havelka. (markt)
- Expand the coverage and quality of the Spanish translations provided with Apache Tomcat. Includes contributions by Ulises Gonzalez Horta. (markt)

### 2019-02-08 Tomcat 9.0.16 (markt)

#### Web applications

- Use client's preferred language for the Server Status page of the Manager web application. Review and fix several cases when the client's language preference was not respected in Manager and Host Manager web applications. (kkolinko)
- 63141: Ensure that translated manager response strings still start with `OK -` where expected by the associated Ant tasks. (markt)
- 63143: Ensure that the Manager web application respects the language preferences of the user as configured in the browser when the language of the default system locale is not English. (markt)

#### Tribes

- Remove unnecessary shutdown for executor. (kfujino)

#### Other

- Update the NSIS Installer used to build the Windows installer to version 3.04. (markt)
- Add Czech translations to Apache Tomcat. Includes contributions from Arnošt Havelka and Alice. (markt)
- Expand the coverage and quality of the Spanish translations provided with Apache Tomcat. Includes contributions from Ulises Gonzalez Horta. (markt)
- Expand the coverage and quality of the French translations provided with Apache Tomcat. (remm)
- Expand the coverage and quality of the Korean translations provided with Apache Tomcat. (woonsan)
- Expand the coverage and quality of the Japanese translations provided with Apache Tomcat. Includes contributions from Yujiorama. (markt)
- Expand the coverage and quality of the Chinese translations provided with Apache Tomcat. Includes contributions from zheng. (markt)
- Expand the coverage and quality of the Russian translations provided with Apache Tomcat. (kkolinko)

### not released Tomcat 9.0.15 (markt)

#### Catalina

- 54741: Add a new method, `Tomcat.addWebapp(String,URL)`, that allows a web application to be deployed from a URL when using Tomcat in embedded mode. (markt)
- 63002: Fix setting rewrite qsdiscard flag. (remm)
- Implement the requirements of section 8.2.2 2c of the Servlet specification and prevent a web application from deploying if it has fragments with duplicate names and is configured to use relative ordering of fragments. (markt)
- Ensure that the HEAD response is consistent with the GET response when `HttpServlet` is relied upon to generate the HEAD response and the GET response uses chunking. (markt)
- Ensure that the `ServletOutputStream` implementation is consistent with the requirements of asynchronous I/O and that all of the write methods use a single write rather than multiple writes. (markt)
- Correct the Javadoc for `Context.getDocBase()` and `Context.setDocBase()` and remove text that indicates that a URL may be used for the `docBase` as this has not been the case for quite some time. (markt)
- Add basic health check valve. (remm)
- Correct a bug exposed in 9.0.14 and ensure that the Tomcat terminates in a timely manner when running as a service. (markt)
- Log a message when using a Connector that requires Apr without enabling the AprLifecycleListener first. (csutherl)
- Utility thread count for special negative or zero values will again be based on Runtime.getRuntime().availableProcessors(). (remm)
- Treat I/O errors during request body reads the same way as I/O errors during response body writes. The errors are treated as client side errors rather than server side errors and only logged at debug level. (markt)
- 63038: Ensure that a `ClassNotFoundException` is thrown when attempting to load a class from a corrupted JAR file. (markt)
- 63078: Ensure the utility thread pool is at least two, as the deployer uses a blocking pattern. (remm, markt)
- Make the removal of leading and trailing whitespace from credentials passed to BASIC authentication configurable via a new attribute, `trimCredentials` on the `BasicAuthenticator`. (markt)
- 63003: Extend the `unloadDelay` attribute on a `Context` to include in-flight asynchronous requests. (markt)
- 63026: Add a new attribute, `forceDnHexEscape`, to the `JNDIRealm` that forces escaping in the String representation of a distinguished name to use the `\nn` form. This may avoid issues with realms using Active Directory which appears to be more tolerant of optional escaping when the `\nn` form is used. (markt)
- Avoid a swallowed (and therefore ignored) access failure during web application class loading when running under a `SecurityManager`. (markt)
- Add SSL configuration options to the JMX remote listener using the `SSLHostConfig` framework. (remm)
- Update the recommended minimum Tomcat Native version to 1.2.21. (markt)
- 63137: If the resources for a web application have been configured with multiple locations mapped to `/WEB-INF/classes`, ensure that all of those locations are used when building the web application class path. Patch provided by Marcin Gołębski. (markt)

#### Coyote

- 63009: Include the optional `content-length` header in HTTP/2 responses where an appropriate value is available. (markt)
- 63022: Do not use the socket open state when using the wrapper isClosed method for NIO and NIO2, as it will disable all further processing. (remm)
- Fix socket close discrepancies for NIO2, now the wrapper close is used everywhere except for socket accept problems. (remm)
- Fix use of write timeout instead of read timeout for HTTP/2 NIO2 frame read. (remm)
- Fix incorrect APR sendfile thread stop. (remm)

#### Jasper

- 63056: Correct a regression in the fix for 53737 that did not correctly scan the web application directory structure for JSPs. (markt)
- Update the performance optimisation for using expressions in tags that depend on uninitialised tag attributes with implied scope to make the performance optimisation aware of the new public class (`java.lang.Enum$EnumDesc`) added in Java 12. (markt)

#### WebSocket

- 57974: Ensure implementation of `Session.getOpenSessions()` returns correct value for both client-side and server-side calls. (markt)
- 63019: Use payload remaining bytes rather than limit when writing. Submitted by Benoit Courtilly. (remm)
- When running under a `SecurityManager`, ensure that the `ServiceLoader` look-up for the default `javax.websocket.server.ServerEndpointConfig.Configurator` implementation completes correctly rather than silently using the hard-coded fall-back. (markt)
- Ensure that the network connection is closed if the client receives an I/O error trying to communicate with the server. (markt)
- Ignore synthetic methods when scanning POJO methods. (markt)
- Implement the requirements of section 5.2.1 of the WebSocket 1.1 specification and ensure that if the deployment of one Endpoint fails, no Endpoints are deployed for that web application. (markt)
- Implement the requirements of section 4.3 of the WebSocket 1.1 specification and ensure that the deployment of an Endpoint fails if `@PathParam` is used with an invalid parameter type. (markt)
- Ensure a `DeploymentException` rather than an `IllegalArgumentException` is thrown if a method annotated with `@OnMessage` does not conform to the requirements set out in the Javadoc. (markt)
- Improve algorithm that determines if two `@OnMessage` annotations have been added for the same message type. Prior to this change some matches were missed. (markt)

#### Web applications

- 63103: Remove the unused source.jsp file and associated tag from the examples web application as it is no longer used. (markt)

#### Tribes

- Add dns-ping support to enumerate cluster members. This is much simpler than getting the pod list but it does not indicate pod status. Submitted by Maxime Beck. (remm)
- Never expire the local member from a Membership. (remm)

#### Other

- Update container image with monitoring contraptions. (remm)
- Expand the coverage and quality of the Korean translations provided with Apache Tomcat. Includes contributions from woonsan and Chris Cho. (markt)
- Expand the coverage and quality of the Japanese translations provided with Apache Tomcat. Includes contributions from kfujino, Yujiorama and motohashi.yuki. (markt)
- Expand the coverage and quality of the French translations provided with Apache Tomcat. Includes contributions from remm, Ludovic Pénet and evernat. (markt)
- Expand the coverage and quality of the German translations provided with Apache Tomcat. Includes contributions from fschumacher, Stefan and burghard. (markt)
- Expand the coverage and quality of the Chinese (simplified) translations provided with Apache Tomcat. Includes contributions from winsonzhao, Lanranzi, shawn, Winsonzhoa, JinXiqian, RichardHo, qingshi huang, Greenman0007, Jim Ma, huxing, 袁宇杰 and evernat. (markt)
- Expand the coverage and quality of the Spanish translations provided with Apache Tomcat. Includes contributions from Ulises Gonzalez Horta, Israel, Eduardo Quintanilla and Miguel Ortega. (markt)
- Expand the coverage and quality of the Russian translations provided with Apache Tomcat. Includes contributions from Andrei Maiseyenka and solomax. (markt)
- Expand the coverage and quality of the Brazilian Portuguese translations provided with Apache Tomcat. Includes contributions from Victor Caetano and Dabilo. (markt)
- 63041: Correct a regression in the fix for 53930 that prevented Tomcat from working correctly with systemd. Patch provided by Patrik S. (markt)
- <fix>63072</fix>: Remove extras (JMX remote listener and webservices object factories) and merge them back into the core build. (remm)
- Update the internal fork of Apache Commons FileUpload to pick up the changes in the Apache Commons FileUpload 1.4 release. (markt)
- Update the internal fork of Apache Commons DBCP 2 to de20b77 (2019-01-29) to pick up some bug fixes and enhancements. (markt)
- Update the packaged version of the Tomcat Native Library to 1.2.21 to pick up the memory leak fixes when using NIO/NIO2 with OpenSSL. (markt)

### 2018-12-12 Tomcat 9.0.14 (markt)

#### Catalina

- 62788: Add explicit logging configuration to write log files using UTF-8 to align with Tomcat's use of UTF-8 by default elsewhere. (markt)
- The default Servlet should not override a previously set content-type. (remm)
- Fix storeconfig for the cluster encryption interceptor key attribute. (remm)
- Add a scheduled executor to the Server, which can be used to process periodic utility tasks. The utility threads are non daemon by default. (remm)
- Refactor container background processor using the Server executor, and add monitoring to reschedule it in case of an unexpected error. (remm)
- Refactor parallel deployment threads using the Server executor. (remm)
- Introduce a ConfigurationSource API to standardize access to the core configuration resources of Tomcat. (remm)
- Update the Tomcat embedded API by allowing to set a configuration source, which will allow processing of core configuration. (remm)
- Refactor processing of server.xml, web.xml, context.xml, other configuration files and resources using the ConfigurationSource API. JASPIC persistent providers load and store remains file based. StoreConfig Tomcat configuration files storing remains file based at their previous default locations. (remm)
- 62897: Provide a property (`clearReferencesThreadLocals`) on the standard `Context` implementation that enables the check for memory leaks via `ThreadLocal`s to be disabled because this check depends on the use of an API that has been deprecated in later versions of Java. (markt)
- Fix more storeconfig issues with duplicated SSL attributes. (remm)
- 62924: Fix file descriptor leak introduced in the code that monitors `tomcat-users.xml` for modifications. (markt)
- Add periodic event notification for lifecycle listeners configured on the Server. (remm)
- 62968: Avoid unnecessary (and relatively expensive) `getResources()` call in the Mapper when processing rule 7. (markt)
- Update the recommended minimum Tomcat Native version to 1.2.19. (markt)
- 62978: Update the RemoteIpValve to handle multiple values in the `x-forwarded-proto` header. Patch provided by Tom Groot. (markt)
- Update the RemoteIpFilter to handle multiple values in the `x-forwarded-proto` header. Based on a patch provided by Tom Groot. (markt)
- 62986: Refactor the code that performs class scanning during web application start to make integration simpler for downstream users. Patch provided by rmannibucau. (markt)
- Filter out tomcat-web.xml from the watched resources list in storeconfig. (remm)
- 62988: Fix the `LoadBalancerDrainingValve` so it works when the session cookie configuration is not explicitly declared. Based on a patch provided by Andreas Kurth. (markt)

#### Coyote

- Refactor connector async timeout threads using a scheduled executor. (remm)
- Avoid using a dedicated thread for accept on the NIO2 connector, it is always less efficient. (remm)
- Load SSL configuration resources for JSSE using the ConfigurationSource API. OpenSSL use requires actual files. (remm)
- 62899: Prevent the incorrect timing out of connections when Servlet non-blocking I/O is used to read a request body over an HTTP/2 stream. (markt)
- Avoid bad SSLHostConfig JMX registrations before init. (remm)
- Avoid a potential hang when a client connects using TLS 1.0 to a Tomcat HTTPS connector configured to use NIO or NIO2 with OpenSSL 1.1.1 or later. (markt)

#### Jasper

- Update the Eclipse Compiler for Java to 4.9. Additional patch by Lukasz Jader. (markt)
- 53737: Extend JspC, the precompilation tool, to include support for resource JARs. (markt)
- 62976: Avoid an `IllegalStateException` when using background compilation when tag files are packaged in JAR files. (markt)

#### Web applications

- 53553: Add the ability to specify a context.xml from the server to use when uploading a web application for deployment with the Manager web application. Patch provided by Anton Lindström. (markt)
- 62918: Filter out subtype mbeans to avoid breaking the connector status page. (remm)
- Unify letter case of the word 'How-To' in the webapps (csutherl)

#### Tribes

- Refactor various operations performed in tribes using a scheduled executor. When tribes is not running standalone, it will use the executor from the Catalina Server. If running independently, the Channel will provide the executor. (remm)
- Make EncryptInterceptor thread-safe. This makes this interceptor actually usable. (schultz/markt)
- Add support for GCM mode to EncryptInterceptor. (schultz)

#### Other

- Prevent an error when running in a Cygwin shell and the `JAVA_ENDORSED_DIRS` system property is empty. Patch provided by Zemian Deng. (markt)
- Expand the coverage and quality of the French translations provided with Apache Tomcat. Includes contributions from remm, soliplaya, Ludovic Pénet, David, NicolasG and bdelacretaz. (markt)
- Add Simplified Chinese translations to the translations to Apache Tomcat. Includes contributions from Darren Luo, syseal, Winsonzhao, 袁宇杰, Lanranzi, ZhangJieWen, Jerry, yinzhili001, 安柏诚, shawn, lavender, Zheng Feng, zengwc, RichardHo, mm, gingshi huang, Bob, geekwang, zheng, Deanzhg, Tianfengjingjing, Panblack, oking, Dave Newman, Cnfnss, Jim Ma, 852394875, huxing and Greenman0007. (markt)
- Add Korean translations to Apache Tomcat. Includes contributions from woonsan, JunSang Park, song choe and OhChan. (markt)
- Expand the coverage and quality of the Spanish translations provided with Apache Tomcat. Includes contributions from Ulises Gonzalez Horta, Israel, Eduardo Quintanilla and Miguel suarez. (markt)
- Expand the coverage and quality of the Russian translations provided with Apache Tomcat. Includes contributions from solomax, Rafael Sachakov and Andrei Maiseyenka. (markt)
- Expand the coverage and quality of the German translations provided with Apache Tomcat. Includes contributions from Matk80, burghard, Daniel Wehringer and Felix Schumacher. (markt)
- Expand the coverage and quality of the Japanese translations provided with Apache Tomcat. Includes contributions from Yujiorama, motohashi.yuki and kfujino. (markt)
- Add Brazilian Portuguese translations to Apache Tomcat. Includes contributions from geraldo netto. (markt)
- Include Brazilian Portuguese translations in the standard Tomcat distribution. (markt)
- Include Simplified Chinese translations in the standard Tomcat distribution. (markt)
- Include Korean translations in the standard Tomcat distribution. (markt)
- Add a packaging method for Tomcat using Maven, as well as a container build file for it. (remm)
- Add XML Namespace to the project element of all POM files so that the XML files are Well Formed and Valid. (csutherl)
- 53930: Add support for the `CATALINA_OUT_CMD` environment variable that defines a command to which captured stdout and stderr will be redirected. Patch provided by Casey Lucas. (markt)
- Update the packaged version of the Tomcat Native Library to 1.2.19 to pick up the latest Windows binaries built with APR 1.6.5 and OpenSSL 1.1.1a. (markt)
- Add i18n to many strings that lacked it. (remm)

### 2018-11-07 Tomcat 9.0.13 (markt)

#### Catalina

- 58590: Add the ability for a UserDatabase to monitor the backing XML file for changes and reload the source file if a change in the last modified time is detected. This is enabled by default meaning that changes to `$CATALINA_BASE/conf/tomcat-users.xml` will now take effect a short time after the file is saved. (markt)
- 61171: Add the `portOffset` attribute to the `Server` element which is added to the configured shutdown and `Connector` ports. Based on a patch by Marek Czernek. (markt)
- 61692: Add the ability to control which HTTP methods are handled by the CGI Servlet via a new initialization parameter `cgiMethods`. (markt)
- 62687: Expose content length information for resources when using a compressed war. (remm)
- 62737: Fix rewrite substitutions parsing of {} nesting. (remm)
- Add rewrite flags output when getting the rewrite configuration back. (remm)
- Add missing qsdiscard flag to the rewrite flags as a cleaner way to discard the query string. (remm)
- 62755: Add ability to opt out of adding the default web.xml config when embedding Tomcat and adding a context via `addWebapp()`. Call `setAddDefaultWebXmlToWebapp(false)` to prevent the automatic config. (isapir)
- Add documentation about the files `context.xml.default` and `web.xml.default` that can be used to customize `conf/context.xml` and `conf/web.xml` on a per host basis. (fschumacher)
- Ensure that a canonical path is always used for the docBase of a Context to ensure consistent behaviour. (markt)
- 62803: Fix SSL connector configuration processing in storeconfig. (remm)
- 62797: Pass throwable to keep client aborts with status 200 rather than 500. Patch submitted by zikfat. (remm)
- 62802: Restore the `appContextProtection` attribute to the `JreMemoryLeakPreventionListener` as application code may still trigger this memory leak. (markt)
- 62809: Correct a regression in the implementation of DIGEST authentication support for the Deployer Ant tasks (bug 45832) that prevented the `DeployTask` from working when authentication was required. (markt)
- Update the recommended minimum Tomcat Native version to 1.2.18. (markt)
- Ignore an attribute named `source` on `Context` elements provided by `StandardContext`. This is to suppress warnings generated by the Eclipse / Tomcat integration provided by Eclipse. Based on a patch by mdfst13. (markt)
- 62830: Added `JniLifeCycleListener` and static methods `Library.loadLibrary(libraryName)` and `Library.load(filename)` to load a native library by a shared class loader so that more than one Webapp can use it. (isapir)
- Refactor the `Connector` so that the port is obtained from the `Endpoint` rather than a local field that could end up out of sync. (markt)
- Correct a typo in the Spanish resource files. Patch provided by Diego Agulló. (markt)
- 62868: Order the `Enumeration<URL>` provided by `WebappClassLoaderBase.getResources(String)` according to the setting of the delegate flag. (markt)

#### Coyote

- Add TLSv1.3 to the default protocols and to the `all` alias for JSSE based TLS connectors when running on a JVM that supports TLS version 1.3. One such JVM is OpenJDK version 11. (rjung)
- 62685: Correct an error in host name validation parsing that did not allow a fully qualified domain name to terminate with a period. Patch provided by AG. (markt)
- Make PEM file parser a public utility class. (remm)
- 62739: Do not reject requests with an empty HTTP Host header. Such requests are unusual but not invalid. Patch provided by Michael Orr. (markt)
- 62748: Add TLS 1.3 support for the APR/Native connector and the NIO/NIO2 connector when using the OpenSSL backed JSSE implementation. (schultz/markt)
- 62791: Remove an unnecessary check in the NIO TLS implementation that prevented from secure WebSocket connections from being established. (markt)
- Fix server initiated TLS renegotiation to obtain a client certificate when using NIO/NIO2 and the OpenSSL backed JSSE TLS implementation. (markt)
- Ensure open sockets etc. are cleaned up if the socket binding process fails. (markt)
- 62871: Improve MBeans for Endpoint instances (type `ThreadPool` in JMX) by using explicit declaration of attributes and operations rather than relying on introspection. Add a new MBean to expose the `Socketproperties` values. (markt)

#### Jasper

- Correct parsing of XML whitespace in TLD function signatures that incorrectly only looked for the space character. (markt)
- 62674: Correct a regression in the stand-alone JSP compiler utility, `JspC`, caused by the fix for 53492, that caused the JSP compiler to hang. (markt)
- 62721: Correct generation of web.xml header when using JspC. (markt)
- 62757: Correct a regression in the fix for 62603 that caused `NullPointerException`s when compiling tag files on first access when development mode was disabled and background compilation was enabled. Based on a patch by Jordi Llach. (markt)

#### WebSocket

- 62731: Make the URI returned by `HandshakeRequest.getRequestURI()` and `Session.getRequestURI()` absolute so that the scheme, host and port are accessible. (markt)

#### Web applications

- 62676: Expand the CORS filter documentation to make it clear that explicit configuration is required to enable support for cross-origin requests. (markt)
- 62712: Correct NPE in Manager application when attempting to view configured certificates for an APR/native TLS connector. (markt)
- 62761: Correct the advanced CORS example in the Filter documentation to use a valid configuration. (markt)
- 62786: Add a note to the Context documentation to explain that, by default, settings for a Context element defined in server.xml will be overwritten by settings specified in a default context file such as `conf/context.xml`. (markt)
- Create a little visual separation between the Undeploy button and the other buttons in the Manager application. Patch provided by Łukasz Jąder. (markt)

#### Tribes

- Add `setMembershipService` method to the `MembershipProvider`. (kfujino)
- Experimental Kubernetes aware cloud membership provider, based on code by Maxime Beck. Contains code derived from jgroups. (remm/kfujino)
- Move the event notification `ThreadPoolExecutor` to `MembershipProviderBase`. (kfujino)
- Even if all members have already disappeared and PING can not be sent, ensure that members will be expired. (kfujino)
- Ensure that remove the member from suspect list when member added. (kfujino)
- Add EncryptInterceptor to the portfolio of available clustering interceptors. This adds symmetric encryption of session data to Tomcat clustering regardless of the type of cluster manager or membership being used. (schultz)

#### Other

- Port DBCP transaction synchronization registry fix (commit d49d45e). (remm)
- Update the internal fork of Apache Commons Pool 2 to d4e0e88 (2018-09-12) to pick up some bug fixes and enhancements. (markt)
- 62705: Added a fail fast check for minimum required Apache Ant version 1.9.8 when building Tomcat. (isapir)
- Added ant target ide-intellij to create an IntelliJ IDEA project. (isapir)
- Utility JSON parser generated from a public domain javacc grammar written by Robert Fischer. (remm)
- Update the packaged version of the Tomcat Native Library to 1.2.18 to pick up the latest Windows binaries built with APR 1.6.5 and OpenSSL 1.1.1. (markt)

### 2018-09-10 Tomcat 9.0.12 (markt)

#### Catalina

- Improve the handling of path parameters when working with RequestDispatcher objects. (markt)
- 62664: Process requests with content type `multipart/form-data` to servlets with a `@MultipartConfig` annotation regardless of HTTP method. (markt)
- 62667: Add recursion to rewrite substitution parsing. (remm)
- 62669: When using the SSIFilter and a resource does not specify a content type, do not force the content type to `application/x-octet-stream`. (markt)
- 62670: Adjust the memory leak protection for the `DriverManager` so that JDBC drivers located in `$CATALINA_HOME/lib` and `$CATALINA_BASE/lib` are loaded via the service loader mechanism when the protection is enabled. (markt)
- When generating a redirect to a directory in the Default Servlet, avoid generating a protocol relative redirect. (markt)

#### Coyote

- Fix potential deadlocks when using asynchronous Servlet processing with HTTP/2 connectors. (markt)
- 62620: Fix corruption of response bodies when writing large bodies using asynchronous processing over HTTP/2. (markt)
- 62628: Additional fixes for output corruption of response bodies when writing large bodies using asynchronous processing over HTTP/2. (markt)
- Support for Netware in the `org.apache.tomcat.jni` package has been removed as there has not been a supported Netware platform for a number of years. (markt)

#### Jasper

- Correct the JSP version in the X-PoweredBy HTTP header generated when the xpoweredBy option is enabled. (markt)
- 62662: Fix the corruption of web.xml output during JSP compilation caused by the fix for 53492. Patch provided by Bernhard Frauendienst. (markt)

#### Web applications

- Expand the information in the documentation web application regarding the use of `CATALINA_HOME` and `CATALINA_BASE`. Patch provided by Marek Czernek. (markt)
- 62652: Make it clearer that the version of DBCP that is packaged in Tomcat 9.0.x is DBCP 2. Correct the names of some DBCP 2 configuration attributes that changed between 1.x and 2.x. (markt)
- 62666: Expand internationalisation support in the Manager application to include the server status page and provide Russian translations in addition to English. Patch provided by Artem Chebykin. (markt)

#### Other

- Switch the build script to use http for downloads from an ASF mirror using the closer.lua script to avoid failures due to HTTPS to HTTP redirects. (rjung)

### 2018-08-17 Tomcat 9.0.11 (markt)

#### Catalina

- Make the `isLocked()` method of the `LockOutRealm` public and expose the method via JMX. (markt)
- 53387: Add support for regular expression capture groups to the SSI servlet and filter. (markt)
- 53411: Improve the handling of HTTP requests that do not explicitly specify a host name when no default host is configured. Also improve the tracking of changes to the default host as hosts are added and removed while Tomcat is running. (markt)
- Ensure that the HTTP Vary header is set correctly when using the CORS filter and improve the cacheability of requests that pass through the COPRS filter. (markt)
- 62527: Revert restriction of JNDI to the `java:` namespace. (remm)
- Introduce a new class - `MultiThrowable` - to report exceptions when multiple actions are taken where each action may throw an exception but all actions are taken before any errors are reported. Use this new class when reporting multiple container (e.g. web application) failures during start. (markt)
- Correctly decode URL paths (`+` should not be decoded to a space in the path) in the `RequestDispatcher` and the web application class loader. (markt)
- Make logout more robust if JASPIC subject is unexpectedly unavailable. (markt)
- 62547: JASPIC `cleanSubject()` was not called on logout when the authenticator was configured to cache the authenticated Principal. Patch provided by Guillermo González de Agüero. (markt)
- 62559: Add `jaxb-*.jar` to the list of JARs ignored by `StandardJarScanner`. (markt)
- 62560: Add `oraclepki.jar` to the list of JARs ignored by `StandardJarScanner`. (markt)
- 62607: Return a non-zero exit code from `catalina.[bat|sh] run` if Tomcat fails to start. (markt)
- Use short circuit logic to prevent potential NPE in CorsFilter. (fschumacher)
- Simplify construction of appName from container name in JAASRealm. (fschumacher)
- Remove `ServletException` from declaration of `Tomcat.addWebapp(String,String)` since it is never thrown. Patch provided by Tzafrir. (markt)

#### Coyote

- Refactor HTTP date creation and parsing to reduce code duplication, reduce the use of ThreadLocals and to increase the use of caching. (markt)
- 56676: Add a default location for the native library, as ${catalina.home}/bin, which the testsuite already uses. (remm)
- 60560: Add support for using an inherited channel to the NIO connector. Based on a patch submitted by Thomas Meyer with testing and suggestions by Coty Sutherland. (remm)
- 62507: Ensure that JSSE based TLS connectors work correctly with a DKS keystore. (markt)
- Refactor code that adds an additional header name to the `Vary` HTTP response header to use a common utility method that addresses several additional edge cases. (markt)
- 62515: When a connector is configured (via setting `bindOnInit` to `false`) to bind/unbind the server socket during start/stop, close the socket earlier in the stop process so new connections do not sit in the TCP backlog during the shutdown process only to be dropped as stop completes. In this scenario new connections will now be refused immediately. (markt)
- 62526: Correctly handle PKCS12 format key stores when the key store password is configured to be the empty string. (markt)
- 62605: Ensure `ReadListener.onDataAvailable()` is called when the initial request body data arrives after the request headers when using asynchronous processing over HTTP/2. (markt)
- 62614: Ensure that `WriteListener.onWritePossible()` is called after `isReady()` returns `false` and the window size is subsequently incremented when using asynchronous processing over HTTP/2. (markt)

#### Jasper

- 53492: Make the Java file generation process multi-threaded. By default, one thread will be used per core. Based on a patch by Dan Fabulich. (markt)
- 62453: Add a performance optimisation for using expressions in tags that depend on uninitialised tag attributes with implied scope. Generally, using an explicit scope with tag attributes in EL is the best way to avoid various potential performance issues. (markt)
- Correctly decode URL paths (`+` should not be decoded to a space in the path) in the Jasper class loader. (markt)
- 62603: Fix a potential race condition when development mode is disabled and background compilation checks are enabled. It was possible that some updates would not take effect and/or `ClassNotFoundException`s would occur. (markt)

#### WebSocket

- 62596: Remove the limit on the size of the initial HTTP upgrade request used to establish the web socket connection. (markt)

#### Web applications

- 62558: Add Russian translations for the Manager and Host Manager web applications. Based on a patch by Ivan Krasnov. (markt)
- Add documents for Static Membership service. (kfujino)
- 62561: Add advanced class loader configuration information regarding the use of the Server and Shared class loaders to the documentation web application. (markt)

#### Tribes

- Ensures that the specified `rxBufSize` is correctly set to receiver buffer size. (kfujino)
- Correct the stop order of the Channel components. It stops in the reverse order to that at startup. (kfujino)
- Added new StaticMembership implementation. This implementation does not require any additional configuration of other `ChannelInterceptors`. It works only with membership service. (kfujino)

#### Other

- Support building with Java 9+ while preserving the Java 8 compatibility at runtime (requires Ant 1.9.8 or later). (ebourg)
- Update WSDL4J library to version 1.6.3 (from 1.6.2). (kkolinko)
- Update JUnit library to version 4.12 (from 4.11). (kkolinko)
- Downgrade CGLib library used for testing with EasyMock to version 2.2.2 (from 2.2.3) as version 2.2.3 is not available from Maven Central. (markt)
- Implement checksum checks when downloading dependencies that are used to build Tomcat. (kkolinko)
- Fixed spelling. Patch provided by Jimmy Casey via GitHub. (violetagg)
- Update the internal fork of Apache Commons Pool 2 to 3e02523 (2018-08-09) to pick up some bug fixes and enhancements. (markt)
- Update the internal fork of Apache Commons DBCP 2 to abc0484 (2018-08-09) to pick up some bug fixes and enhancements. (markt)
- Correct various spelling errors throughout the source code and documentation. Patch provided by Kazuhiro Sera. (markt)

### 2018-06-25 Tomcat 9.0.10 (markt)

#### Catalina

- 62476: Use GMT timezone for the value of `Expires` header as required by HTTP specification (RFC 7231, 7234). (kkolinko)

### not released Tomcat 9.0.9 (markt)

#### Catalina

- Treat the `<mapped-name>` element of a `<env-entry>` in web.xml in the same way as the `mappedName` element of the equivalent `@Resource` annotation. Both now attempt to set the `mappedName` property of the resource. (markt)
- Correct the processing of resources with `<injection-target>`s defined in web.xml. First look for a match using JavaBean property names and then, only if a match is not found, look for a match using fields. (markt)
- When restoring a saved request with a request body after FORM authentication, ensure that calls to the `HttpServletRequest` methods `getRequestURI()`, `getQueryString()` and `getProtocol()` are not corrupted by the processing of the saved request body. (markt)
- JNDI resources that are defined with injection targets but no value are now treated as if the resource is not defined. (markt)
- Ensure that JNDI names used for `<lookup-name>` entries in web.xml and for `lookup` elements of `@Resource` annotations specify a name with an explicit `java:` namespace. (markt)
- 50019: Add support for `<lookup-name>`. Based on a patch by Gurkan Erdogdu. (markt)
- Add the `AuthenticatedUserRealm` for use with CLIENT-CERT and SPNEGO when just the authenticated user name is required. (markt)
- 50175: Add a new attribute to the standard context implementation, `skipMemoryLeakChecksOnJvmShutdown`, that allows the user to configure Tomcat to skip the memory leak checks usually performed during web application stop if that stop is triggered by a JVM shutdown. (markt)
- 51497: Add an option, `ipv6Canonical`, to the `AccessLogValve` that causes IPv6 addresses to be output in canonical form defined by RFC 5952. (ognjen/markt)
- 51953: Add the `RemoteCIDRFilter` and `RemoteCIDRValve` that can be used to allow/deny requests based on IPv4 and/or IPv6 client address where the IP ranges are defined using CIDR notation. Based on a patch by Francis Galiegue. (markt)
- 62343: Make CORS filter defaults more secure. This is the fix for CVE-2018-8014. (markt)
- Ensure that the web application resources implementation does not incorrectly cache results for resources that are only visible as class loader resources. (markt)
- 62387: Do not log a warning message if the file based persistent session store fails to delete the file for a session when the session is invalidated because the file has not been created yet. (markt)
- Make all loggers associated with Tomcat provided Filters non-static to ensure that log messages are not lost when a web application is reloaded. (markt)
- Correct the manifest for the annotations-api.jar. The JAR implements the Common Annotations API 1.3 and the manifest should reflect that. (markt)
- Switch to non-static loggers where there is a possibility of a logger becoming associated with a web application class loader causing log messages to be lost if the web application is stopped. (markt)
- 62389: Add the IPv6 loopback address to the default `internalProxies` regular expression. Patch by Craig Andrews. (markt)
- In the `RemoteIpValve` and `RemoteIpFilter`, correctly handle the case when the request passes through one or more `trustedProxies` but no `internalProxies`. Based on a patch by zhanhb. (markt)
- Correct the logic in `MBeanFactory.removeConnector()` to ensure that the correct Connector is removed when there are multiple Connectors using different addresses but the same port. (markt)
- Make `JAASRealm` mis-configuration more obvious by requiring the authenticated Subject to include at least one Principal of a type specified by `userClassNames`. (markt)

#### Coyote

- Correct a regression in the error page handling that prevented error pages from issuing redirects or taking other action that required the response status code to be changed. (markt)
- Consistent exception propagation for NIO2 SSL close. (remm)
- Followup sync fix for NIO2 async IO blocking read/writes. (remm)
- Log an error message if the AJP connector detects that the reverse proxy is sending AJP messages that are too large for the configured `packetSize`. (markt)
- Relax Host validation by removing the requirement that the final component of a FQDN must be alphabetic. (markt)
- 62371: Improve logging of Host validation failures. (markt)
- Fix a couple of unlikely edge cases in the shutting down of the APR/native connector. (markt)
- Add missing handshake timeout for NIO2. (remm)
- Correctly handle a digest authorization header when the user name contains an escaped character. (markt)
- Correctly handle a digest authorization header when one of the hex field values ends the header with in an invalid character. (markt)
- Correctly handle an invalid quality value in an `Accept-Language` header. (markt)
- 62423: Fix SSL docs CRL attribute typo. (remm)
- Improve IPv6 validation by ensuring that IPv4-Mapped IPv6 addresses do not contain leading zeros in the IPv4 part. Based on a patch by Katya Stoycheva. (markt)
- Fix `NullPointerException` thrown from `replaceSystemProperties()` when trying to log messages. (csutherl)
- Avoid unnecessary processing of async timeouts. (markt)

#### Jasper

- 50234: Add the capability to generate a web-fragment.xml file to JspC. (markt)
- 62080: Ensure that all reads of the current thread's context class loader made by the UEL API and implementation are performed via a `PrivilegedAction` to ensure that a `SecurityException` is not triggered when running under a `SecurityManager`. (mark)
- 62350: Refactor `org.apache.jasper.runtime.BodyContentImpl` so a `SecurityException` is not thrown when running under a SecurityManger and additional permissions are not required in the `catalina.policy` file. This is a follow-up to the fix for 43925. (kkolinko/markt)
- Enable JspC from Tomcat 9 to work with Maven JspC compiler plug-ins written for Tomcat 8.5.x. Patch provided by Pavel Cibulka. (markt)
- Update web.xml, web-fragment.xml and web.xml extracts generated by JspC to use the Servlet 4.0 version of the relevant schemas. (markt)

#### Cluster

- Remove duplicate calls when creating a replicated session to reduce the time taken to create the session and thereby reduce the chances of a subsequent session update message being ignored because the session does not yet exist. (markt)
- Add the method to send a message with a specified sendOptions. (kfujino)
- When sending the `GET_ALL_SESSIONS` message, make sure that sends with asynchronous option in order to avoid ack timeout. Waiting to receive the `ALL_SESSION_DATA` message should be done with `waitForSendAllSessions` instead of ACK. (kfujino)

#### WebSocket

- Use NIO2 API for websockets writes. (remm)
- When decoding of path parameter failed, make sure to throw `DecodeException` instead of throwing `ArrayIndexOutOfBoundsException`. (kfujino)
- Improve the handling of exceptions during TLS handshakes for the WebSocket client. (markt)
- Enable host name verification when using TLS with the WebSocket client. (markt)

#### Web applications

- 62395: Clarify the meaning of the connector attribute `minSpareThreads` in the documentation web application. (markt)
- Correct the documentation for the `allowHostHeaderMismatch` attribute of the standard HTTP Connector implementations. (markt)

#### Tribes

- Ensure that the correct default value is returned when retrieve unset properties in `McastService`. (kfujino)
- Make `MembershipService` more easily extensible. (kfujino)

#### jdbc-pool

- When `logValidationErrors` is set to true, the connection validation error is logged as `SEVERE` instead of `WARNING`. (kfujino)

#### Other

- Ensure that Apache Tomcat may be built from source with Java 11. (markt)
- 52381: Add OSGi metadata to JAR files. (markt)
- 62391: Remove references to `javaw.exe` as this file is not required by Tomcat and the references prevent the use of the Server JRE. (markt)
- Update the packaged version of the Tomcat Native Library to 1.2.17 to pick up the latest Windows binaries built with APR 1.6.3 and OpenSSL 1.0.2o. (markt)
- 62458: Update the internal fork of Commons Pool 2 to dfef97b (2018-06-18) to pick up some bug fixes and enhancements. (markt)
- Update the internal fork of Commons DBCP 2 to 2.4.0. (markt)

### 2018-05-03 Tomcat 9.0.8 (markt)

#### Catalina

- 62263: Avoid a `NullPointerException` when the `RemoteIpValve` processes a request for which no Context can be found. (markt)
- 62258: Don't trigger the standard error page mechanism when the error has caused the connection to the client to be closed as no-one will ever see the error page. (markt)
- Register MBean when DataSource Resource `type="javax.sql.XADataSource"`. Patch provided by Masafumi Miura. (csutherl)
- Fix a rare edge case that is unlikely to occur in real usage. This edge case meant that writing long streams of UTF-8 characters to the HTTP response that consisted almost entirely of surrogate pairs could result in one surrogate pair being dropped. (markt)
- Update the internal fork of Apache Commons BCEL to r1829827 to add early access Java 11 support to the annotation scanning code. (markt)
- 62297: Enable the `CrawlerSessionManagerValve` to correctly handle bots that crawl multiple hosts and/or web applications when the Valve is configured on a Host or an Engine. (fschumacher)
- 62309: Fix a `SecurityException` when using JASPIC under a `SecurityManager` when authentication is not mandatory. (markt)
- 62329: Correctly list resources in JAR files when directories do not have dedicated entries. Patch provided by Meelis Müür. (markt)
- Collapse multiple leading `/` characters to a single `/` in the return value of `HttpServletRequest#getContextPath()` to avoid issues if the value is used with `HttpServletResponse#sendRedirect()`. This behaviour is enabled by default and configurable via the new Context attribute `allowMultipleLeadingForwardSlashInPath`. (markt)
- Improve handling of overflow in the UTF-8 decoder with supplementary characters. (markt)

#### Coyote

- Correct off-by-one error in thread pool that allowed thread pools to increase in size to one more than the configured limit. Patch provided by usc. (markt)
- Prevent unexpected TLS handshake failures caused by errors during a previous handshake that were not correctly cleaned-up when using the NIO or NIO2 connector with the `OpenSSLImplementation`. (markt)
- 62273: Implement configuration options to work-around specification non-compliant user agents (including all the major browsers) that do not correctly %nn encode URI paths and query strings as required by RFC 7230 and RFC 3986. (markt)
- Fix sync for NIO2 async IO blocking read/writes. (remm)

#### Jasper

- Update the Eclipse Compiler for Java to 4.7.3a. (markt)
- Allow `9` to be used to specify Java 9 as the compiler source and/or compiler target for JSP compilation. The Early Access value of `1.9` is still supported. (markt)
- Add support for specifying Java 10 (with the value `10`) as the compiler source and/or compiler target for JSP compilation. (markt)
- 62287: Do not rely on hash codes to test instances of `ValueExpressionImpl` for equality. Patch provided by Mark Struberg. (markt)

#### WebSocket

- 62301: Correct a regression in the fix for 61491 that didn't correctly handle a final empty message part in all circumstances when using `PerMessageDeflate`. (markt)
- 62332: Ensure WebSocket connections are closed after an I/O error is experienced reading from the client. (markt)

#### Other

- Avoid warning when running under Cygwin when the `JAVA_ENDORSED_DIRS` environment variable is not set. Patch provided by Zemian Deng. (markt)

### 2018-04-07 Tomcat 9.0.7 (markt)

#### Catalina

- 51195: Avoid a false positive report of a web application memory leak by clearing `ObjectStreamClass$Caches` of classes loaded by the web application when the web application is stopped. (markt)
- 52688: Add support for the `maxDays` attribute to the `AccessLogValve` and `ExtendedAccessLogValve`. This allows the maximum number of days for which rotated access logs should be retained before deletion to be defined. (markt)
- Ensure the MBean names for the `SSLHostConfig` and `SSLHostConfigCertificate` are correctly formed when the `Connector` is bound to a specific IP address. (markt)
- 62168: When using the `PersistentManager` honor a value of `-1` for `minIdleSwap` and do not swap out sessions to keep the number of active sessions under `maxActive`. Patch provided by Holger Sunke. (markt)
- 62172: Improve Javadoc for `org.apache.catalina.startup.Constants` and ensure that the constants are correctly used. (markt)
- 62175: Avoid infinite recursion, when trying to validate a session while loading it with `PersistentManager`. (fschumacher)
- Ensure that `NamingContextListener` instances are only notified once of property changes on the associated naming resources. (markt)
- 62224: Disable the `forkJoinCommonPoolProtection` of the `JreMemoryLeakPreventionListener` when running on Java 9 and above since the underlying JRE bug has been fixed. (markt)

#### Coyote

- Avoid potential loop in APR/Native poller. (markt)
- Ensure streams that are received but not processed are excluded from the tracking of maximum ID of processed streams. (markt)
- Refactor the check for a paused connector to consistently prevent new streams from being created after the connector has been paused. (markt)
- Improve debug logging for HTTP/2 pushed streams. (markt)
- The OpenSSL engine SSL session will now ignore invalid accesses. (remm)
- 62177: Correct two protocol errors with HTTP/2 `PUSH_PROMISE` frames. Firstly, the HTTP/2 protocol only permits pushes to be sent on peer initiated requests. Secondly, pushes must be sent in order of increasing stream ID. These restriction were not being enforced leading to protocol errors at the client. (markt)

#### Web applications

- Add document for `FragmentationInterceptor`. (kfujino)
- Document how the roles for an authenticated user are determined when the `CombinedRealm` is used. (markt)
- 62163: Correct the Tomcat Setup documentation that incorrectly referred to Java 7 as the minimum version rather than Java 8. (markt)

#### Tribes

- Add JMX support for `FragmentationInterceptor` in order to prevent warning of startup. (kfujino)

#### jdbc-pool

- Ensure that `SQLWarning` has been cleared when connection returns to the pool. (kfujino)
- Enable clearing of `SQLWarning` via JMX. (kfujino)
- Ensure that parameters have been cleared when `PreparedStatement` and/or `CallableStatement` are cached. (kfujino)
- Enable PoolCleaner to be started even if `validationQuery` is not set. (kfujino)

#### Other

- Update the build script so MD5 hashes are no longer generated for releases as per the change in the ASF distribution policy. (markt)
- 62164: Switch the build script to use TLS for downloads from SourceForge and Maven Central to avoid failures due to HTTP to HTTPS redirects. (markt)
- Always report the OS's umask when launching the JVM. (schultz)
- Add managed connections package to the package renamed DBCP 2 to provide a complete DBCP 2 in Tomcat. (remm)

### 2018-03-08 Tomcat 9.0.6 (markt)

#### Catalina

- 43866: Add additional attributes to the Manager to provide control over which listeners are called when an attribute is added to the session when it has already been added under the same name. This is to aid clustering scenarios where `setAttribute()` is often called to signal that the attribute value has been mutated and needs to be replicated but it may not be required, or even desired, for the associated listeners to be triggered. The default behaviour has not been changed. (markt)
- Minor optimization when calling class transformers. (rjung)
- Pass errors triggered by invalid requests or unavailable services to the application provided error handling and/or the container provided error handling (`ErrorReportValve`) as appropriate. (markt)
- 41007: Add the ability to specify static HTML responses for specific error codes and/or exception types with the `ErrorReportValve`. (markt)
- Prevent Tomcat from applying gzip compression to content that is already compressed with brotli compression. Based on a patch provided by burka. (markt)
- 62090: Null container names are not allowed. (remm)
- 62104: Fix programmatic login regression as the NonLoginAuthenticator has to be set for it to work (if no login method is specified). (remm)
- 62117: Improve error message in `catalina.sh` when calling `kill -0 <pid>` fails. Based on a suggestion from Mark Morschhaeuser. (markt)
- 62118: Correctly create a JNDI `ServiceRef` using the specified interface rather than the concrete type. Based on a suggestion by Ángel Álvarez Páscua. (markt)
- Fix for `RequestDumperFilter` log attribute. Patch provided by Kirill Romanov via Github. (violetagg)
- 62123: Avoid `ConcurrentModificationException` when attempting to clean up application triggered RMI memory leaks on web application stop. (markt)
- When a deployment descriptor is deployed that includes a `path` attribute, log a warning that the `path` attribute will be ignored. (markt)
- When a deployment descriptor is deployed that references an external `docBase` and, as a result, a `docBase` under the `appBase` will be ignored, log a warning. (markt)
- Correct a regression in the fix for 60276 that meant that compression was applied to all MIME types. Patch provided by Stefan Knoblich. (markt)

#### Coyote

- Add async HTTP/2 parser for NIO2. (remm)
- Add minor HPACK fixes, based on fixes by Stuart Douglas. (remm)
- 61751: Follow up fix so that OpenSSL engine returns underflow when unwrapping if no bytes were produced and the input is empty. (remm)
- Minor OpenSSL engine cleanups. (remm)
- NIO SSL handshake should throw an exception on overflow status, like NIO2 SSL. (remm)

#### Web applications

- 47467: When deploying a web application via the manager application and a path is not explicitly specified, derive it from the provided deployment descriptor or, if that is not present, the WAR or DIR. (markt)
- 48672: Add documentation for the Host Manager web application. Patch provided by Marek Czernek. (markt)
- Add support for specifying the application version when deploying an application via the Manager application HTML interface. (markt)
- Work-around a known, non-specification compliant behaviour in some versions of IE that can allow XSS when the Manager application generates a plain text response. Based on a suggestion from Muthukumar Marikani. (markt)

### 2018-02-11 Tomcat 9.0.5 (markt)

#### Catalina

- Prevent a stack trace being written to standard out when running on Java 10 due to changes in the `LogManager` implementation. (markt)
- Avoid duplicate load attempts if one has been made already. (remm)
- Avoid NPE in ThreadLocalLeakPreventionListener if there is no Engine. (remm)
- 62000: When a JNDI reference cannot be resolved, ensure that the root cause exception is reported rather than swallowed. (markt)
- 62036: When caching an authenticated user Principal in the session when the web application is configured with the `NonLoginAuthenticator`, cache the internal Principal object rather than the user facing Principal object as Tomcat requires the internal object to correctly process later authorization checks. (markt)
- Refactor error handling to enable errors that occur before processing is passed to the application to be handled by the application provided error handling and/or the container provided error handling (`ErrorReportValve`) as appropriate. (markt)
- Pass 404 errors triggered by a missing ROOT web application to the container error handling to generate the response body. (markt)
- Pass 400 errors triggered by invalid request targets to the container error handling to generate the response body. (markt)
- Provide a correct `Allow` header when responding to an HTTP `TRACE` request for a JSP with a 405 status code. (markt)
- When using Tomcat embedded, only perform Authenticator configuration once during web application start. (markt)
- 62067: Correctly apply security constraints mapped to the context root using a URL pattern of `""`. (markt)
- Process all `ServletSecurity` annotations at web application start rather than at servlet load time to ensure constraints are applied consistently. (markt)

#### Coyote

- 61751: Fix truncated request input streams when using NIO2 with TLS. (markt)
- 62023: Log error reporting multiple SSLHostConfig elements when using the APR Connector instead of crashing Tomcat. (csutherl)
- 62032: Fix NullPointerException when certificateFile is not defined on an SSLHostConfig and unify the behavior when a certificateFile is defined but the file does not exist for both JKS and PEM file types. (csutherl)
- Ensure that the `toString()` method behaves consistently for `ByteChunk` and `CharChunk` and that `null` is returned when `toString()` is called both on newly created objects and immediately after a call to `recycle()`. This should not impact typical Tomcat users. It may impact users who use these classes directly in their own code. (markt)
- Ensure that the `toString()`, `toBytes()` and `toChars()` methods of `MessageBytes` behave consistently and do not throw a `NullPointerException` both on newly created objects and immediately after a call to `recycle()`. This should not impact typical Tomcat users. It may impact users who use these classes directly in their own code. (markt)
- When processing an HTTP 1.0 request in the HTTP connector and no host information is provided in the request, obtain the server port from the local port rather than the connector configuration since the configured value maybe zero. (markt)
- Enable strict validation of the provided host name and port for all connectors. Requests with invalid host names and/or ports will be rejected with a 400 response. (markt)
- Update the host validation to permit host names and components of domain names (excluding top-level domains) to start with a number and to ensure that top-level domains are fully alphabetic. (markt)
- 62053: Fix NPE when writing push headers with HTTP/2 NIO2. Patch submitted by Holger Sunke. (remm)

#### Jasper

- Include an HTTP `Allow` header when a JSP generates a 405 response due to a request with an unsupported method. (markt)
- Add support for the HTTP `OPTION` method to JSPs. The JSP specification explicitly states that the behaviour for this method is undefined for JSPs so this is a Tomcat specific behaviour. (markt)

#### WebSocket

- 62024: When closing a connection with an abnormal close, close the socket immediately rather than waiting for a close message from the client that may never arrive. (markt)

#### Webapps

- 62049: Fix missing class from manager 404 JSP error page. (remm)

#### jdbc-pool

- Enhance the JMX support for jdbc-pool in order to expose `PooledConnection` and `JdbcInterceptors`. (kfujino)
- Add MBean for `PooledConnection`. (kfujino)
- 62011: Add MBean for `StatementCache`. (kfujino)
- Expose the cache size for each connection via JMX in `StatementCache`. (kfujino)
- Add MBean for `ResetAbandonedTimer`. (kfujino)

#### Other

- Update the list with the public interfaces in the RELEASE-NOTES. (violetagg)
- Update the NSIS Installer used to build the Windows installer to version 3.03. (kkolinko)

### 2018-01-22 Tomcat 9.0.4 (markt)

#### Catalina

- Correct a regression in the previous fix for 61916 that meant that any call to `addHeader()` would have been replaced with a call to `setHeader()` for all requests mapped to the `AddDefaultCharsetFilter`. (markt)
- 61999: maxSavePostSize set to 0 should disable saving POST data during authentication. (remm)

#### Coyote

- Fix NIO2 HTTP/2 sendfile. (remm)
- 61993: Improve handling for `ByteChunk` and `CharChunk` instances that grow close to the maximum size allowed by the JRE. (markt)

#### Jasper

- 43925: Add a new system property (`org.apache.jasper.runtime.BodyContentImpl.BUFFER_SIZE`) to control the size of the buffer used by Jasper when buffering tag bodies. (markt)

#### Web applications

- 62006: Document the new `JvmOptions9` command line parameter for `tomcat9.exe`. (markt)

### not released Tomcat 9.0.3 (markt)

#### Catalina

- 57619: Implement a small optimisation to how JAR URLs are processed to reduce the storage of duplicate String objects in memory. Patch provided by Dmitri Blinov. (markt)
- Add some missing NPEs to ServletContext. (remm)
- Update the Java EE 8 XML schema to the released versions. (markt)
- Minor HTTP/2 push fixes. (remm)
- 61916: Extend the `AddDefaultCharsetFilter` to add a character set when the content type is set via `setHeader()` or `addHeader()` as well as when it is set via `setContentType()`. (markt)
- When using WebDAV to copy a file resource to a destination that requires a collection to be overwritten, ensure that the operation succeeds rather than fails (with a 500 response). This enables Tomcat to pass two additional tests from the Litmus WebDAV test suite. (markt)
- Modify the Default and WebDAV Servlets so that a 405 status code is returned for `PUT` and `DELETE` requests when disabled via the `readonly` initialisation parameter.
- Align the contents of the `Allow` header with the response code for the Default and WebDAV Servlets. For any given resource a method that returns a 405 status code will not be listed in the `Allow` header and a method listed in the `Allow` header will not return a 405 status code. (markt)

#### Coyote

- 60276: Implement GZIP compression support for responses served over HTTP/2. (markt)
- Do not call onDataAvailable without any data to read. (remm)
- Correctly handle EOF when `ServletInputStream.isReady()` is called. (markt)
- 61886: Log errors on non-container threads at `DEBUG` rather than `INFO`. The exception will be made available to the application via the asynchronous error handling mechanism. (markt)
- 61914: Possible NPE with Java 9 when creating an SSL engine. Patch submitted by Evgenij Ryazanov. (remm)
- 61918: Fix connectionLimitLatch counting when closing an already closed socket. Based on a patch by Ryan Fong. (remm)
- Add support for the OpenSSL ARIA ciphers to the OpenSSL to JSSE cipher mapping. (markt)
- 61932: Allow a call to `AsyncContext.dispatch()` to terminate non-blocking I/O. (markt)
- 61948: Improve the handling of malformed ClientHello messages in the code that extracts the SNI information from a TLS handshake for the JSSE based NIO and NIO2 connectors. (markt)
- Fix NIO2 handshaking with a full input buffer. (remm)
- Return a simple, plain text error message if a client attempts to make a plain text HTTP connection to a TLS enabled NIO or NIO2 Connector. (markt)

#### Jasper

- 61854: When using sets and/or maps in EL expressions, ensure that Jasper correctly parses the expression. Patch provided by Ricardo Martin Camarero. (markt)
- Improve the handling of methods with varargs in EL expressions. In particular, the calling of a varargs method with no parameters now works correctly. Based on a patch by Nitkalya (Ing) Wiriyanuparb. (markt)
- 61945: Fix prototype mode used to compile tags. (remm)

#### Web applications

- 61223: Add the mbeans-descriptors.dtd file to the custom MBean documentation so users have a reference to use when constructing mbeans-descriptors.xml files for custom components. (markt)
- 61565: Add the ability to trigger a reloading of TLS host configuration (certificate and key files, server.xml is not re-parsed) via the Manager web application. (markt)
- 61566: Expose the currently in use certificate chain and list of trusted certificates for all virtual hosts configured using the JSSE style (keystore) TLS configuration via the Manager web application. (markt)
- Partial fix for 61886. Ensure that multiple threads do not attempt to complete the `AsyncContext` if an I/O error occurs in the stock ticker example Servlet. (markt)
- 61886: Prevent `ConcurrentModificationException` when running the asynchronous stock ticker in the examples web application. (markt)
- 61886: Prevent `NullPointerException` and other errors if the stock ticker example is running when the examples web application is stopped. (markt)
- 61910: Clarify the meaning of the `allowLinking` option in the documentation web application. (markt)
- Add OCSP configuration information to the SSL How-To. Patch provided by Marek Czernek. (markt)

#### jdbc-pool

- 61312: Prevent `NullPointerException` when using the statement cache of connection that has been closed. (kfujino)

#### Other

- Add an additional system property for the system property replacement. (remm)
- Add missing SHA-512 hash for release artifacts to the build script. (markt)
- Update the internal fork of Commons Pool 2 to 2.4.3. (markt)
- Update the internal fork of Commons DBCP 2 to 8a71764 (2017-10-18) to pick up some bug fixes and enhancements. (markt)
- Update the internal fork of Commons FileUpload to 6c00d57 (2017-11-23) to pick up some code clean-up. (markt)
- Update the internal fork of Commons Codec to r1817136 to pick up some code clean-up. (markt)
- The native source bundles (for Commons Daemon and Tomcat Native) are no longer copied to the bin directory for the deploy target. They are now only copied to the bin directory for the release target. (markt)

### 2017-11-30 Tomcat 9.0.2 (markt)

#### Catalina

- Fix possible `SecurityException` when using TLS related request attributes. (markt)
- 61597: Extend the `StandardJarScanner` to scan JARs on the module path when running on Java 9 and class path scanning is enabled. (markt)
- 61601: Add support for multi-release JARs in JAR scanning and web application class loading. (markt)
- 61681: Allow HTTP/2 push when using request wrapping. (remm)
- Provide the `SessionInitializerFilter` that can be used to ensure that an HTTP session exists when initiating a WebSocket connection. Patch provided by isapir. (markt)
- 61682: When re-prioritising HTTP/2 streams, ensure that both parent and children fields are correctly updated to avoid a possible `StackOverflowError`. (markt)
- Improve concurrency by reducing the scope of the synchronisation for `javax.security.auth.message.config.AuthConfigFactory` in the JASPIC API implementation. Based on a patch by Pavan Kumar. (markt)
- Avoid a possible `NullPointerException` when timing out `AsyncContext` instances during shut down. (markt)
- 61777: Avoid a `NullPointerException` when detaching a JASPIC `RegistrationListener`. Patch provided by Lazar. (markt)
- 61778: Correct the return value when detaching a JASPIC `RegistrationListener`. Patch provided by Lazar. (markt)
- 61779: Avoid a `NullPointerException` when a `null` `RegistrationListener` is passed to `AuthConfigFactory.getConfigProvider()`. Patch provided by Lazar. (markt)
- 61780: Only include the default JASPIC registration ID in the return value for a call to `AuthConfigFactory.getRegistrationIDs()` if a `RegistrationContext` has been registered using the default registration ID. Patch provided by Lazar. (markt)
- 61781: Enable JASPIC provider registrations to be persisted when the layer and/or application context are `null`. Patch provided by Lazar. (markt)
- 61782: When calling `AuthConfigFactory.doRegisterConfigProvider()` and the requested JASPIC config provider class is found by the web application class loader, do not attempt to load the class with the class loader that loaded the JASPIC API. Patch provided by Lazar. (markt)
- 61783: When calling `AuthConfigFactory.removeRegistration()` and the registration is persistent, it should be removed from the persistent store. Patch provided by Lazar. (markt)
- 61784: Correctly handle the case when `AuthConfigFactoryImpl.registerConfigProvider()` is called with a provider name of `null`. Patch provided by Lazar. (markt)
- 61795: Add a property to the `Authenticator` implementations to enable a custom JASPIC `CallbackHandler` to be specified. Patch provided by Lazar. (markt)

#### Coyote

- 61568: Avoid a potential `SecurityException` when using the NIO2 connector and a new thread is added to the pool. (markt)
- 61583: Correct a further regression in the fix to enable the use of Java key stores that contained multiple keys that did not all have the same password. This fixes PKCS11 key store handling with multiple keys selected with an alias. (markt)
- Improve NIO2 syncing for async IO operations. (remm)
- Sendfile support for HTTP/2 and NIO2. (remm)
- Reduce default HTTP/2 stream concurrent execution within a connection from 200 to 20. (remm)
- 61668: Avoid a possible NPE when calling `AbstractHttp11Protocol.getSSLProtocol()`. (markt)
- 61673: Avoid a possible `ConcurrentModificationException` when working with the streams associated with a connection. (markt)
- 61719: Avoid possible NPE calling InputStream.setReadListener with HTTP/2. (remm)
- 61736: Improve performance of NIO connector when clients leave large time gaps between network packets. Patch provided by Zilong Song. (markt)
- 61740: Correct an off-by-one error in the Hpack header index validation that caused intermittent request failures when using HTTP/2. (markt)

#### Jasper

- 61604: Fix SMAP generation for JSPs that generate no output. (markt)
- 61816: Invalid expressions in attribute values or template text should trigger a translation (compile time) error, not a run time error. (markt)

#### WebSocket

- 61604: Add support for authentication in the websocket client. Patch submitted by J Fernandez. (remm)

#### Web applications

- Correct Javadoc links to point to Java SE 8 and Java EE 8. (markt)
- Enable Javadoc to be built with Java 9. (markt)
- 61603: Add XML filtering for the status servlet output where needed. (remm)
- Correct the description of how the CGI servlet maps a request to a script in the CGI How-To. (markt)

#### Tribes

- Fix incorrect behavior that attempts to resend channel messages more than the actual setting value of `maxRetryAttempts`. (kfujino)
- Ensure that the remaining Sender can send channel messages by avoiding unintended `ChannelException` caused by comparing the number of failed members and the number of remaining Senders. (kfujino)
- Ensure that remaining SelectionKeys that were not handled by throwing a `ChannelException` during SelectionKey processing are handled. (kfujino)

#### Other

- Improve the fix for 61439 and exclude the JPA, JAX-WS and EJB annotations completely from the Tomcat distributions. (markt)
- Improve handling of endorsed directories. The endorsed directory mechanism will only be used if the `JAVA_ENDORSED_DIRS` system property is explicitly set or if `$CATALINA_HOME/endorsed` exists. When running on Java 9, any such attempted use of the endorsed directory mechanism will trigger an error and Tomcat will fail to start. (rjung)
- 51496: When using the Windows installer, check if the requested service name already exists and, if it does, prompt the user to select an alternative service name. Patch provided by Ralph Plawetzki. (markt)
- 61590: Enable `service.bat` to recognise when `JAVA_HOME` is configured for a Java 9 JDK. (markt)
- 61598: Update the Windows installer to search the new (as of Java 9) registry locations when looking for a JRE. (markt)
- Add generation of a SHA-512 hash for release artifacts to the build script. (markt)
- 61658: Update MIME mappings for fonts to use `font/*` as per RFC8081. (markt)
- Update the packaged version of the Tomcat Native Library to 1.2.16 to pick up the latest Windows binaries built with APR 1.6.3 and OpenSSL 1.0.2m. (markt)
- Update the NSIS Installer used to build the Windows installer to version 3.02.1. (kkolinko)
- Update the Windows installer to use "The Apache Software Foundation" as the Publisher when Tomcat is displayed in the list of installed applications in Microsoft Windows. (kkolinko)
- 61803: Remove outdated SSL information from the Security documentation. (remm)

### 2017-09-30 Tomcat 9.0.1 (markt)

#### Catalina

- Use the correct path when loading the JVM `logging.properties` file for Java 9. (rjung)
- Add additional validation to the resource handling required to fix CVE-2017-12617 on Windows. The checks were being performed elsewhere but adding them to the resource handling ensures that the checks are always performed. (markt)

#### Other

- 61563: Correct typos in Spanish translation. Patch provided by Gonzalo Vásquez. (csutherl)

### not released Tomcat 9.0.0 (markt)

#### Catalina

- 61542: Fix CVE-2017-12617 and prevent JSPs from being uploaded via a specially crafted request when HTTP PUT was enabled. (markt)
- 61554: Exclude test files in unusual encodings and markdown files intended for display in GitHub from RAT analysis. Patch provided by Chris Thistlethwaite. (markt)

#### Coyote

- 60762: Add the ability to make changes to the TLS configuration of a connector at runtime without having to restart the Connector. (markt)
- Add an option to reject requests that contain HTTP headers with invalid (non-token) header names with a 400 response and reject such requests by default. (markt)
- Implement the requirements of RFC 7230 (and RFC 2616) that HTTP/1.1 requests must include a `Host` header and any request that does not must be rejected with a 400 response. (markt)
- Implement the requirements of RFC 7230 that any HTTP/1.1 request that specifies a host in the request line, must specify the same host in the `Host` header and that any such request that does not, must be rejected with a 400 response. This check is optional but enabled by default. It may be disabled with the `allowHostHeaderMismatch` attribute of the Connector. (markt)
- Implement the requirements of RFC 7230 that any HTTP/1.1 request that contains multiple `Host` headers is rejected with a 400 response. (markt)
- Add a way to set the property source in embedded mode. (remm)
- 61557: Correct a further regression in the fix to enable the use of Java key stores that contain multiple keys that do not all have the same password. The regression broke support for some FIPS compliant key stores. (markt)

#### jdbc-pool

- 61545: Correctly handle invocations of methods defined in the `PooledConnection` interface when using pooled XA connections. Patch provided by Nils Winkler. (markt)

#### Other

- Update fix for 59904 so that values less than zero are accepted instead of throwing a NegativeArraySizeException. (remm)
- Complete the implementation of the Servlet 4.0 specification. (markt)

### 2017-09-19 Tomcat 9.0.0.M27 (markt)

#### Catalina

- Before generating an error page in the `ErrorReportValve`, check to see if I/O is still permitted for the associated connection before generating the error page so that the page generation can be skipped if the page is never going to be sent. (markt)
- 61189: Add the ability to set environment variables for individual CGI scripts. Based on a patch by jm009. (markt)
- 61210: When running under a SecurityManager, do not print a warning about not being able to read a logging configuration file when that file does not exist. (markt)
- 61280: Add RFC 7617 support to the `BasicAuthenticator`. Note that the default configuration does not change the existing behaviour. (markt)
- 61424: Avoid a possible `StackOverflowError` when running under a `SecurityManager` and using `Subject.doAs()`. (markt)
- When running under Java 9 or later, and the `urlCacheProtection` option of the `JreMemoryLeakPreventionListener` is enabled, use the API added in Java 9 to only disable the caching for JAR URL connections. (markt)
- 61489: When using the CGI servlet, make the generation of command line arguments from the query string (as per section 4.4 of RFC 3875) optional and disabled by default. Based on a patch by jm009. (markt)
- 61503: This corrects a potential regression in the fix for 60940 with an alternative solution that adds the `JarEntry` objects normally skipped by a `JarInputStream` only if those entries exist. (markt)

#### Coyote

- The minimum required Tomcat Native version has been increased to 1.2.14. This version includes a new API needed for correct client certificate support when using a Java connector with OpenSSL TLS implementation and support for the `SSL_CONF` OpenSSL API. (rjung)
- Add support for the OpenSSL `SSL_CONF` API when using TLS with OpenSSL implementation. It can be used by adding `OpenSSLConf` elements underneath `SSLHostConfig`. The new element contains a list of `OpenSSLConfCmd` elements, each with the attributes `name` and `value`. (rjung)
- When using a Java connector in combination with the OpenSSL TLS implementation, do not configure each SSL connection object via the OpenSSLEngine. For OpenSSL the SSL object inherits its settings from the SSL_CTX which we have already configured. (rjung)
- When using JSSE TLS configuration with the OpenSSL implementation and client certificates: include client CA subjects in the TLS handshake so that the client can choose an appropriate client certificate to present. (rjung)
- If an invalid option is specified for the `certificateVerification` attribute of an `SSLHostConfig` element, treat it as `required` which is the most secure / restrictive option in addition to reporting the configuration error. (markt)
- Improve the handling of client disconnections during the TLS renegotiation handshake. (markt)
- Prevent exceptions being thrown during normal shutdown of NIO connections. This enables TLS connections to close cleanly. (markt)
- Fix possible race condition when setting IO listeners on an upgraded connection. (remm)
- Ensure that the APR/native connector uses blocking I/O for TLS renegotiation. (markt)
- 48655: Enable Tomcat to shutdown cleanly when using sendfile, the APR/native connector and a multi-part download is in progress. (markt)
- 58244: Handle the case when OpenSSL resumes a TLS session using a ticket and the full client certificate chain is not available. In this case the client certificate without the chain will be presented to the application. (markt)
- Improve the warning message when JSSE and OpenSSL configuration styles are mixed on the same `SSLHostConfig`. (markt)
- 61415: Fix TLS renegotiation with OpenSSL based connections and session caching. (markt)
- Delay checking that the configured attributes for an `SSLHostConfig` instance are consistent with the configured SSL implementation until `Connector` start to avoid incorrect warnings when the SSL implementation changes during initialisation. (markt)
- 61450: Fix default key alias algorithm. (remm)
- 61451: Correct a regression in the fix to enable the use of Java key stores that contained multiple keys that did not all have the same password. The regression broke support for any key store that did not store keys in PKCS #8 format such as hardware key stores and Windows key stores. (markt)

#### WebSocket

- 60523: Reduce the number of packets used to send WebSocket messages by not flushing between the header and the payload when the two are written together. (markt)
- 61491: When using the `permessage-deflate` extension, correctly handle the sending of empty messages after non-empty messages to avoid the `IllegalArgumentException`. (markt)

#### Web applications

- Show connector cipher list in the manager web application in the correct cipher order. (rjung)

#### Tribes

- To avoid unexpected session timeout notification from backup session, update the access time when receiving the map member notification message. (kfujino)
- Add member info to the log message when the failure detection check fails in `TcpFailureDetector`. (kfujino)
- Avoid Ping timeout until the added map member by receiving `MSG_START` message is completely started. (kfujino)
- When sending a channel message, make sure that the Sender has connected. (kfujino)
- Correct the backup node selection logic that node 0 is returned twice consecutively. (kfujino)
- Fix race condition of `responseMap` in `RpcChannel`. (kfujino)

#### jdbc-pool

- 61391: Ensure that failed queries are logged if the `SlowQueryReport` interceptor is configured to do so and the connection has been abandoned. Patch provided by Craig Webb. (markt)
- 61425: Ensure that transaction of idle connection has terminated when the `testWhileIdle` is set to `true` and `defaultAutoCommit` is set to `false`. Patch provided by WangZheng. (kfujino)

#### Other

- 61419: Replace a Unix style comment in the DOS bat file `catalina.bat` with the correct `rem` markup. (rjung)
- 61439: Remove the Java Annotation API classes from tomcat-embed-core.jar and package them in a separate JAR in the embedded distribution to provide end users with greater flexibility to handle potential conflicts with the JRE and/or other JARs. (markt)
- 61441: Improve the detection of `JAVA_HOME` by the `daemon.sh` script when running on a platform where Java has been installed from an RPM. (rjung)
- Update the packaged version of the Tomcat Native Library to 1.2.14 to pick up the latest Windows binaries built with APR 1.6.2 and OpenSSL 1.0.2l. (markt)
- 61599: Update to Commons Daemon 1.1.0 for improved Java 9 support. (markt)

### 2017-08-08 Tomcat 9.0.0.M26 (markt)

#### Catalina

- Correct multiple regressions in the fix for 49464 that could corrupt static content served by the `DefaultServlet`.(markt)
- Correct a bug in the `PushBuilder` implementation that meant push URLs containing `%nn` sequences were not correctly decoded. Identified by FindBugs. (markt)
- 61164: Add support for the `%X` pattern in the `AccessLogValve` that reports the connection status at the end of the request. Patch provided by Zemian Deng. (markt)
- 61351: Correctly handle %nn decoding of URL patterns in web.xml and similar locations that may legitimately contain characters that are not permitted by RFC 3986. (markt)
- 61366: Add a new attribute, `localDataSource`, to the `JDBCStore` that allows the Store to be configured to use a DataSource defined by the web application rather than the default of using a globally defined DataSource. Patch provided by Jonathan Horowitz. (markt)

#### Coyote

- 61086: Ensure to explicitly signal an empty request body for HTTP 205 responses. Additional fix to r1795278. Based on a patch provided by Alexandr Saperov. (violetagg)
- 61345: Add a server listener that can be used to do system property replacement from the property source configured in the digester. (remm)
- Add additional logging to record problems that occur while waiting for the NIO pollers to stop during the Connector stop process. (markt)

#### Jasper

- 61364: Ensure that files are closed after detecting encoding of JSPs so that files do not remain locked by the file system. (markt)

#### WebSocket

- 57767: Add support to the WebSocket client for following redirects when attempting to establish a WebSocket connection. Patch provided by J Fernandez. (markt)

### 2017-07-28 Tomcat 9.0.0.M25 (markt)

#### Catalina

- Performance improvements for service loader look-ups (and look-ups of other class loader resources) when the web application is deployed in a packed WAR file. (markt)
- 60963: Add `ExtractingRoot`, a new `WebResourceRoot` implementation that extracts JARs to the work directory for improved performance when deploying packed WAR files. (markt)
- 61253: Add warn message when Digester.updateAttributes throws an exception instead of ignoring it. (csutherl)
- Correct a further regression in the fix for 49464 that could cause an byte order mark character to appear at the start of content included by the `DefaultServlet`. (markt)
- 61313: Make the read timeout configurable in the `JNDIRealm` and ensure that a read timeout will result in an attempt to fail over to the alternateURL. Based on patches by Peter Maloney and Felix Schumacher. (markt)

#### Web applications

- Correct the documentation for how `StandardRoot` is configured. (markt)

#### Other

- 61316: Fix corruption of UTF-16 encoded source files in released source distributions. (markt)

### not released Tomcat 9.0.0.M24 (markt)

#### Catalina

- 52924: Add support for a Tomcat specific deployment descriptor, `/WEB-INF/tomcat-web.xml`. This descriptor has an identical format to `/WEB-INF/web.xml`. The Tomcat descriptor takes precedence over any settings in `conf/web.xml` but does not take precedence over any settings in `/WEB-INF/web.xml`. (markt)
- 61232: When log rotation is disabled only one separator will be used when generating the log file name. For example if the prefix is `catalina.` and the suffix is `.log` then the log file name will be `catalina.log` instead of `catalina..log`. Patch provided by Katya Stoycheva. (violetagg)
- 61264: Correct a regression in the refactoring to use `Charset` rather than `String` to store request character encoding that prevented `getReader()` throwing an `UnsupportedEncodingException` if the user agent specifies an unsupported character encoding. (markt)
- Correct a regression in the fix for 49464 that could cause an incorrect `Content-Length` header to be sent by the `DefaultServlet` if the encoding of a static is not consistent with the encoding of the response. (markt)

#### Coyote

- Enable TLS connectors to use Java key stores that contain multiple keys where each key has a separate password. Based on a patch by Frank Taffelt. (markt)
- Improve the handling of HTTP/2 stream resets due to excessive headers when a continuation frame is used. (markt)

#### Jasper

- 53031: Add support for the `fork` option when compiling JSPs with the Jasper Ant task and javac. (markt)

#### Other

- 52791: Add the ability to set the defaults used by the Windows installer from a configuration file. Patch provided by Sandra Madden. (markt)

### not released Tomcat 9.0.0.M23 (markt)

#### Catalina

- 49464: Improve the Default Servlet's handling of static files when the file encoding is not compatible with the required response encoding. (markt)
- 61214: Remove deleted attribute `servlets` from the Context MBean description. Patch provided by Alexis Hassler. (markt)
- 61215: Correctly define `addConnectorPort` and `invalidAuthenticationWhenDeny` in the `mbean-descriptors.xml` file for the `org.apache.catalina.valves` package so that the attributes are accessible via JMX. (markt)
- 61216: Improve layout for `CompositeData` and `TabularData` when viewing via the JMX proxy servlet. Patch provided by Alexis Hassler. (markt)
- Additional permission for deleting files is granted to JULI as it is required by FileHandler when running under a Security Manager. The thread that cleans the log files is marked as daemon thread. (violetagg)
- 61229: Correct a regression in 9.0.0.M21 that broke WebDAV handling for resources with names that included a `&` character. (markt)

#### Coyote

- Restore the ability to configure support for SSLv3. Enabling this protocol will trigger a warning in the logs since it is known to be insecure. (markt)
- Add LoadBalancerDrainingValve, a Valve designed to reduce the amount of time required for a node to drain its authenticated users. (schultz)
- Do not log a warning when a `null` session is returned for an OpenSSL based TLS session since this is expected when session tickets are enabled. (markt)
- When the access log valve logs a TLS related request attribute and the NIO2 connector is used with OpenSSL, ensure that the TLS attributes are available to the access log valve when the connection is closing. (markt)
- 60461: Sync SSL session access for the APR connector. (remm)
- 61224: Make the `GlobalRequestProcessor` MBean attributes read-only. Patch provided by Alexis Hassler. (markt)

#### Jasper

- 49176: When generating JSP runtime error messages that quote the relevant JSP source code, switch from using the results of the JSP page parsing process to using the JSR 045 source map data to identify the correct part of the JSP source from the stack trace. This significantly reduces the memory footprint of Jasper in development mode, provides a small performance improvement for error page generation and enables source quotes to continue to be provided after a Tomcat restart. (markt)

#### Web applications

- Remove references to the Loader attribute `searchExternalFirst` from the documentation since the attribute is no longer supported. (markt)

#### Tribes

- 51513: Add support for the `compressionMinSize` attribute to the `GzipInterceptor`, add optional statistics collection and expose the Interceptor over JMX. Based on a patch by Christian Stöber. (markt)
- 61127: Allow human-readable names for channelSendOptions and mapSendOptions. Patch provided by Igal Sapir. (schultz)

#### Other

- Restore the local definition of the web service annotations since the JRE provided versions are deprecated and Java 9 does not provide them by default. (markt)
- Add necessary Java 9 configuration options to the startup scripts to prevent warnings being generated on web application stop. (markt)

### 2017-06-26 Tomcat 9.0.0.M22 (markt)

#### Catalina

- 48543: Add the option to specify an alternative file name for the `catalina.config` system property. Also document that relative, as well as absolute, URLs are permitted. (markt)
- 61072: Respect the documentation statements that allow using the platform default secure random for session id generation. (remm)
- Correct the javadoc for `o.a.c.connector.CoyoteAdapter#parseSessionCookiesId`. Patch provided by John Andrew (XUZHOUWANG) via Github. (violetagg)
- 61101: CORS filter should set Vary header in response. Submitted by Rick Riemer. (remm)
- 61105: Add a new JULI FileHandler configuration for specifying the maximum number of days to keep the log files. By default the log files will be kept 90 days as configured in `logging.properties`. (violetagg)
- Update the Servlet 4.0 implementation to add support for setting trailer fields for HTTP responses. (markt)
- 61125: Ensure that `WarURLConnection` returns the correct value for calls to `getLastModified()` as this is required for the correct detection of JSP modifications when the JSP is packaged in a WAR file. (markt)
- Improve the `SSLValve` so it is able to handle client certificate headers from Nginx. Based on a patch by Lucas Ventura Carro. (markt)
- 61134: Do not use '[' and ']' symbols around substituted text fragments when generating the default error pages. Patch provided by Katya Todorova. (violetagg)
- 61154: Allow the Manager and Host Manager web applications to start by default when running under a security manager. This was accomplished by adding a custom permission, `org.apache.catalina.security.DeployXmlPermission`, that permits an application to use a `META-INF/context.xml` file and then granting that permission to the Manager and Host Manager. (markt)
- 61173: Polish the javadoc for `o.a.catalina.startup.Tomcat`. Patch provided by peterhansson_se. (violetagg)
- A new configuration property `crawlerIps` is added to the `o.a.catalina.valves.CrawlerSessionManagerValve`. Using this property one can specify a regular expression that will be used to identify crawlers based on their IP address. Based on a patch provided by Tetradeus. (violetagg)
- 61180: Log a warning message rather than an information message if it takes more than 100ms to initialised a `SecureRandom` instance for a web application to use to generate session identifiers. Patch provided by Piotr Chlebda. (markt)
- 61185: When an asynchronous request is dispatched via `AsyncContext.dispatch()` ensure that `getRequestURI()` for the dispatched request matches that of the original request. (markt)
- 61197: Ensure that the charset name used in the `Content-Type` header has exactly the same form as that provided by the application. This reverts a behavioural change in 9.0.0.M21 that caused problems for some clients. (markt)
- 61201: Ensure that the `SCRIPT_NAME` environment variable for CGI executables is populated in a consistent way regardless of how the CGI servlet is mapped to a request. (markt)
- Ensure to send a space between trailer field name and field value for HTTP responses trailer fields. (huxing)

#### Coyote

- 61086: Explicitly signal an empty request body for HTTP 205 responses. (markt)
- 61120: Do not ignore path parameters when processing HTTP/2 requests. (markt)
- Revert a change introduced in the fix for bug 60718 that changed the status code recorded in the access log when the client dropped the connection from 200 to 500. (markt)
- Make asynchronous error handling more robust. In particular ensure that `onError()` is called for any registered `AsyncListener`s after an I/O error on a non-container thread. (markt)
- Add additional syncs to the SSL session object provided by the OpenSSL engine so that a concurrent destruction cannot cause a JVM crash. (remm)

#### Jasper

- 44787: Improve error message when JSP compiler configuration options are not valid. (markt)
- 45931: Extend Jasper's `timeSpaces` option to add support for `single` which replaces template text that consists entirely of whitespace with a single space character. Based on a patch by Meetesh Karia. (markt)
- 53011: When pre-compiling with JspC, report all compilation errors rather than stopping after the first error. A new option `-failFast` can be used to restore the previous behaviour of stopping after the first error. Based on a patch provided by Marc Pompl. (markt)
- 61137: `j.s.jsp.tagext.TagLibraryInfo#uri` and `j.s.jsp.tagext.TagLibraryInfo#prefix` fields should not be final. Patch provided by Katya Todorova. (violetagg)

#### WebSocket

- Correct the log message when a `MessageHandler` for `PongMessage` does not implement `MessageHandler.Whole`. (rjung)
- Improve thread-safety of `Future`s used to report the result of sending WebSocket messages. (markt)
- 61183: Correct a regression in the previous fix for 58624 that could trigger a deadlock depending on the locking strategy employed by the client code. (markt)

#### Web applications

- Better document the meaning of the trimSpaces option for Jasper. (markt)
- 61150: Configure the Manager and Host-Manager web applications to permit serialization and deserialization of CRSFPreventionFilter related session objects to avoid warning messages and/or stack traces on web application stop and/or start when running under a security manager. (markt)
- Correct the TLS configuration documentation to remove SSLv2 and SSLv3 from the list of supported protocols. (markt)

#### Other

- 45832: Add HTTP DIGEST authentication support to the Catalina Ant tasks used to communicate with the Manager application. (markt)
- 45879: Add the `RELEASE-NOTES` file to the root of the installation created by the Tomcat installer for Windows to make it easier for users to identify the installed Tomcat version. (markt)
- 61055: Clarify the code comments in the rewrite valve to make clear that there are no plans to provide proxy support for this valve since Tomcat does not have proxy capabilities. (markt)
- 61076: Document the `altDDName` attribute for the `Context` element. (markt)
- Correct typo in Jar Scan Filter Configuration Reference. Issue reported via comments.apache.org. (violetagg)
- Correct the requirement for the minimum Java SE version in Application Developer's Guide. Issue reported via comments.apache.org. (violetagg)
- 61145: Add missing `@Documented` annotation to annotations in the annotations API. Patch provided by Katya Todorova. (markt)
- 61146: Add missing `lookup()` method to `@EJB` annotation in the annotations API. Patch provided by Katya Todorova. (markt)
- Correct typo in Context Container Configuration Reference. Patch provided by Katya Todorova. (violetagg)

### 2017-05-10 Tomcat 9.0.0.M21 (markt)

#### General

- Allow to exclude JUnit test classes using the build property `test.exclude` and document the property in BUILDING.txt. (rjung)

#### Catalina

- Review those places where Tomcat re-encodes a URI or URI component and ensure that the correct encoding (path differs from query string) is applied and that the encoding is applied consistently. (markt)
- Avoid a `NullPointerException` when reading attributes for a initialised HTTP connector where TLS is enabled. (markt)
- Always quote the `hostName` of an `SSLHostConfig` element when using it as part of the JMX object name to avoid errors that prevent the associated TLS connector from starting if a wild card `hostName` is configured (because `*` is a reserved character for JMX object names). (markt)
- Update the default `URIEncoding` for a `Connector` to `UTF-8` as required by the Servlet 4.0 specification. (markt)
- Switch to using `Charset` rather than `String` to store encoding settings (including for configuration and for the `Content-Type header`) to reduce the number of places the associated `Charset` needs to be looked up. (markt)
- Use a more reliable mechanism for the `DefaultServlet` when determining if the current request is for custom error page or not. (markt)
- Ensure that when the Default or WebDAV servlets process an error dispatch that the error resource is processed via the `doGet()` method irrespective of the method used for the original request that triggered the error. (markt)
- If a static custom error page is specified that does not exist or cannot be read, ensure that the intended error status is returned rather than a 404 or 403. (markt)
- When the WebDAV servlet is configured and an error dispatch is made to a custom error page located below `WEB-INF`, ensure that the target error page is displayed rather than a 404 response. (markt)
- Update the Servlet 4.0 implementation to add support for obtaining trailer fields from chunked HTTP requests. (markt)
- 61047: Add MIME mapping for woff2 fonts in the default web.xml. Patch provided by Justin Williamson. (violetagg)
- Correct the logic that selects the encoding to use to decode the query string in the `SSIServletExternalResolver` so that the `useBodyEncodingForURI` attribute of the `Connector` is correctly taken into account. (markt)
- Within the Expires filter, make the content type value specified with the `ExpiresByType` parameter, case insensitive. (markt)

#### Coyote

- When a `TrustManager` is configured that does not support `certificateVerificationDepth` only log a warning about that lack of support when `certificateVerificationDepth` has been explicitly set. (markt)
- 60970: Extend the fix for large headers to push requests. (markt)
- Do not include a `Date` header in HTTP/2 responses with status codes less than 200. (markt)
- When sending an HTTP/2 push promise with the NIO2 connector, the pushed stream ID should only be included with the initial push promise frame and not any subsequent continuation frames. (markt)

#### Jasper

- When no BOM is present and an encoding is detected, do not skip the bytes used to detect the encoding since they are not part of a BOM. (markt)
- 61057: Update to Eclipse JDT Compiler 4.6.3. (violetagg)
- 61065: Ensure that once the class is resolved by `javax.el.ImportHandler#resolveClass` it will be cached with the proper name. (violetagg)

#### WebSocket

- Introduce new API `o.a.tomcat.websocket.WsSession#suspend`/ `o.a.tomcat.websocket.WsSession#resume` that can be used to suspend/resume reading of the incoming messages. (violetagg)
- 61003: Ensure the flags for reading/writing in `o.a.t.websocket.AsyncChannelWrapperSecure` are correctly reset even if some exceptions occurred during processing. (markt/violetagg)

#### Web Applications

- Add documents for `maxIdleTime` attribute to Channel Receiver docs. (kfujino)

#### Tribes

- Add features to get the statistics of the thread pool of the `Receiver` component and `MessageDispatchInterceptor`. These statistics information can be acquired via JMX. (kfujino)
- Add `maxIdleTime` attribute to `NioReceiverMBean` in order to expose to JMX. (kfujino)
- Add JMX support for `Channel Interceptors`. The Interceptors that implement JMX support are `TcpFailureDetector`, `ThroughputInterceptor`, `TcpPingInterceptor`, `StaticMembershipInterceptor`, `MessageDispatchInterceptor` and `DomainFilterInterceptor`. (kfujino)

#### Other

- Modify the Ant build script used to publish to a Maven repository so that it no longer requires artifacts to be GPG signed. This is make it possible for the CI system to upload snapshot builds to the ASF Maven repository. (markt)

### 2017-04-18 Tomcat 9.0.0.M20 (markt)

#### Catalina

- Update the Servlet 4.0 API implementation to reflect the change in method name from `getPushBuilder()` to `newPushBuilder()`. (markt)
- Correct various edge cases in the new HTTP Host header validation parser. Patch provided by Katya Todorova. (martk)
- Correct a regression in the X to comma refactoring that broke JMX operations that take parameters. (markt)
- Avoid a `NullPointerException` when reading attributes for a running HTTP connector where TLS is not enabled. (markt)
- 47214: Refactor code so that explicitly referenced inner classes are given explicit names rather than being anonymous. (markt)
- 59825: Log a message that lists the components in the processing chain that do not support async processing when a call to `ServletRequest.startAsync()` fails. (markt)
- 60940: Improve the handling of the `META-INF/` and `META-INF/MANIFEST.MF` entries for Jar files located in `/WEB-INF/lib` when running a web application from a packed WAR file. (markt)
- Pre-load the `ExceptionUtils` class. Since the class is used extensively in error handling, it is prudent to pre-load it to avoid any failure to load this class masking the true problem during error handling. (markt)
- Avoid potential `NullPointerException`s related to access logging during shutdown, some of which have been observed when running the unit tests. (markt)
- When there is no `javax.servlet.WriteListener` registered then a call to `javax.servlet.ServletOutputStream#isReady` will return `false` instead of throwing `IllegalStateException`. (violetagg)
- When there is no `javax.servlet.ReadListener` registered then a call to `javax.servlet.ServletInputStream#isReady` will return `false` instead of throwing `IllegalStateException`. (violetagg)

#### Coyote

- Align cipher configuration parsing with current OpenSSL master. (markt)
- 60970: Fix infinite loop if application tries to write a large header to the response when using HTTP/2. (markt)

#### Jasper

- 47214: Refactor code so that explicitly referenced inner classes are given explicit names rather than being anonymous. (markt)
- 60925: Improve the handling of access to properties defined by interfaces when a `BeanELResolver` is used under a `SecurityManager`. (markt)

#### Tribes

- Add JMX support for Tribes components. (kfujino)

#### jdbc-pool

- Refactor the creating a constructor for a proxy class to reduce duplicate code. (kfujino)
- In `StatementFacade`, the method call on the statements that have been closed throw `SQLException` rather than `NullPointerException`. (kfujino)

#### Other

- 60932: Correctly escape single quotes when used in i18n messages. Based on a patch by Michael Osipov. (markt)
- Review i18n property files, remove unnecessary escaping and consistently use `[...]` to delimit inserted values. (markt)
- Update the custom Ant task that integrates with the Symantec code signing service to use the now mandatory 2-factor authentication. (markt)
- Refactoring in preparation for Java 9. Refactor to avoid using some methods that will be deprecated in Java 9 onwards. (markt)

### 2017-03-30 Tomcat 9.0.0.M19 (markt)

#### Catalina

- 54618: Add support to the `HttpHeaderSecurityFilter` for the HSTS preload parameter. (markt)
- Correct a bug in the implementation of the Servlet 4.0 feature that allows specifying a default request and/or response character encoding per web application. `null` values passed via the programmatic interface no longer trigger a `NullPointerException`. (markt)
- Correct a potential exception during shutdown when one or more Containers are configured with a value of 1 for startStopThreads. (markt)
- 60853: Expose the `SSLHostConfig` and `SSLHostConfigCertificate` objects via JMX. (markt)
- 60876: Ensure that `Set-Cookie` headers generated by the `Rfc6265CookieProcessor` are aligned with the specification. Patch provided by Jim Griswold. (markt)
- 60882: Fix a `NullPointerException` when obtaining a `RequestDispatcher` for a request that will not have any pathInfo associated with it. This was a regression in the changes in 9.0.0.M18 for the Servlet 4.0 API changes. (markt)
- Align `PushBuilder` API with changes from the Servlet expert group. (markt)
- Align web.xml parsing rules with changes from the Servlet expert group for `<request-character-encoding>` and `<response-character-encoding>`. (markt)
- Refactor the various implementations of X to comma separated list to a single utility class and update the code to use the new utility class. (markt)
- 60911: Ensure NPE will not be thrown when looking for SSL session ID. Based on a patch by Didier Gutacker. (violetagg)

#### Coyote

- Add async based IO groundwork for HTTP/2. (remm)
- Fix HTTP/2 incorrect input unblocking on EOF. (remm)
- Close the connection sooner if an event occurs for a current connection that is not consistent with the current state of that connection. (markt)
- Speed up shutdown when using multiple acceptor threads by ensuring that the code that unlocks the acceptor threads correctly handles the case where there are multiple threads. (markt)
- 60851: Add `application/xml` and `application/json` to the default list of compressible MIME types. Patch by Michael Osipov. (markt)
- 60852: Correctly spell compressible when used in configuration attributes and internal code. Based on a patch by Michael Osipov. (markt)
- 60900: Avoid a `NullPointerException` in the APR Poller if a connection is closed at the same time as new data arrives on that connection. (markt)
- Improve HPACK specification compliance by fixing some test failures reported by the h2spec tool written by Moto Ishizawa. (markt)
- Improve HTTP/2 specification compliance by fixing some test failures reported by the h2spec tool written by Moto Ishizawa. (markt)
- 60918: Fix sendfile processing error that could lead to subsequent requests experiencing an `IllegalStateException`. (markt)
- Improve sendfile handling when requests are pipelined. (markt)

#### Jasper

- 60844: Correctly handle the error when fewer parameter values than required by the method are used to invoke an EL method expression. Patch provided by Daniel Gray. (markt)

#### jdbc-pool

- 60764: Implement `equals()` and `hashCode()` in the `StatementFacade` in order to enable these methods to be called on the closed statements if any statement proxy is set. This behavior can be changed with `useStatementFacade` attribute. (kfujino)

#### Other

- Refactor the build script and the NSIS installer script so that either NSIS 2.x or NSIS 3.x can be used to build the installer. This is primarily to re-enable building the installer on the Linux based CI system where the combination of NSIS 3.x and wine leads to failed installer builds. (markt)

### 2017-03-13 Tomcat 9.0.0.M18 (markt)

#### Catalina

- 60469: Refactor `RealmBase` for better code re-use when implementing Realms that use a custom `Principal`. (markt)
- 60490: Various formatting and layout improvements for the `ErrorReportValve`. Patch provided by Michael Osipov. (markt)
- 60573: Remove the reason phrase when sending a `100` response status for consistency with other response status lines. Patch provided by Michael Osipov. (markt)
- 60596: Improve performance of DefaultServlet when sendfile feature is disabled on connector. (kkolinko)
- Make it easier for sub-classes of `Tomcat` to modify the default web.xml settings by over-riding `getDefaultWebXmlListener()`. Patch provided by Aaron Anderson. (markt)
- Reduce the contention in the default `InstanceManager` implementation when multiple threads are managing objects and need to reference the annotation cache. (markt)
- 60623: When startStopThreads is 1 (or a special value that is equivalent to 1) then rather than using an `ExecutorService` to start the children of the current component, the children will be started on the current thread. (markt)
- 60674: Remove `final` marker from `CorsFilter` to enable sub-classing. (markt)
- 60683: Security manager failure causing NPEs when doing IO on some JVMs. (csutherl)
- 60688: Update the internal fork of Apache Commons BCEL to r1782855 to add early access Java 9 support to the annotation scanning code. (markt)
- 60694: Prevent NPE during authentication when no JASPIC `AuthConfigFactory` is available. (markt)
- 60697: When HTTP TRACE requests are disabled on the Connector, ensure that the HTTP OPTIONS response from custom servlets does not include TRACE in the returned Allow header. (markt)
- 60718: Improve error handling for asynchronous processing and correct a number of cases where the `requestDestroyed()` event was not being fired and an entry wasn't being made in the access logs. (markt)
- 60720: Replace "WWW-Authenticate" literal with static final AUTH_HEADER_NAME in SpnegoAuthenticator. Patch provided by Michael Osipov. (violetagg)
- The default JASPIC `AuthConfigFactory` now correctly notifies registered `RegistrationListener`s when a new `AuthConfigProvider` is registered. (markt)
- Improve the performance of `AuthenticatorBase` when there is no JASPIC configuration available. (violetagg)
- When HTTP TRACE requests are disabled on the Connector, ensure that the HTTP OPTIONS response from the WebDAV servlet does not include TRACE in the returned Allow header. (markt)
- 60722: Take account of the dispatchersUseEncodedPaths setting on the current Context when generating paths for dispatches triggered by `AsyncContext.dispatch()`. (markt)
- 60728: Make the separator Tomcat uses in the Tomcat specific `war:file:...` URL protocol customizable via a system property. The separator is equivalent to the use of the `!` character in `jar:file:...` URLs. The default separator of `*` remains unchanged. (markt)
- Update the Servlet 4.0 API implementation to align with the latest proposals from the Servlet 4.0 expert group. This includes updates to the new Servlet mapping API, new methods on the `ServletContext` to make the available API more equivalent to the deployment descriptor, updates to the HTTP push API and the ability to set default request and response character encoding per web application. Note that the Servlet 4.0 API is still a work in progress and further changes are likely. (markt)
- 60798: Correct a bug in the handling of JARs in unpacked WARs that meant multiple attempts to read the same entry from a JAR in succession would fail for the second and subsequent attempts. (markt)
- 60808: Ensure that the `Map` returned by `ServletRequest.getParameterMap()` is fully immutable. Based on a patch provided by woosan. (markt)
- 60824: Correctly cache the `Subject` in the session - if there is a session - when running under a `SecurityManager`. Patch provided by Jan Engehausen. (markt)
- Ensure request and response facades are used when firing application listeners. (markt/remm)

#### Coyote

- Improve handling of case when an HTTP/2 client sends more data that is subject to flow control than the current window size allows. (markt)
- Improve NIO2 look-ahead parsing of TLS client hello for SNI with large client hello messages. (markt)
- Enable ALPN and also, therefore, HTTP/2 for the NIO and NIO2 HTTP connectors when using the JSSE implementation for TLS when running on Java 9. (markt)
- Restore Java 9 direct byte buffer compatibility. (remm)
- 59807: Provide a better error message when there is no SSLHostConfig defined with a `hostName` that matches the `defaultSSLHostConfigName` for the associated Connector. (markt)
- 60627: Modify the `Rfc6265CookieProcessor` so that in addition to cookie headers that start with an explicit RFC 2109 `$Version=1`, cookies that start with `$Version=0` are also parsed as RFC 2109 cookies. (markt)
- Include the value of `SslHostConfig.truststoreAlgorithm` when warning that the algorithm does not support the `certificateVerificationDepth` configuration option. (markt)
- Ensure that executor thread pools used with connectors pre-start the configured minimum number of idle threads. (markt)
- 60716: Add a new JSSE specific attribute, `revocationEnabled`, to `SSLHostConfig` to permit JSSE provider revocation checks to be enabled when no `certificateRevocationListFile` has been configured. The expectation is that configuration will be performed via a JSSE provider specific mechanisms. (markt)
- Modify the cookie header generated by the `Rfc6265CookieProcessor` so it always sends an `Expires` attribute as well as a `Max-Age` attribute to avoid problems with Microsoft browsers that do not support the `Max-Age` attribute. (markt)
- 60761: Expose a protected getter and setter for `NioEndpoint.stopLatch` to make the class easier to extend. (markt)
- Prevent blocking reads after a stream exception occurs with HTTP/2. (remm)

#### Jasper

- Follow up to the fix for 58178. When creating the `ELContext` for a tag file, ensure that any registered `ELContextListener`s are fired. (markt)
- Refactor code generated for JSPs to reduce the size of the code required for tags. (markt)
- Improve the error handling for simple tags to ensure that the tag is released and destroyed once used. (remm, violetagg)
- 60769: Correct a regression in the XML encoding detection refactoring carried out for 9.0.0.M16 that incorrectly always used the detected BOM encoding in preference to any encoding specified in the prolog. (markt)

#### Cluster

- Make the `accessTimeout` configurable in `BackupManager` and `ClusterSingleSignOn`. The `accessTimeout` is used as a timeout period for PING in replication map. (kfujino)
- 60806: To avoid `ClassNotFoundException`, make sure that the web application class loader is passed to `ReplicatedContext`. (kfujino)

#### WebSocket

- 60617: Correctly create a `CONNECT` request when establishing a WebSocket connection via a proxy. Patch provided by Svetlin Zarev. (markt)

#### Tribes

- Add log message that PING message has received beyond the timeout period. (kfujino)
- When a PING message that beyond the time-out period has been received, make sure that valid member is added to the map membership. (kfujino)
- Ensure that `NoRpcChannelReply` messages are not received on `RpcCallback`. (kfujino)

#### Web Applications

- Add Specification and Javadoc references for JASPIC to the Docs application. (csutherl)

#### Other

- Spelling corrections provided by Josh Soref. (violetagg)
- Remove local definition of web service annotations since these are provided by the JRE. (markt)
- Update the packaged version of the Tomcat Native Library to 1.2.12 to pick up the latest Windows binaries built with OpenSSL 1.0.2k. (violetagg)
- 60784: Update all unit tests that test the HTTP status line to check for the required space after the status code. Patch provided by Michael Osipov. (markt)

### 2017-01-16 Tomcat 9.0.0.M17 (markt)

#### Catalina

- 60620: Extend the `JreMemoryLeakPreventionListener` to provide protection against `ForkJoinPool.commonPool()` related memory leaks. (markt)

#### Coyote

- Ensure UpgradeProcessor instances associated with closed connections are removed from the map of current connections to Processors. (markt)
- Remove a workaround for a problem previously reported with WebSocket, TLS and APR that treated some error conditions as not errors. The original problem cannot be reproduced with the current code and the work-around is now causing problems. (markt)

#### Jasper

- 60497: Follow up fix using a better variable name for the tag reuse flag. (remm)
- Revert use of try/finally for simple tags. (remm)

#### WebSocket

- Prevent potential processing loop on unexpected WebSocket connection closure. (markt)

#### jdbc-pool

- Enable reset the statistics without restarting the pool. (kfujino)

#### Other

- Update the NSIS Installer used to build the Windows installer to version 3.01. (markt)
- Spelling corrections provided by Josh Soref. (violetagg)

### not released Tomcat 9.0.0.M16 (markt)

#### Catalina

- 53602: Add HTTP status code 451 (RFC 7725) to the list of HTTP status codes recognised by the ErrorReportValve. (markt)
- 60446: Handle the case where the stored user credential uses a different key length than the length currently configured for the `CredentialHandler`. Based on a patch by Niklas Holm. (markt)
- Update the warnings that reference required options for running on Java 9 to use the latest syntax for those options. (markt)
- 60513: Fix thread safety issue with RMI cleanup code. (remm)

#### Coyote

- Expand the search process for a server certificate when OpenSSL is used with a JSSE connector and an explicit alias has not been configured. (markt)
- Extract the common Acceptor code from each Endpoint into a new Acceptor class that is used by all Endpoints. (markt)
- 60450: Improve the selection algorithm for the default trust store type for a TLS Virtual Host. In particular, don't use `PKCS12` as a default trust store type. Better document how the default trust store type is selected for a TLS virtual host. (markt)
- 60451: Correctly handle HTTP/2 header values that contain characters with unicode code points in the range 128 to 255. Reject with a clear error message HTTP/2 header values that contain characters with unicode code points above 255. (markt)
- Improve the logic that selects an address to use to unlock the Acceptor to take account of platforms what do not listen on all local addresses when configured with an address of `0.0.0.0` or `::`. (markt)
- Correct a regression in the refactoring to make wider use of `ByteBuffer` that caused an intermittent failure in the unit tests. (markt)
- 60482: HTTP/2 shouldn't do URL decoding on the query string. (remm)
- Fix an HTTP/2 compression error. Once a new size has been agreed for the dynamic HPACK table, the next header block must begin with a dynamic table update. (markt)
- 60508: Set request start time for HTTP/2. (remm)
- The default output buffer size for AJP connectors is now based on the configured AJP packet size rather than the minimum permitted AJP packet size. (markt)

#### Jasper

- Implement a simpler JSP file encoding detector that delegates XML prolog encoding detection to the JRE rather than using a custom XML parser. (markt)
- 60497: Restore previous tag reuse behavior following the use of try/finally. (remm)
- Improve the error handling for simple tags to ensure that the tag is released and destroyed once used. (remm)

#### WebSocket

- Correctly handle blocking WebSocket writes when the write times out just before the write is attempted. (markt)

#### Web Applications

- 60344: Add a note to BUILDING.txt regarding using the source bundle with the correct line endings. (markt)
- 60467: remove problematic characters from XML documentation. Based upon a patch by Michael Osipov. (schultz)
- In the documentation web application, be explicit that clustering requires a secure network for all of the cluster network traffic. (markt)
- Update the ASF logos to the new versions.
- 60468: Correct the format of the sample ISO-8601 date used to report the build date for the documentation. Patch provided by Michael Osipov. (markt)

#### Other

- Update the ASF logos used in the Apache Tomcat installer for Windows to use the new versions.

### 2016-12-08 Tomcat 9.0.0.M15 (markt)

#### Other

- Increment version due a local build configuration error with 9.0.0.M14 that wasn't caught until after digital signing had been completed Signing requires unique names so a new tag was required. (markt)

### not released Tomcat 9.0.0.M14 (markt)

#### Catalina

- 60202: Add an available flag to realms, to indicate the state, or the realm backend. Update lockout realm to only register auth failures if the realm is available. (remm)
- 60340: Readability improvements for CSS used in DefaultServlet and ErrorReportValve. Patch provided by Michael Osipov. (violetagg)
- 60351: Delay creating `META-INF/war-tracker` file until after the WAR has been expanded to address the case where the Tomcat process terminates during the expansion. (markt)
- Correctly generate URLs for resources located inside JARs that are themselves located inside a packed WAR file. (markt)
- Correctly handle the `configClass` attribute of a Host when embedding Tomcat. (markt)
- 60368: Stop creating a default connector on start in embedded mode. (remm)
- 60379: Dispose of the GSS credential once it is no longer required. Patch provided by Michael Osipov. (markt)
- 60380: Ensure that a call to `HttpServletRequest#logout()` triggers a call to `TomcatPrincipal#logout()`. Based on a patch by Michael Osipov. (markt)
- 60381: Provide a standard `toString()` implementation for components that implement `Contained`. (markt)
- 60387: Correct the javadoc for `o.a.catalina.AccessLog.setRequestAttributesEnabled`. The default value is different for the different implementations. (violetagg)
- 60393: Use consistent parameter naming in implementations of `Realm#authenticate(GSSContext, boolean)`. (markt)
- Refactor the `org.apache.naming` package to reduce duplicate code. Duplicate code identified by the Simian tool. (markt)
- Refactor the implementations of `HttpServletRequest#getRequestURL()` to reduce duplicate code. Duplicate code identified by the Simian tool. (markt)
- Refactor Catalina interfaces to make wider use of the `Contained` interface and reduce duplication. (markt)
- Remove the `getName()` method from `RealmBase` along with the various constants used by the sub-classes to store the return value. (markt)
- 60395: Log when an `Authenticator` passes an incomplete `GSSContext` to a Realm since it indicates a bug in the `Authenticator`. Patch provided by Michael Osipov. (markt)
- 60400: When expanding the buffer used for reading the request body, ensure the read position will be restored to the original one. (violetagg)
- Refactor the MBean implementations for the internal Tomcat components to reduce code duplication. (markt)
- 60410: Ensure that multiple calls to `JarInputStreamWrapper#close()` do not incorrectly trigger the closure of the underlying JAR or WAR file. (markt)
- 60411: Implement support in the `RewriteValve` for symbolic names to specify the redirect code to use when returning a redirect response to the user agent. Patch provided by Michael Osipov. (markt)
- 60413: In the `RewriteValve` write empty capture groups as the empty string rather than as `"null"` when generating the re-written URL. Based on a patch by Michael Osipov. (markt)

#### Coyote

- 60372: Ensure the response headers' buffer limit is reset to the capacity of this buffer when IOException occurs while writing the headers to the socket. (violetagg)
- Ensure that the availability of configured upgrade protocols that require ALPN is correctly reported during Tomcat start. (markt)
- 60386: Implement a more sophisticated pruning algorithm for removing closed streams from the priority tree to ensure that the tree does not grow too large. (markt)
- 60409: When unable to complete sendfile request, ensure the Processor will be added to the cache only once. (markt/violetagg)
- Ensure that the endpoint is able to unlock the acceptor thread during shutdown if the endpoint is configured to listen to any local address of a specific type such as `0.0.0.0` or `::`. (markt)
- Add a new configuration option, `ipv6v6only` to the APR connectors that allows them to be configure to only accept IPv6 connections when configured with an IPv6 address rather than the default which is to accept IPv4 connections as well if the operating system uses a dual network stack. (markt)
- Improve the logic that unlocks the acceptor thread so a better choice is made for the address to connect to when a connector is configured for any local port. This reduces the likelihood of the unlock failing. (markt)
- 60436: Avoid a potential NPE when processing async timeouts. (markt)
- Reduce the window in which an async request that has just started processing on a container thread remains eligible for an async timeout. (markt)

#### Jasper

- 60431: Improve handling of varargs in UEL expressions. Based on a patch by Ben Wolfe. (markt)

#### Web applications

- Correct a typo in Host Configuration Reference. Issue reported via comments.apache.org. (violetagg)
- 60412: Add information on the comment syntax for the `RewriteValve` configuration. (markt)

#### Tribes

- Reduce the warning logs for a message received from a different domain in order to avoid excessive log outputs. (kfujino)

#### WebSocket

- 60437: Avoid possible handshake overflows in the websocket client. (remm)

#### jdbc-pool

- 58816: Implement the statistics of jdbc-pool. The stats infos are `borrowedCount`, `returnedCount`, `createdCount`, `releasedCount`, `reconnectedCount`, `releasedIdleCount` and `removeAbandonedCount`. (kfujino)
- 60194: If `validationQuery` is not specified, connection validation is done by calling the `isValid()` method. (kfujino)
- 60398: Fix testcase of `TestSlowQueryReport`. (kfujino)

#### Other

- Allow customization of service.bat, such as heap memory size, service startup mode and JVM args. Patch provided by isapir via Github. (violetagg)
- 60366: Change `catalina.bat` to use directly `LOGGING_MANAGER` and `LOGGING_CONFIG` variables in order to configure logging, instead of modifying `JAVA_OPTS`. Patch provided by Petter Isberg. (violetagg)
- 60383: JASPIC API is added as a dependency to the `org.apache.tomcat:tomcat-catalina` maven artifact. (violetagg)
- Update the comments associated with the TLS Connector examples in `server.xml`. (markt)
- New property is added `test.verbose` in order to control whether the output of the tests is displayed on the console or not. Patch provided by Emmanuel Bourg. (violetagg)
- `TestOpenSSLCipherConfigurationParser.testSpecification` - if there are test failures, provide more detailed information. Patch provided by Emmanuel Bourg. (violetagg)

### 2016-11-08 Tomcat 9.0.0.M13 (markt)

#### Coyote

- Check that threadPriority values used in AbstractProtocol are valid. (fschumacher)

### not released Tomcat 9.0.0.M12 (markt)

#### Catalina

- When creating a new Connector via JMX, ensure that both HTTP/1.1 and AJP/1.3 connectors can be created. (markt)
- Reduce multiple error messages when Connector fails to instantiate the associated ProtocolHandler. (markt)
- 60152: Provide an option for Connector Lifecycle exceptions to be re-thrown rather than logged. This is controlled by the new `throwOnFailure` attribute of the Connector. (markt)
- Include the Context name in the log message when an item cannot be added to the cache. (markt)
- Exclude JAR files in `/WEB-INF/lib` from the static resource cache. (markt)
- When calling `getResourceAsStream()` on a directory, ensure that `null` is returned. (markt)
- 60161: Allow creating subcategories of the container logger, and use it for the rewrite valve. (remm)
- Correctly test for control characters when reading the provided shutdown password. (markt)
- 60297: Simplify connector creation in embedded mode. (remm)
- Refactor creation of containers in embedded mode for more consistency and flexibility. (remm)
- Log a warning if running on Java 9 with the ThreadLocal memory leak detection enabled (the default) but without the command line option it now requires. (markt)
- When a Connector is configured to use an executor, ensure that the StoreConfig component includes the executor name when writing the Connector configuration. (markt)
- When configuring the JMX remote listener, specify the allowed types for the credentials. (markt)

#### Coyote

- Correct the HPACK header table size configuration that transposed the client and server table sizes when creating the encoder and decoder. (markt)
- Review HTTP/2 implementation removing unused code, reducing visibility where possible and using final where appropriate. (markt)
- Don't continue to process an HTTP/2 stream if it is reset during header parsing. (markt)
- HTTP/2 uses separate headers for each Cookie. As required by RFC 7540, merge these into a single Cookie header before processing continues. (markt)
- Align the HTTP/2 implementation with the HTTP/1.1 implementation and return a 500 response when an unhandled exception occurs during request processing. (markt)
- Correct the HTTP header parser so that DEL is not treated as a valid token character. (markt)
- Add checks around the handling of HTTP/2 pseudo headers. (markt)
- Add support for trailer headers to the HTTP/2 implementation. (markt)
- 60232: When processing headers for an HTTP/2 stream, ensure that the read buffer is large enough for the header being processed. (markt)
- Add configuration options to the HTTP/2 implementation to control the maximum number of headers allowed, the maximum size of headers allowed, the maximum number of trailer headers allowed, the maximum size of trailer headers allowed and the maximum number of cookies allowed. (markt)
- Correctly differentiate between sending and receiving a reset frame when tracking the state of an HTTP/2 stream. (markt)
- Remove the undocumented support for using the old Connector attribute names `backlog`, `soLinger` and `soTimeout` that were renamed several major versions ago. (markt)
- 60319: When using an Executor, disconnect it from the Connector attributes `maxThreads`, `minSpareThreads` and `threadPriority` to enable the configuration settings to be consistently reported. These Connector attributes will be reported as `-1` when an Executor is in use. The values used by the executor may be set and obtained via the Executor. (markt)
- If an I/O error occurs during async processing on a non-container thread, ensure that the `onError()` event is triggered. (markt)
- Improve detection of I/O errors during async processing on non-container threads and trigger async error handling when they are detected. (markt)
- Add additional checks for valid characters to the HTTP request line parsing so invalid request lines are rejected sooner. (markt)

#### Jasper

- Update to the Eclipse JDT Compiler 4.6.1. (markt)

#### Web applications

- Add HTTP/2 configuration information to the documentation web application. (markt)
- Fix default value of `validationInterval` attribute in jdbc-pool. (kfujino)
- Correct a typo in CGI How-To. Issue reported via comments.apache.org. (violetagg)

#### Tribes

- When the proxy node sends a backup retrieve message, ensure that using the `channelSendOptions` that has been set rather than the default `channelSendOptions`. (kfujino)

#### Other

- Add the JASPIC API jar to the Maven Central publication script. (markt)
- Remove classes from tomcat-util-scan.jar that are duplicates of those in tomcat-util.jar. (markt)
- Update the NSIS Installer used to build the Windows installer to version 3.0. (markt)

### 2016-10-10 Tomcat 9.0.0.M11 (markt)

#### Catalina

- 59961: Add an option to the `StandardJarScanner` to control whether or not JAR Manifests are scanned for additional class path entries. (markt)
- 60013: Refactor the previous fix to align the behaviour of the Rewrite Valve with mod_rewrite. As part of this, provide an implementation for the `B` and `NE` flags and improve the handling for the `QSA` flag. Includes multiple test cases by Santhana Preethiand a patch by Tiago Oliveira. (markt)
- 60087: Refactor the web resources handling to use the Tomcat specific `war:file:...` URL protocol to refer to WAR files and their contents rather than the standard `jar:file:...` form since some components of the JRE, such as JAR verification, give unexpected results when the standard form is used. A side-effect of the refactoring is that when using packed WARs, it is now possible to reference a WAR and/or specific JARs within a WAR in the security policy file used when running under a `SecurityManager`. (markt)
- 60116: Fix a problem with the rewrite valve that caused back references evaluated in conditions to be forced to lower case when using the `NC` flag. (markt)
- Ensure `Digester.useContextClassLoader` is considered in case the class loader is used. (violetagg)
- 60117: Ensure that the name of `LogLevel` is localized when using `OneLineFormatter`. Patch provided by Tatsuya Bessho. (kfujino)
- 60138: Fix the `SSLHostConfig` so that the `protocols` attribute is limited to the protocols supported by the current JSSE implementation rather than the default protocols used by the implementation. (markt)
- 60146: Improve performance for resource retrieval by making calls to WebResource.getInputStream() trigger caching if the resource is small enough. Patch provided by mohitchugh. (markt)
- 60151: Improve the exception error messages when a `ResourceLink` fails to specify the type, specifies an unknown type or specifies the wrong type. (markt)
- 60167: Ignore empty lines in `/etc/passwd` files when using the `PasswdUserDatabase`. (markt)
- 60170: Exclude the compressed test file `index.html.br` from RAT analysis. Patch provided by Gavin McDonald. (markt)
- When starting web resources, ensure that class resources are only started once. (markt)
- Improve the access checks for linked global resources to handle the case where the current class loader is a child of the web application class loader. (markt)
- 60196: Ensure that the `isMandatory` flag is correctly set when using JASPIC authentication. (markt)
- 60199: Log a warning if deserialization issues prevent a session attribute from being loaded. (markt)
- 60208: When using RFC6265 compliant cookies, the `/` character should not be allowed in a cookie name since the RFC6265 will drop such cookies as invalid. (markt)
- Introduce new methods `read(ByteBuffer)`/ `write(ByteBuffer)` in `o.a.catalina.connector.CoyoteInputStream`/ `o.a.catalina.connector.CoyoteOutputStream`. (violetagg)

#### Coyote

- Refactor the code that implements the requirement that a call to `complete()` or `dispatch()` made from a non-container thread before the container initiated thread that called `startAsync()` completes must be delayed until the container initiated thread has completed. Rather than implementing this by blocking the non-container thread, extend the internal state machine to track this. This removes the possibility that blocking the non-container thread could trigger a deadlock. (markt)
- Fail earlier if the client closes the connection during SNI processing. (markt)
- 60123: Avoid potential threading issues that could cause excessively large values to be returned for the processing time of a current request. (markt)
- 60174: Log instances of `HeadersTooLargeException` during request processing. (markt)
- 60173: Allow up to 64kB HTTP/2 header table size limit. (remm)
- Java 9 compatibility of direct ByteBuffer cleaner. (remm)

#### Jasper

- 60101: Remove preloading of the class that was deleted. (violetagg)

#### Web applications

- Expand the documentation for the nested elements within a `Resources` element to clarify the behaviour of different configuration options with respect to the order in which resources are searched. (markt)
- Add an example of using the `classesToInitialize` attribute of the `JreMemoryLeakPreventionListener` to the documentation web application. Based on a patch by Cris Berneburg. (markt)
- 60192: Correct a typo in the status output of the Manager application. Patch provided by Radhakrishna Pemmasani. (markt)

#### jdbc-pool

- Notify jmx when returning the connection that has been marked suspect. (kfujino)
- Ensure that the `POOL_EMPTY` notification has been added to the jmx notification types. (kfujino)
- 60099: Ensure that use all method arguments as a cache key when using `StatementCache`. (kfujino)

#### Other

- Update the download location for Objenesis. (violetagg)
- 60164: Replace `log4j-core*.jar` with `log4j-web*.jar` since it is `log4j-web*.jar` that contains the `ServletContainerInitializer`. (markt)
- Add documentation to the bin/catalina.bat script to remind users that environment variables don't affect the configuration of Tomcat when run as a Windows Service. Based upon a documentation patch by James H.H. Lampert. (schultz)
- Update the packaged version of the Tomcat Native Library to 1.2.10 to pick up the latest Windows binaries built with OpenSSL 1.0.2j. (markt)

### 2016-09-05 Tomcat 9.0.0.M10 (markt)

#### Catalina

- 59813: Ensure that circular relations of the Class-Path attribute from JAR manifests will be processed correctly. (violetagg)
- Ensure that reading the `singleThreadModel` attribute of a `StandardWrapper` via JMX does not trigger initialisation of the associated servlet. With some frameworks this can trigger an unexpected initialisation thread and if initialisation is not thread-safe the initialisation can then fail. (markt)
- Compatibility with rewrite from httpd for non existing headers. (jfclere)
- By default, treat paths used to obtain a request dispatcher as encoded. This behaviour can be changed per web application via the `dispatchersUseEncodedPaths` attribute of the Context. (markt)
- Provide a mechanism that enables the container to check if a component (typically a web application) has been granted a given permission when running under a SecurityManager without the current execution stack having to have passed through the component. Use this new mechanism to extend SecurityManager protection to the system property replacement feature of the digester. (markt)
- When retrieving an object via a `ResourceLink`, ensure that the object obtained is of the expected type. (markt)
- 59823: Ensure that JASPIC configuration is taken into account when calling `HttpServletRequest.authenticate()`. (markt)
- 59824: Mark the `RewriteValve` as supporting async processing by default. (markt)
- 59839: Apply `roleSearchAsUser` to all nested searches in JNDIRealm. (fschumacher)
- 59859: Fix resource leak in WebDAV servlet. Based on patch by Coty Sutherland. (fschumacher)
- 59862: Allow nested jar files scanning to be filtered with the system property `tomcat.util.scan.StandardJarScanFilter.jarsToSkip`. Patch is provided by Terence Bandoian. (violetagg)
- 59866: When scanning `WEB-INF/classes` for annotations, don't scan the contents of `WEB-INF/classes/META-INF` (if present) since classes will never be loaded from that location. (markt)
- 59888: Correctly handle tabs and spaces in quoted version one cookies when using the `Rfc6265CookieProcessor`. (markt)
- A number of the JRE memory leaks addressed by the `JreMemoryLeakPreventionListener` have been fixed in Java 9 so the associated protection is now disabled when running on Java 9 onwards. (markt)
- 59912: Fix an edge case in input stream handling where an `IOException` could be thrown when reading a POST body. (markt)
- 59913: Correct a regression introduced with the support for the Servlet 4 `HttpServletRequest.getMapping()` API that caused the attributes for forwarded requests to be lost if requested from within a subsequent include. (markt)
- 59966: Do not start the web application if the error page configuration in web.xml is invalid. (markt)
- Switch the CGI servlet to the standard logging mechanism and remove support for the debug attribute. (markt)
- 60012: Improvements in the log messages. Based on suggestions by Nemo Chen. (violetagg)
- Changes to the `allowLinking` attribute of a `StandardRoot` instance now invalidate the cache if caching is enabled. (markt)
- Add a new initialisation parameter, `envHttpHeaders`, to the CGI Servlet to mitigate httpoxy (CVE-2016-5388) by default and to provide a mechanism that can be used to mitigate any future, similar issues. (markt)
- When adding and removing `ResourceLink`s dynamically, ensure that the global resource is only visible via the `ResourceLinkFactory` when it is meant to be. (markt)
- 60008: When processing CORs requests, treat any origin with a URI scheme of `file` as a valid origin. (markt)
- Improve handling of exceptions during a Lifecycle events triggered by a state transition. The exception is now caught and the component is now placed into the `FAILED` state. (markt)
- 60013: Fix encoding issues when using the RewriteValve with UTF-8 query strings or UTF-8 redirect URLs. (markt)
- 60022: Improve handling when a WAR file and/or the associated exploded directory are symlinked into the `appBase`. (markt)
- Fix a file descriptor leak when reading the global web.xml. (markt)
- Consistently decode URL patterns provided via web.xml using the encoding of the web.xml file where specified or UTF-8 where no explicit encoding is specified. (markt)
- Make timing attacks against the Realm implementations harder. (schultz)

#### Coyote

- Correct a regression in refactoring to enable injection of custom keystores that broke the automatic conversion of OpenSSL style PEM key and certificate files for use with JSSE TLS connectors. (markt)
- 59910: Don't hardcode key alias value to "tomcat" for JSSE. When using a keystore, OpenSSL will still default to it. (remm)
- 59904: Add a limit (default 200) for the number of cookies allowed per request. Based on a patch by gehui. (markt)
- 59925: Correct regression in r1628368 and ensure that HTTP separators are handled as configured in the `LegacyCookieProcessor`. Patch provided by Kyohei Nakamura. (markt)
- 59950: Correct log message when reporting that the current number of HTTP/2 streams for a connection could not be pruned to below the limit. (markt)
- Ensure that `Semaphore.release` is called in all cases. Even when there is an exception. (violetagg)
- 60030: Correct a potential infinite loop in the SNI parsing code triggered by failing to handle an end of stream condition. (markt)
- Refactor the JSSE client certificate validation so that the effectiveness of the `certificateVerificationDepth` configuration attribute does not depend on the presence of a certificate revocation list. (markt)
- Small logging optimization in the `Rfc6265CookieProcessor`. Patch provided by Svetlin Zarev. (markt)
- OpenSSL now disables 3DES by default so reflect this when using OpenSSL syntax to select ciphers. (markt)
- Use the proper ERROR socket status code for async errors with NIO2. (remm)
- 60035: Fix a potential connection leak if the client drops a TLS connection before the handshake completes. (markt)
- Log a warning at start up if a JSSE TLS connector is configured with a trusted certificate that is either not yet valid or has expired. (markt)

#### Jasper

- When writing out a full web.xml file with JspC ensure that the encoding used in the XML prolog matches the encoding used to write the contents of the file. (markt)
- Improve the error handling for custom tags to ensure that the tag is returned to the pool or released and destroyed once used. (markt)
- 60032: Fix handling of method calls that use varargs within EL value expressions. (markt)
- Ignore `engineOptionsClass` and `scratchdir` when running under a security manager. (markt)
- Fixed StringIndexOutOfBoundsException. Based on a patch provided by wuwen via Github. (violetagg)

#### WebSocket

- 59908: Ensure that a reason phrase is included in the close message if a session is closed due to a timeout. (markt)

#### Web applications

- 59867: Correct the documentation provided by Manager's 403.jsp. (violetagg)
- 59868: Clarify the documentation for the Manager web application to make clearer that the host name and IP address in the server section are the primary host name and IP address. (markt)
- 59940: Correct the name of the `truststorePassword` attribute of the `SSLHostConfig` element in the configuration documentation. (markt)
- MBeans Descriptors How-To is moved to `mbeans-descriptors-howto.html`. Patch provided by Radoslav Husar. (violetagg)
- Update NIO Connector configuration documentation with an information about `socket.directSslBuffer`. (violetagg)
- 60034: Correct a typo in the Manager How-To page of the documentation web application. (markt)
- Correct the name of the CRL location configuration attributes in the documentation web application. (markt)

#### jdbc-pool

- In order to avoid the unintended skip of `PoolCleaner`, remove the check code of the execution interval in the task that has been scheduled. (kfujino)
- 59850: Ensure that the `ResultSet` is closed when enabling the `StatementCache` interceptor. (kfujino)
- 59923: Reduce the default value of `validationInterval` in order to avoid the potential issue that continues to return an invalid connection after database restart. (kfujino)
- Ensure that the `ResultSet` is returned as Proxy object when enabling the `StatementDecoratorInterceptor`. (kfujino)
- 60043: Ensure that the `suspectTimeout` works without removing connection when the `removeAbandoned` is disabled. (kfujino)
- Add log message of when returning the connection that has been marked suspect. (kfujino)
- Correct Javadoc for `ConnectionPool.suspect()`. Based on a patch by Yahya Cahyadi. (markt)

#### Other

- 59871: Add a property (`timeFormat`) to JULI's `OneLineFormatter` to enable the format of the time stamp used in log messages to be configured. (markt)
- 59899: Update Tomcat's copy of the Java Persistence annotations to include the changes made in 2.1 / JavaEE 7. (markt)
- Fixed typos in mbeans-descriptors.xml files. (violetagg)
- Update the internal fork of Commons BCEL to r1757132 to align with the BCEL 6 release. (markt)
- Update the internal fork of Commons DBCP 2 to r1757164 to pick up a couple of bug fixes. (markt)
- Update the internal fork of Commons Codec to r1757174. Code formatting changes only. (markt)
- Update the internal fork of Commons FileUpload to afdedc9. This pulls in a fix to improve the performance with large multipart boundaries. (markt)

### 2016-07-12 Tomcat 9.0.0.M9 (markt)

#### Catalina

- 18500: Add limited support for wildcard host names and host aliases. Names of the form `*.domainname` are now permitted. Note that an exact host name match takes precedence over a wild card host name match. (markt)
- 57705: Add debug logging for requests denied by the remote host and remote address valves and filters. Based on a patch by Graham Leggett. (markt)
- Correct a regression in the fix for 58588 that removed the entire `org.apache.juli` package from the embedded JARs rendering them unusable. (markt)
- 59399: Add a new option to the Realm implementations that ship with Tomcat that allows the HTTP status code used for HTTP -> HTTPS redirects to be controlled per Realm. (markt)
- 59708: Modify the LockOutRealm logic. Valid authentication attempts during the lock out period will no longer reset the lock out timer to zero. (markt)
- Change the default of the `sessionCookiePathUsesTrailingSlash` attribute of the `Context` element to `false` since the problems caused when a Servlet is mapped to `/*` are more significant than the security risk of not enabling this option by default. (markt)
- Follow-up to 59655. Improve the documentation for configuring permitted cookie names. Patch provided by Kyohei Nakamura. (markt)
- Do not attempt to start web resources during a web application's initialisation phase since the web application is not fully configured at that point and the web resources may not be correctly configured. (markt)
- Improve error handling around user code prior to calling `InstanceManager.destroy()` to ensure that the method is executed. (markt)

#### Coyote

- Fix a cause of multiple attempts to close the same socket. (markt)
- Refactor the certificate keystore and trust store generation to make it easier for embedded users to inject their own key stores. (markt)
- Add a `maxConcurrentStreamExecution` on the HTTP/2 protocol handler to allow restricting the amount of concurrent stream that are being executed in a single connection. The default is to not limit it. (remm)
- 59233: Add the ability to add TLS virtual hosts dynamically. (markt)
- Correct a problem with `ServletRequest.getServerPort()` for secure HTTP/2 connections that meant an incorrect value was returned when using the default port. (markt)
- Improve error handling around user code prior to calling `InstanceManager.destroy()` to ensure that the method is executed. (markt)
- Document the default for the HTTP/2 configuration parameter `maxConcurrentStreamExecution` as 20. (markt)

#### Jasper

- Improve error handling around user code prior to calling `InstanceManager.destroy()` to ensure that the method is executed. (markt)

#### WebSocket

- Now the WebSocket implementation is not built directly on top of the Servlet API and can use Tomcat internals, there is no need for the dedicated WebSocket Executor. It has been replaced by the use of the Connector/Endpoint provided Executor. (markt)
- Improve error handling around user code prior to calling `InstanceManager.destroy()` to ensure that the method is executed. (markt)

#### Web Applications

- Do not log an additional case of `IOException`s in the error handler for the Drawboard WebSocket example when the root cause is the client disconnecting since the logs add no value. (markt)
- 59642: Mention the `localDataSource` in the `DataSourceRealm` section of the Realm How-To. (markt)
- 59672: Update the security considerations page of the documentation web application to take account of the fact that the Manager and HostManager applications now have a `RemoteAddrValve` configured by default. (markt)
- Follow-up to the fix for 59399. Ensure that the new attribute `transportGuaranteeRedirectStatus` is documented for all Realms. Also document the `NullRealm` and when it is automatically created for an Engine. (markt)
- Fix the description of `maxAge` attribute in jdbc-pool doc. This attribute works both when a connection is returned and when a connection is borrowed. (kfujino)
- 59774: Correct the `prefix` values in the documented examples for configuring the `AccessLogValve`. Patch provided by Mike Noordermeer. (markt)

#### Tribes

- Add log message when the ping has timed-out. (kfujino)
- If the ping message has been received at the `AbstractReplicatedMap#leftOver` method, ensure that notify the member is alive than ignore it. (kfujino)

#### jdbc-pool

- Fix the duplicated connection release when connection verification failed. (kfujino)
- Ensure that do not remove the abandoned connection that has been already released. (kfujino)

#### Other

- Remove JULI plus log4j extras and embedded artifacts from Maven release script. (markt)
- Use the mirror network rather than the ASF master site to download the current ASF dependencies. (markt)
- Update the packaged version of the Tomcat Native Library to 1.2.8 to pick up the latest fixes and make 1.2.8 the minimum recommended version. (markt)

### 2016-06-13 Tomcat 9.0.0.M8 (markt)

#### Coyote

- Remove accidentally committed debug code. (markt)

### not released Tomcat 9.0.0.M7 (markt)

#### Catalina

- RMI Target related memory leaks are avoidable which makes them an application bug that needs to be fixed rather than a JRE bug to work around. Therefore, start logging RMI Target related memory leaks on web application stop. Add an option that controls if the check for these leaks is made. Log a warning if running on Java 9 with this check enabled but without the command line option it requires. (markt)
- Ensure NPE will not be thrown during deployment when scanning jar files without MANIFEST.MF file. (violetagg)
- Remove the `clearReferencesStatic` option from `StandardContext`. It was known to cause problems with some libraries (such as log4j) and was only linked to suspected memory leaks rather than known memory leaks. It had been disabled by default with no increase in the reports of memory leaks for some time. (markt)
- 59604: Correct the assumption made in the URL decoding that the default platform encoding is always compatible with ISO-8859-1. This assumption is not always valid, e.g. on z/OS. (markt)
- 59608: Skip over any invalid `Class-Path` attribute from JAR manifests. Log errors at debug level due to many bad libraries. (remm)
- Fix error message when failed to register MBean. (kfujino)
- 59655: Configure the cookie name validation to use RFC6265 rules by default to align it with the default cookie parser. Document the impact system properties have on cookie name validation. (mark)

#### Coyote

- Ensure that requests with HTTP method names that are not tokens (as required by RFC 7231) are rejected with a 400 response. (markt)
- When an asynchronous request is processed by the AJP connector, ensure that request processing has fully completed before starting the next request. (markt)
- Improve handling of HTTP/2 stream resets. (markt)
- 58750: The HTTP Server header is no longer set by default. A Server header may be configured by setting the `server` attribute on the `Connector`. A new `Connector` attribute, `serverRemoveAppProvidedValues` may be used to remove any Server header set by a web application. (markt)
- 59564: Correct offset when reading into HTTP/2 input buffer that could cause problems reading request bodies. (violetagg/markt)
- Modify the handling of read/write timeouts so that the appropriate error handling (`ReadListener.onError()`, `WriteListener.onError()` or `AsyncListener.onError()`) is called. (markt)
- If an async dispatch results in the completion of request processing, ensure that any remaining request body is swallowed before starting the processing of the next request else the remaining body may be read as the start of the next request leading to a 400 response. (markt)

#### Jasper

- 59567: Fix NPE scanning webapps for TLDs when an exploded JAR has an empty WEB-INF/classes/META-INF folder. (remm)
- Fix a memory leak in the expression language implementation that caused the class loader of the first web application to use expressions to be pinned in memory. (markt)
- 59654: Improve error message when attempting to use a TLD file from an invalid location. Patch provided by Huxing Zhang. (markt)

#### WebSocket

- 59659: Fix possible memory leak in WebSocket handling of unexpected client disconnects. (markt)

#### Web applications

- 58891: Update the SSL How-To. Based on a suggestion by Alexander Kjäll. (markt)

#### Extras

- 58588: Remove the JULI extras package from the distribution. It was only useful for switching Tomcat's internal logging to log4j 1.2.x and that version of log4j is no longer supported. No additional Tomcat code is required if switching Tomcat's internal logging to log via log4j 2.x. (markt)

#### jdbc-pool

- Fix a memory leak with the pool cleaner thread that retained a reference to the web application class loader for the first web application to use a connection pool. (markt)

#### Other

- Update the internal fork of Commons DBCP 2 to r1743696 (2.1.1 plus additional fixes). (markt)
- Update the internal fork of Commons Pool 2 to r1743697 (2.4.2 plus additional fixes). (markt)
- Update the internal fork of Commons File Upload to r1743698 (1.3.1 plus additional fixes). (markt)
- Use UTF-8 with a standard prolog for all XML files. (markt)
- 58626: Add support for a new environment variable (`USE_NOHUP`) that causes `nohup` to be used when starting Tomcat. It is disabled by default except on HP-UX where it is enabled by default since it is required when starting Tomcat at boot on HP-UX. (markt)

### 2016-05-16 Tomcat 9.0.0.M6 (markt)

#### Catalina

- Ensure that annotated web components packed in web fragments will be processed when `unpackWARs` is enabled. (violetagg)

### not released Tomcat 9.0.0.M5 (markt)

#### Catalina

- 48922: Apply a very small performance improvement to the date formatting in Tomcat's internal request object. Based on a patch provided by Ondrej Medek. (markt)
- 59206: Ensure NPE will not be thrown by `o.a.tomcat.util.file.ConfigFileLoader` when `catalina.base` is not specified. (violetagg)
- 59217: Remove duplication in the recycling of the path in `o.a.tomcat.util.http.ServerCookie`. Patch is provided by Kyohei Nakamura. (violetagg)
- Fixed possible NPE in `o.a.catalina.loader.WebappClassLoaderBase.getResourceAsStream` (violetagg)
- 59213: Async dispatches should be based off a wrapped request. (remm)
- Ensure that `javax.servlet.ServletRequest` and `javax.servlet.ServletResponse` provided during `javax.servlet.AsyncListener` registration are made available via `javax.servlet.AsyncEvent.getSuppliedRequest` and `javax.servlet.AsyncEvent.getSuppliedResponse` (violetagg)
- 59219: Ensure `AsyncListener.onError()` is called if an `Exception` is thrown during async processing. (markt)
- 59220: Ensure that `AsyncListener.onComplete()` is called if the async request times out and the response is already committed. (markt)
- 59226: Process the `Class-Path` attribute from JAR manifests for JARs on the class path excluding JARs packaged in `WEB-INF/lib`. (markt)
- 59255: Fix possible NPE in mapper. (kkolinko/remm)
- 59256: `slf4j-taglib*.jar` should not be excluded from the standard JAR scanning by default. (violetagg)
- Clarify the log message that specifying both urlPatterns and value attributes in @WebServlet and @WebFilter annotations is not allowed. (violetagg)
- Ensure the exceptions caused by Valves will be available in the log files so that they can be evaluated when `o.a.catalina.valves.ErrorReportValve.showReport` is disabled. Patch is provided by Svetlin Zarev. (violetagg)
- Remove unused `distributable` attribute that is defined as `TransientAttribute` of `Manager` in StoreConfig. (kfujino)
- Fix handling of Cluster Receiver in StoreConfig. The `bind` and `host` attributes define as `TransientAttribute`. (kfujino)
- 59261: `ServletRequest.getAsyncContext()` now throws an `IllegalStateException` as required by the Servlet specification if the request is not in asynchronous mode when called. (markt)
- 59269: Correct the implementation of `PersistentManagerBase` so that `minIdleSwap` functions as designed and sessions are swapped out to keep the active session count below `maxActiveSessions`. (markt)
- Update the implementation of the proposed Servlet 4.0 API to provide mapping type information for the current request to reflect discussions within the EG. (markt)
- Correctly configure the base path for a resources directory provided by an expanded JAR file. Patch provided by hengyunabc. (markt)
- When multiple compressed formats are available and the client does not express a preference, use the server order to determine the preferred format. Based on a patch by gmokki. (markt)
- 59284: Allow the Tomcat provided JASPIC `SimpleServerAuthConfig` to pick up module configuration properties from either the property set passed to its constructor or from the properties passed in the call to `getAuthContext`. Based on a patch by Thomas Maslen. (markt)
- 59310: Do not add a `Content-Length: 0` header for custom responses to `HEAD` requests that do not set a `Content-Length` value. (markt)
- When normalizing paths, improve the handling when paths end with `/.` or `/..` and ensure that input and output are consistent with respect to whether or not they end with `/`. (markt)
- 59317: Ensure that `HttpServletRequest.getRequestURI()` returns an encoded URI rather than a decoded URI after a dispatch. (markt)
- Use the correct URL for the fragment when reporting errors processing a `web-fragment.xml` file from a JAR located in an unpacked WAR. (markt)
- Ensure that `JarScanner` only uses the explicit call-back to process `WEB-INF/classes` and only when configured to treat the contents of `WEB-INF/classes` as a possible exploded JAR. (markt)
- Remove the `java2DDisposerProtection` option from the `JreMemoryLeakPreventionListener`. The leak is fixed in Java 7 onwards and Tomcat 9 requires Java 8 so the option is unnecessary. (markt)
- Remove the `securityPolicyProtection` option from the `JreMemoryLeakPreventionListener`. The leak is fixed in Java 8 onwards and Tomcat 9 requires Java 8 so the option is unnecessary. (markt)
- Remove the `securityLoginConfigurationProtection` option from the `JreMemoryLeakPreventionListener`. The leak is fixed in Java 8 onwards and Tomcat 9 requires Java 8 so the option is unnecessary. (markt)
- Ensure that the value for the header `X-Frame-Options` is constructed correctly according to the specification when `ALLOW-FROM` option is used. (violetagg)
- Fix an `IllegalArgumentException` if the first use of an internal `Response` object requires JASPIC authentication. (markt)
- Do not trigger unnecessary session ID changes when using JASPIC and the user is authenticated using cached credentials. (markt)
- 59437: Ensure that the JASPIC `CallbackHandler` is thread-safe. (markt)
- 59449: In `ContainerBase`, ensure that the process to remove a child container is the reverse of the process to add one. Patch provided by Huxing Zhang. (markt)

#### Coyote

- Improves OpenSSL engine robustness when SSL allocation fails for some reason. (remm)
- OpenSSL engine code cleanups. (remm)
- Align cipher configuration parsing with current OpenSSL master. (markt)
- Change the default for `honorCipherOrder` to `false`. With the current default TLS configuration, it is no longer necessary for this to be `true` for a reasonably secure configuration. (markt)
- Add a new environment variable `JSSE_OPTS` that is intended to be used to pass JVM wide configuration to the JSSE implementation. The default value is `-Djdk.tls.ephemeralDHKeySize=2048` which protects against weak Diffie-Hellman keys. (markt)
- 58970: Fix a connection counting bug in the NIO connector that meant some dropped connections were not removed from the current connection count. (markt)
- 59289: Do not recycle upgrade processors in unexpected close situations. (remm)
- 59295: Use `Locale.toLanguageTag()` to construct the `Content-Language` HTTP header to ensure the locale is correctly represented. Patch provided by zikfat. (markt)
- 59295: Add support for using pem encoded certificates with JSSE SSL. Submitted by Emmanuel Bourg with additional tweaks. (remm)
- Make the TLS certificate chain available to clients when using JSSE+OpenSSL with the certificate chain stored in a Java KeyStore. (markt)
- Work around a known issue in OpenSSL that does not permit the TLS handshake to be failed if the ALPN negotiation fails. (markt)
- 59421: Add direct HTTP/2 connection support. (remm)
- Correctly handle a call to `AsyncContext.complete()` from a non-container thread when non-blocking I/O is being used. (markt)
- 59451: Correct Javadoc for `MessageBytes`. Patch provided by Kyohei Nakamura. (markt)
- 59450: Correctly handle the case where the `LegacyCookieProcessor` is configured with `allowHttpSepsInV0` set to `false` and `forwardSlashIsSeparator` set to `true`. Patch provided by Kyohei Nakamura. (markt)

#### Jasper

- When scanning JARs for TLDs, correctly handle the (rare) case where a JAR has been exploded into `WEB-INF/classes` and the web application is deployed as a packed WAR. (markt)
- 59640: NPEs with not found TLDs. (remm)

#### WebSocket

- 59189: Explicitly release the native memory held by the `Inflater` and `Deflater` when using PerMessageDeflate and the WebSocket session ends. Based on a patch by Henrik Olsson. (markt)
- Restore the `WsServerContainer.doUpgrade()` method which was accidentally removed since it is not used by Tomcat. (markt)
- Fix a regression caused by the connector refactoring and ensure that the thread context class loader is set to the web application classloader when processing WebSocket messages on the server. (markt)
- Ensure that a client disconnection triggers the error handling for the associated WebSocket end point. (markt)
- Make WebSocket client more robust when handling errors during the close of a WebSocket session. (markt)

#### Web applications

- 59218: Correct the path to `jaspic-providers.xml` in Jaspic How-To. Patch is provided by Tatsuya Bessho. (violetagg)
- Remove button that has accidentally been added to the host manager. Submitted by Coty Sutherland. (remm)
- Update in the documentation the link to the maven repository where Tomcat snapshot artifacts are deployed. (markt/violetagg)
- Clarify in the documentation that calls to `ServletContext.log(String, Throwable)` or `GenericServlet.log(String, Throwable)` are logged at the SEVERE level. (violetagg)
- Correct a typo in SSL/TLS Configuration How-To. Issue reported via comments.apache.org. (violetagg)

#### Tribes

- Avoid NPE when a proxy node failed to retrieve a backup entry. (kfujino)
- Add the flag indicating that member is a localMember. (kfujino)
- Fix potential NPE that depends on the setting order of attributes of static member when using the static cluster. (kfujino)
- Add get/set method for the channel that is related to `ChannelInterceptor`. (kfujino)
- As with the multicast cluster environment, in the static cluster environment, the local member inherits properties from the cluster receiver. (kfujino)
- Add get/set method for the channel that is related to each Channel services. (kfujino)
- Add name to channel in order to identify channels. In tomcat cluster environment, it is set the cluster name + "-Channel" as default value. (kfujino)
- Add the channel name to the thread which is invoked by channel services in order to identify the associated channel. (kfujino)
- Ensure that clear the channel instance from channel services when stopping channel. (kfujino)
- Implement map state in the replication map. (kfujino)
- Ensure that the ping is not executed during the start/stop of the replication map. (kfujino)
- In ping processing in the replication map, send not the `INIT` message but the newly introduced `PING` message. (kfujino)

#### Other

- 59211: Add hamcrest to Eclipse classpath. Patch is provided by Huxing Zhang. (violetagg)
- 59276: Update optional Checkstyle library to 6.17. (kkolinko)
- 59280: Update the NSIS Installer used to build the Windows Installers to version 2.51. (kkolinko)
- Update the packaged version of the Tomcat Native Library to 1.2.7 to pick up the Windows binaries that are based on OpenSSL 1.0.2h and APR 1.5.2. (markt)

### 2016-03-16 Tomcat 9.0.0.M4 (markt)

#### Catalina

- Ensure that `/WEB-INF/classes` is never processed as a web fragment. (markt)
- Switch default connector when native is installed. Unless configured otherwise, the NIO endpoint will be used by default. If SSL is configured, OpenSSL will be used rather than JSSE. (remm)
- Correct a regression in the fix for 58867. When configuring a Context to use an external directory for the `docBase`, and that directory happens to be located along side the original WAR, use the directory as the `docBase` rather than expanding the WAR into the `appBase` and using the newly created expanded directory as the `docBase`. (markt)
- 58351: Make the server build date and server version number accessible via JMX. Patch provided by Huxing Zhang. (markt)
- 58988: Special characters in the substitutions for the RewriteValve can now be quoted with a backslash. (fschumacher)
- 58999: Fix class and resource name filtering in WebappClassLoader. It throws a StringIndexOutOfBoundsException if the name is exactly "org" or "javax". (rjung)
- Add JASPIC (JSR-196) support. (markt)
- Make checking for var and map replacement in RewriteValve a bit stricter and correct detection of colon in var replacement. (fschumacher)
- Refactor the web application class loader to reduce the impact of JAR scanning on the memory footprint of the web application. (markt)
- Fix some resource leaks in the error handling for accessing files from JARs and WARs. (markt)
- Refactor the JAR and JAR-in-WAR resource handling to reduce the memory footprint of the web application. (markt)
- Refactor the web.xml parsing so a new parser is created every time the web application starts rather than creating and caching the parser when the Context is created. This enables the parser to take account of modified Context configuration parameters and reduces (slightly) the memory footprint of a running Tomcat instance. (markt)
- Switch the web application class loader to the `ParallelWebappClassLoader` by default. (markt)
- 57809: Remove the custom context attribute that held the effective web.xml. Components needing access to configuration information may access it via the Servlet API. (markt)
- Refactor JAR scanning to reduce memory footprint. (markt)
- 59001: Correctly handle the case when Tomcat is installed on a path where one of the segments ends in an exclamation mark. (markt)
- Expand the fix for 59001 to cover the special sequences used in Tomcat's custom jar:war: URLs. (markt)
- 59043: Avoid warning while expiring sessions associated with a single sign on if `HttpServletRequest.logout()` is used. (markt)
- 59054: Ensure that using the `CrawlerSessionManagerValve` in a distributed environment does not trigger an error when the Valve registers itself in the session. (markt)
- Add socket properties support to storeconfig. (remm)
- Fix incorrect parsing of the NE and NC flags in rewrite rules. (remm)
- 59065: Correct the timing of the check for colons in paths on non-Windows systems implemented in `catalina.sh` so it works correctly with Cygwin. Patch provided by Ed Randall. (markt)
- When a Host is configured with an appBase that does not exist, create the appBase before trying to expand an external WAR file into it. (markt)
- 59115: When using the Servlet 3.0 file upload, the submitted file name may be provided as a token or a quoted-string. If a quoted-string, unquote the string before returning it to the user. (markt)
- 59123: Close `NamingEnumeration` objects used by the `JNDIRealm` once they are no longer required. (fschumacher/markt)
- Implement the proposed Servlet 4.0 API to provide mapping type information for the current request. (markt)
- 59138: Correct a false positive warning for ThreadLocal related memory leaks when the key class but not the value class has been loaded by the web application class loader. (markt)
- 59017: Make the pre-compressed file support in the Default Servlet generic so any compression may be used rather than just gzip. Patch provided by Mikko Tiihonen. (markt)
- 59145: Don't log an invalid warning when a user logs out of a session associated with SSO. (markt)
- 59150: Add an additional flag on APR listener to allow disabling automatic use of OpenSSL. (remm)
- 59151: Fix a regression in the fix for 56917 that added additional (and arguably unnecessary) validation to the provided redirect location. (markt)
- 59154: Fix a `NullPointerException` in the `JAASMemoryLoginModule` resulting from the introduction of the `CredentialHandler` to `Realm`s. (schultz/markt)

#### Coyote

- Handle the case in the NIO2 connector where the required TLS buffer sizes increase after the connection has been initiated. (markt/remm)
- Bad processing of handshake errors in NIO2. (remm)
- Use JSSE session configuration options with OpenSSL. (remm)
- 59015: Fix potential cause of endless APR Poller loop during shutdown if the Poller experiences an error during the shutdown process. (markt)
- Align cipher aliases for `kECDHE` and `ECDHE` with the current OpenSSL implementation. (markt)
- 59081: Retain the user defined cipher order when defining ciphers. (markt)
- 59089: Correctly ignore HTTP headers that include non-token characters in the header name. (markt)

#### Jasper

- Update to the Eclipse JDT Compiler 4.5.1. (markt)
- 57583: Improve the performance of `javax.servlet.jsp.el.ScopedAttributeELResolver` when resolving attributes that do not exist. This improvement only works when Jasper is used with Tomcat's EL implementation. (markt)

#### WebSocket

- Fix a timing issue on session close that could result in an exception being thrown for an incomplete message even through the message was completed. (markt)
- Correctly handle compression of partial messages when the final message fragment has a zero length payload. (markt)
- 59119: Correct read logic for WebSocket client when using secure connections. (markt)
- 59134: Correct client connect logic for secure connections made through a proxy. (markt)

#### Web applications

- Correct an error in the documentation of the expected behaviour for automatic deployment. If a WAR is updated and an expanded directory is present, the directory will always be deleted and recreated by expanding the WAR if `unpackWARs` is `true`. (markt)
- 48674: Implement an option within the Host Manager web application to persist the current configuration. Based on a patch by Coty Sutherland. (markt)
- 58935: Remove incorrect references in the documentation to using `jar:file:` URLs with the Manager application. (markt)
- Correct the description of the `ServletRequest.getServerPort()` in Proxy How-To. Issue reported via comments.apache.org. (violetagg)
- The Manager and Host Manager applications are now only accessible via `localhost` by default. (markt)

#### Tribes

- If promoting a proxy node to a primary node when getting a session, notify the change of the new primary node to the original backup node. (kfujino)

#### Other

- 58283: Change the default download location for libraries during the build process from `/usr/share/java` to `${user.home}/temp`. Patch provided by Ahmed Hosni. (markt)
- 59031: When using the Windows uninstaller, do not remove the contents of any directories that have been symlinked into the Tomcat directory structure. (markt)
- Update the packaged version of the Tomcat Native Library to 1.2.5 to pick up the Windows binaries that are based on OpenSSL 1.0.2g and APR 1.5.1. (markt)
- Modify the default `tomcat-users.xml` file to make it harder for users to configure the entries intended for use with the examples web application for the Manager application. (markt)

### 2016-02-05 Tomcat 9.0.0.M3 (markt)

#### General

- Allow to configure multiple JUnit test class patterns with the build property `test.name` and document the property in BUILDING.txt. (rjung)

#### Catalina

- Protect initialization of `ResourceLinkFactory` when running with a SecurityManager. (kkolinko)
- Correct a thread safety issue in the filtering of session attributes based on the implementing class name of the value object. (markt)
- Fix class loader decision on the delegation for class loading and resource lookup and make it faster too. (rjung)
- 58768: Log a warning if a redirect fails because of an invalid location. (markt)
- 58827: Remove remains of JSR-77 implementation. (markt)
- 58946: Ensure that the request parameter map remains immutable when processing via a RequestDispatcher. (markt)
- 58905: Ensure that `Tomcat.silence()` silences the correct logger and respects the current setting. (markt)

#### Coyote

- Correct a regression in the connector refactoring in 9.0.0.M2 that broke TLS support for the APR/native connector. (remm)
- Correct an NPE when listing the enabled ciphers (e.g. via the Manager web application) for a TLS enabled APR/native connector. (markt)
- New configuration option `ajpFlush` for the AJP connectors to disable the sending of AJP flush packets. (rjung)
- Handle the case in the NIO connector where the required TLS buffer sizes increase after the connection has been initiated. (markt)

### not released Tomcat 9.0.0.M2 (markt)

#### Catalina

- Refactor creation of `MapperListener` to ensure that the `Mapper` used is the `Mapper` associated with the `Service` for which the listener was created. (markt)
- Move the functionality that provides redirects for context roots and directories where a trailing `/` is added from the Mapper to the `DefaultServlet`. This enables such requests to be processed by any configured Valves and Filters before the redirect is made. This behaviour is configurable via the `mapperContextRootRedirectEnabled` and `mapperDirectoryRedirectEnabled` attributes of the Context which may be used to restore the previous behaviour. (markt)
- Refactor `Service.getContainer()` to return an `Engine` rather than a `Container`. (markt)
- 34319: Only load those keys in `StoreBase.processExpire` from JDBCStore, that are old enough, to be expired. Based on a patch by Tom Anderson. (fschumacher)
- 56917: As per RFC7231 (HTTP/1.1), allow HTTP/1.1 and later redirects to use relative URIs. This is controlled by a new attribute `useRelativeRedirects` on the Context and defaults to `true`. (markt)
- 58629: Allow an embedded Tomcat instance to start when the `Service` has no `Engine` configured. (markt)
- Correctly notify the MapperListener associated with a Service if the Engine for that Service is changed. (markt)
- Make a web application's CredentialHandler available through a context attribute. This allows a web application to use the same algorithm for validating or generating new stored credentials from cleartext ones. (schultz)
- 58635: Enable break points to be set within agent code when running Tomcat with a Java agent. Based on a patch by Huxing Zhang. (markt)
- Fixed potential NPE in `HostConfig` while deploying an application. Issue reported by coverity scan. (violetagg)
- 58655: Fix an `IllegalStateException` when calling `HttpServletResponse.sendRedirect()` with the `RemoteIpFilter`. This was caused by trying to correctly generate the absolute URI for the redirect. With the fix for 56917, redirects may now be relative making the `sendRedirect()` implementation for the `RemoteIpFilter` much simpler. This also addresses issues where the redirect may not have behaved as expected when redirecting from http to https to from https to http. (markt)
- 58657: Exceptions in a Servlet 3.1 `ReadListener` or `WriteListener` do not need to be immediately fatal to the connection. Allow an error response to be written. (markt)
- Correct implementation of `validateClientProvidedNewSessionId` so client provided session IDs may be rejected if validation is enabled. (markt)
- 58701: Reset the `instanceInitialized` field in `StandardWrapper` when unloading a Servlet so that a new instance may be correctly initialized. (markt)
- Add a new flag `aprPreferred` to the Apr listener. if set to `false`, when using the connector defaults, it will use NIO + OpenSSL if tomcat-native is available, rather than the APR connector. (remm)
- Add path parameter handling to `HttpServletRequest.getContextPath()`. This is a follow-up to the fix for 57215. (markt)
- 58692: Make `StandardJarScanner` more robust. Log a warning if a class path entry cannot be scanned rather than triggering the failure of the web application. Includes a test case written by Derek Abdine. (markt)
- 58702: Ensure an access log entry is generated if the client aborts the connection. (markt)
- Fixed various issues reported by Findbugs. (violetagg)
- 58735: Add support for the `X-XSS-Protection` header to the `HttpHeaderSecurityFilter`. Patch provided by Jacopo Cappellato. (markt)
- Add the `StatusManagerServlet` to the list of Servlets that can only be loaded by privileged applications. (markt)
- Simplify code and fix messages in `org.apache.catalina.core.DefaultInstanceManager` class. (kkolinko)
- 58751: Correctly handle the case where an `AsyncListener` dispatches to a Servlet on an asynchronous timeout and the Servlet uses `sendError()` to trigger an error page. Includes a test case based on code provided by Andy Wilkinson.(markt)
- Ensure that the proper file encoding if specified will be used when a readme file is served by DefaultServlet. (violetagg)
- Fix declaration of `localPort` attribute of Connector MBean: it is read-only. (kkolinko)
- 58766: Make skipping non-class files during annotation scanning faster by checking the file name first. Improve debug logging. (kkolinko)
- 58836: Correctly merge query string parameters when processing a forwarded request where the target includes a query string that contains a parameter with no value. (markt/kkolinko)
- Make sure that shared Digester is reset in an unlikely error case in `HostConfig.deployWAR()`. (kkolinko)
- Extend the feature available in the cluster session manager implementations that enables session attribute replication to be filtered based on attribute name to all session manager implementations. Note that configuration attribute name has changed from `sessionAttributeFilter` to `sessionAttributeNameFilter`. Apply the filter on load as well as unload to ensure that configuration changes made while the web application is stopped are applied to any persisted data. (markt)
- Extend the session attribute filtering options to include filtering based on the implementation class of the value and optional `WARN` level logging if an attribute is filtered. These options are available for all of the Manager implementations that ship with Tomcat. When a `SecurityManager` is used filtering will be enabled by default. (markt)
- Remove `distributable` and `maxInactiveInterval` from the `Manager` interface because the attributes are never used. The equivalent attributes from the `Context` always take precedence. (markt)
- 58867: Improve checking on Host start for WAR files that have been modified while Tomcat has stopped and re-expand them if `unpackWARs` is `true`. (markt)
- 58900: Correctly undeploy symlinked resources and prevent an infinite cycle of deploy / undeploy. (markt)

#### Coyote

- 58621: The certificate chain cannot be set using the main certificate attribute, so restore the certificate chain property. (remm)
- Allow a new SSL config type where a connector can use either JSSE or OpenSSL. Both could be allowed, but it would likely create support issues. This type is used by the OpenSSL implementation for NIOx. (remm)
- Improve upgrade context classloader handling by using Context.bind and unbind. (remm)
- Improve OpenSSL keystore/truststore configuration by using the code from the JSSE implementation. (remm, jfclere)
- Fix a potential loop when a client drops the connection unexpectedly. (markt)
- OpenSSL renegotiation support for client certificate authentication. (remm)
- Fix NIO connector renegotiation. (remm)
- 58659: Fix a potential deadlock during HTTP/2 processing when the connection window size is limited. (markt)

#### Jasper

- 57136#c25: Change default value of `quoteAttributeEL` setting in Jasper to be `true` for better compatibility with other implementations and older versions of Tomcat. Add command line option `-no-quoteAttributeEL` in JspC. (kkolinko)
- Fix handling of missing messages in `org.apache.el.util.MessageFactory`. (violetagg)

#### Cluster

- Enable an explicit configuration of local member in the static cluster membership. (kfujino)
- Fix potential integer overflow in `DeltaSession`. Reported by coverity scan. (fschumacher)
- In order to avoid that the heartbeat thread and the background thread to run `Channel.heartbeat` simultaneously, if `heartbeatBackgroundEnabled` of `SimpleTcpCluster` set to `true`, ensure that the heartbeat thread does not start. (kfujino)

#### WebSocket

- 55006: The WebSocket client now honors the `java.net.java.net.ProxySelector` configuration (using the HTTP type) when establishing WebSocket connections to servers. Based on a patch by Niki Dokovski. (markt)
- 58624: Correct a potential deadlock if the WebSocket connection is closed when a message write is in progress. (markt)
- 57489: Ensure `onClose()` is called when a WebSocket connection is closed even if the sending of the close message fails. Includes test cases by Barry Coughlan. (markt)

#### Web Applications

- 58631: Correct the continuation character use in the Windows Service How-To page of the documentation web application. (markt)
- Correct the SSL documentation for deprecated attributes to point to the correct, new location for attributes related to individual certificates. (markt)
- Correct some typos in the JNDI resources How-To. (markt)
- Don't create session unnecessarily in the Manager application. (markt)
- Don't create session unnecessarily in the Host Manager application. (markt)
- 58723: Clarify documentation and error messages for the text interface of the manager to make clear that version must be used with path when referencing contexts deployed using parallel deployment. (markt)
- Document `test.threads` option in BUILDING.txt. (kkolinko)

#### Tribes

- Ensure that the static member is registered to the add suspect list even if the static member that is registered to the remove suspect list has disappeared. (kfujino)
- When using a static cluster, add the members that have been cached in the membership service to the map members list in order to ensure that the map member is a static member. (kfujino)
- Add support for the startup notification of local members in the static cluster. (kfujino)
- Ignore the unnecessary member remove operation from different domain. (kfujino)
- Add support for the shutdown notification of local members in the static cluster. (kfujino)

#### jdbc-pool

- Correct evaluation of system property `org.apache.tomcat.jdbc.pool.onlyAttemptCurrentClassLoader`. It was basically ignored before. Reported by coverity scan. (fschumacher)
- Fix potential integer overflow in `ConnectionPool` and `PooledConnection`. Reported by coverity scan. (fschumacher)

#### Other

- Update optional Checkstyle library to 6.14.1. (kkolinko)
- Update the packaged version of the Tomcat Native Library to 1.2.4 to pick up the Windows binaries that are based on OpenSSL 1.0.2e and APR 1.5.1. (markt)
- Update the NSIS Installer used to build the Windows Installers to version 2.50. (markt/kkolinko)
- Update the internal fork of Commons BCEL to r1725718 to align with the refactoring for BCEL 6, the next major BCEL release. (markt)
- Update the internal fork of Commons DBCP 2 to r1725730 (2.1.1 plus additional fixes). (markt)
- Update the internal fork of Commons Pool 2 to r1725738 (2.4.2 plus additional fixes). (markt)
- Update the internal fork of Commons Codec to r1725746 (1.9 plus additional fixes). (markt)

### 2015-11-17 Tomcat 9.0.0.M1 (markt)

#### General

- Make Java 8 the minimum required version to build and run Tomcat 9. (markt)
- Remove support for Comet. (markt)
- Tighten up the default file permissions for the `.tar.gz` distribution so no files or directories are world readable by default. Configure Tomcat to run with a default umask of `0027` which may be overridden by setting `UMASK` in `setenv.sh`. (markt)
- Remove native code (Windows Service Wrapper, APR/native connector) support for Windows Itanium. (markt)

#### Catalina

- The default HTTP cookie parser has been changed to `org.apache.tomcat.util.http.Rfc6265CookieProcessor`. (markt)

#### Coyote

- Remove support for the HTTP BIO and AJP BIO connectors. (markt)
- Refactor HTTP upgrade and AJP implementations to reduce duplication. (markt)
- Add support for HPACK header encoding and decoding, contributed by Stuart Douglas. (remm)
- 57108: Add support for Server Name Indication (SNI). There has been significant changes to the SSL configuration in server.xml to support this. (markt)
- Add SSL engine for JSSE backed by OpenSSL. Includes ALPN support. Based on code contributed by Numa de Montmollin and derived from code developed by Twitter and Netty. (remm)
- RFC 7230 states that clients should ignore reason phrases in HTTP/1.1 response messages. Since the reason phrase is optional, Tomcat no longer sends it. As a result the system property `org.apache.coyote.USE_CUSTOM_STATUS_MSG_IN_HEADER` is no longer used and has been removed. (markt)
- The minimum required Tomcat Native version has been increased to 1.2.2. The 1.2.x branch includes ALPN and SNI support which are required for HTTP/2. (markt)
- Add support for HTTP/2 including server push. (markt)

#### Tribes

- Clarify the handling of Copy message and Copy nodes. (kfujino)

#### Other

- Support the use of the `threads` attribute on Ant's junit task. Note that using this with a value of greater than one will disable Cobertura code coverage. (markt)